#include <windows.h>

#include "fclipboard_FClipOutputStream.h"
#include "fclipboard_FClipInputStream.h"

/*
* Class:     fclipboard_FClipOutputStream
* Method:    setClipboardData
* Signature: ([B)V
*/
JNIEXPORT void JNICALL Java_fclipboard_FClipOutputStream_setClipboardData
(JNIEnv *je, jclass, jbyteArray data)
{
    UINT nFormat = RegisterClipboardFormat("java/serializable-object-stream");

    if (OpenClipboard(NULL) == NULL)
        return;

    int length = je->GetArrayLength(data);
    //ڴ棬ڴż
    HANDLE hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, length + sizeof(int));

    //ڴ沢
    void *pData = GlobalLock(hData);
    //ݳ
    *(int *) pData = length;
    //
    je->GetByteArrayRegion(data, 0, length, (jbyte *) pData + sizeof(int));
    //ͷڴ
    GlobalUnlock(hData);
    //ԭм
    EmptyClipboard();
    //ָڴ
    SetClipboardData(nFormat, hData);

    CloseClipboard();
}

/* Inaccessible static: skipBuffer */
/*
* Class:     fclipboard_FClipInputStream
* Method:    getClipboardData
* Signature: ()[B
*/
JNIEXPORT jbyteArray JNICALL Java_fclipboard_FClipInputStream_getClipboardData
(JNIEnv *je, jclass)
{
    UINT nFormat = RegisterClipboardFormat("java/serializable-object-stream");

    HANDLE hData;

    //򿪼ʧܡ
    if (OpenClipboard(NULL) == NULL)
        return NULL;

    //ݲJava
    hData = GetClipboardData(nFormat);
    if (!(hData))
    {
        CloseClipboard();
        return NULL;
    }

    //ȡ
    jbyte *data = (jbyte *) GlobalLock(hData);
    //Javaݵ
    jbyteArray Array = je->NewByteArray(*((int *) data));
    //ݴ
    je->SetByteArrayRegion(Array, 0, *((int *) data), (jbyte *) data + 4);
    //ͷϵͳ
    GlobalUnlock(hData);

    CloseClipboard();

    return Array;
}
