package components.animation;

import fsdi.*;
import fclipboard.*;
import datatype.*;
import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>༭壬
 * ṩ֡鿴ͱ༭֡ʾʱĹܣ
 * ܴ֡༭༭֡</p>*/

public class AnimationPanel
    extends JInternalFrame
    implements FView, InternalFrameListener, Editor
{
    private MainFrame frame;
    private SlidePanel animation;
    private AnimationDoc doc;
    private JButton apply;
    private JTextField rate;

    public void onCut()
    {
        onCopy();
        onClear();
    }

    public void onCopy()
    {
        int index;
        if ((index = animation.getCurrentIndex()) == -1)
            return;

        FrameData fd = new FrameData();
        fd.Icon = doc.getData().getCursor(index);
        fd.Rate = doc.getData().getRate(index);

        try
        {
            FClipboard.setClipboardData(fd);
        }
        catch (IOException e)
        {}
    }

    public void onPaste()
    {
        int index;
        if ((index = animation.getCurrentIndex()) == -1)
            index = doc.getData().getFrameCount();

        FrameData fd;
        try
        {
            fd = (FrameData) FClipboard.getClipboardData();
            animation.insertBeforeCurrentFrame(fd.Icon, fd.Rate);
        }
        catch (IOException e)
        {}
        catch (ClassNotFoundException e)
        {}
    }

    public void onClear()
    {
        animation.deleteCurrentFrame();
    }

    public void onSelAll()
    {}

    public void internalFrameActivated(InternalFrameEvent e)
    {
        frame.onUpdate();
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {}

    public void internalFrameClosing(InternalFrameEvent e)
    {
        setVisible(false);
        frame.onUpdate();
    }

    public void internalFrameDeactivated(InternalFrameEvent e)
    {}

    public void internalFrameDeiconified(InternalFrameEvent e)
    {}

    public void internalFrameIconified(InternalFrameEvent e)
    {}

    public void internalFrameOpened(InternalFrameEvent e)
    {
        frame.onUpdate();
    }

    public void attachFrame(FFrame Frame)
    {
        frame = (MainFrame) Frame;

        setFrameIcon(skeleton.Resource.IconChildFrame);

        frame.addInternalFrame(this);
        setVisible(true);
        pack();

        doc = (AnimationDoc) (frame.getDocument());
    }

    public void updateView()
    {
        updateRate();
        if (doc.getModifyData() == null)
            animation.attachAni(doc);
        else
            animation.updateImage(doc.getModifyData());
    }

    public void updateRate()
    {
        if (animation == null)
            return;

        int index = animation.getCurrentIndex();
        boolean state = (index != -1);

        rate.setEnabled(state);
        apply.setEnabled(state);

        if (state && index < doc.getData().getFrameCount())
            rate.setText(String.valueOf(doc.getData().getRate(index)));
    }

    public void changeRate()
    {
        int index, Rate;

        try
        {
            Rate = Integer.parseInt(rate.getText());
            index = animation.getCurrentIndex();
            if (index == -1)
                return;

            if (Rate == doc.getData().getRate(index))
                return;
        }
        catch (Exception e)
        {
            return;
        }

        ModifyData data = new ModifyData();
        data.Level = 1;
        data.Operation = 0;
        data.index = index;
        data.Data = new Integer(Rate);
        doc.modify(data);
    }

    public AnimationPanel()
    {
        super(skeleton.Resource.TitleAnimation, false, true, false, true);
        setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(this);

        animation = new SlidePanel(this);

        JScrollPane Scroll =
            new JScrollPane(
                animation,
                JScrollPane.VERTICAL_SCROLLBAR_NEVER,
                JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        Scroll.setPreferredSize(
            new Dimension(
                skeleton.Resource.AnimationPanelWidth,
                skeleton.Resource.AnimationPanelHeight));

        JPanel panel = new JPanel();
        panel.setLayout(new FlowLayout());
        panel.add(new JLabel(skeleton.Resource.AnimationPanelRate));
        panel.add(rate = new JTextField(5));
        rate.addKeyListener(new KeyAdapter()
        {
            public void keyPressed(KeyEvent e)
            {
                if (e.getKeyCode() == KeyEvent.VK_ENTER)
                    changeRate();
            }
        });

        panel.add(new JLabel(skeleton.Resource.AnimationPanelUnit));

        panel.add(apply = new JButton(skeleton.Resource.AnimationPanelApply));
        apply.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                changeRate();
            }
        });

        getContentPane().add(Scroll, "North");
        getContentPane().add(panel, "South");
    }

    public MainFrame getMainFrame()
    {
        return frame;
    }

    public SlidePanel getSlidePanel()
    {
        return animation;
    }
}
