package components.animation;
import msicon.*;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class IconButton extends JToggleButton
{
    MSIcon msi;
    BufferedImage bImage;
    Graphics bg;
    int bestFitIndex;

    /**һհ׵İť*/
    public IconButton()
    {
        this(null);
    }

    /**ʹͼһͼİť*/
    public IconButton(MSIcon icon)
    {
        msi = icon;
        updateIcon();
    }

    private void updateIconAt(int x, int y, boolean Repaint)
    {
        if ((x / 4 + y / 4) % 2 == 0)
        {
            if (msi != null)
                bg.setColor(
                    msi.get(bestFitIndex).mixColorAt(x, y, Color.lightGray));
            else
                bg.setColor(Color.lightGray);
        }
        else
        {
            if (msi != null)
                bg.setColor(
                    msi.get(bestFitIndex).mixColorAt(x, y, Color.white));
            else
                bg.setColor(Color.white);
        }

        bg.drawLine(x, y, x, y);

        if (Repaint)
            repaint();
    }

    public void updateIcon()
    {
        int i = 0;
        int mostColors = 0;
        int width = 0, height = 0;

        if (msi != null)
        {
            for (int k = 0; k < msi.getIconCount(); k++)
            {
                if (msi.get(k).getPaletteSize() > mostColors)
                {
                    mostColors = msi.get(k).getPaletteSize();
                    i = k;
                }
            }

            bestFitIndex = i;
            int Range =
                (int) ((msi.get(i).getWidth() - 32)
                    * (msi.get(i).getWidth() - 32)
                    + (msi.get(i).getHeight() - 32)
                        * (msi.get(i).getHeight() - 32));

            for (int k = 1; k < msi.getIconCount(); k++)
            {
                if (msi.get(k).getPaletteSize() < mostColors)
                    continue;
                int nRange =
                    (int) ((msi.get(k).getWidth() - 32)
                        * (msi.get(k).getWidth() - 32)
                        + (msi.get(k).getHeight() - 32)
                            * (msi.get(k).getHeight() - 32));
                if (nRange < Range)
                {
                    Range = nRange;
                    bestFitIndex = k;
                }
            }

            width = msi.get(bestFitIndex).getWidth();
            height = msi.get(bestFitIndex).getHeight();
        }
        else
        {
            width = 32;
            height = 32;
        }

        bImage = new BufferedImage(width, height, BufferedImage.TYPE_3BYTE_BGR);
        bg = bImage.createGraphics();

        for (int y = 0; y < height; y++)
            for (int x = 0; x < width; x++)
                updateIconAt(x, y, false);

        repaint();
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(34, 34);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(34, 34);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(34, 34);
    }

    public void paint(Graphics g)
    {
        if (msi == null)
        {
            if (isSelected())
                g.setColor(Color.BLUE);
            else
                g.setColor(Color.lightGray);
        }
        else
        {
            if (isSelected())
                g.setColor(Color.RED);
            else
                g.setColor(Color.BLACK);
        }

        g.drawRect(0, 0, 33, 33);
        g.drawImage(bImage, 1, 1, 32, 32, this);
    }
}
