package components.animation;

import fmenu.*;
import msicon.*;
import fsdi.*;

import datatype.*;
import skeleton.*;
import components.editor.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.filechooser.FileFilter;
import java.util.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>갴֡༭塣</p>*/
public class SlidePanel extends JPanel
{
    private ButtonGroup bgGroup;
    private ArrayList Button;
    private ArrayList Panel;
    private AnimationDoc doc;
    private AnimationPanel parent;
    private JPopupMenu jpmMenu;

    private FMenuItem fmiModify;
    private FMenuItem fmiCut;
    private FMenuItem fmiCopy;
    private FMenuItem fmiPaste;
    private FMenuItem fmiInsert;
    private FMenuItem fmiDelete;
    private FMenuItem fmiImport;
    private FMenuItem fmiExport;

    private String openPath;
    private FileFilter openFilter;

    private SunFileFilter sfIco =
        new SunFileFilter("ico", skeleton.Resource.DescriptionIconFile);
    private SunFileFilter sfCur =
        new SunFileFilter("cur", skeleton.Resource.DescriptionCursorFile);

    public void confirmAll()
    {
        for (int i = 0; i < Panel.size(); i++)
        {
            if (Panel.get(i) != null)
                 ((EditorPanel) Panel.get(i)).confirmPaste();
        }
    }

    /**֪ͨһ༭屻رա*/
    public void disposeEditor(EditorPanel editor)
    {
        Panel.set(Panel.indexOf(editor), null);
    }

    /**ȡһӦͼš*/
    public int getEditorIndex(EditorPanel editor)
    {
        return Panel.indexOf(editor);
    }

    /**һµı༭塣*/
    public void openEditor(int index)
    {
        if (Panel.get(index) == null)
        {
            EditorPanel ep = new EditorPanel(parent.getMainFrame(), index);
            Panel.set(index, ep);
            ep.show();
        }
        else
        {
            parent.getMainFrame().activeInternalFrame(
                (EditorPanel) (Panel.get(index)));
        }
    }

    /**һ塣*/
    protected SlidePanel(AnimationPanel Parent)
    {
        super();
        parent = Parent;

        setLayout(new FlowLayout(FlowLayout.LEFT));

        if (parent != null && parent.getMainFrame() != null)
            doc = (AnimationDoc) (parent.getMainFrame().getDocument());
        else
            doc = null;

        jpmMenu = new JPopupMenu();

        fmiModify = new FMenuItem(skeleton.Resource.MenuEditModify);
        fmiModify.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                openEditor(getCurrentIndex());
            }
        });

        fmiCut = new FMenuItem(skeleton.Resource.MenuEditCut);
        fmiCut.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                parent.onCut();
            }
        });

        fmiCopy = new FMenuItem(skeleton.Resource.MenuEditCopy);
        fmiCopy.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                parent.onCopy();
            }
        });

        fmiPaste = new FMenuItem(skeleton.Resource.MenuEditPaste);
        fmiPaste.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                parent.onPaste();
            }
        });

        fmiInsert = new FMenuItem(skeleton.Resource.PopupMenuInsertFrame);
        fmiInsert.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                insertBeforeCurrentFrame();
            }
        });

        fmiDelete = new FMenuItem(skeleton.Resource.PopupMenuDeleteFrame);
        fmiDelete.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                deleteCurrentFrame();
            }
        });

        fmiImport = new FMenuItem(skeleton.Resource.PopupMenuImportFrame);
        fmiImport.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                importFrameFromFile();
            }
        });

        fmiExport = new FMenuItem(skeleton.Resource.PopupMenuExportFrame);
        fmiExport.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                exportFrameToFile();
            }
        });

        fmiModify.setIcon(skeleton.Resource.IconEditor);
        jpmMenu.add(fmiModify);

        jpmMenu.addSeparator();

        fmiCut.setIcon(skeleton.Resource.IconToolBarCut);
        jpmMenu.add(fmiCut);

        fmiCopy.setIcon(skeleton.Resource.IconToolBarCopy);
        jpmMenu.add(fmiCopy);

        fmiPaste.setIcon(skeleton.Resource.IconToolBarPaste);
        jpmMenu.add(fmiPaste);

        jpmMenu.addSeparator();

        fmiInsert.setIcon(skeleton.Resource.IconToolBarInsertFrame);
        jpmMenu.add(fmiInsert);

        fmiDelete.setIcon(skeleton.Resource.IconToolBarDeleteFrame);
        jpmMenu.add(fmiDelete);

        jpmMenu.addSeparator();

        fmiImport.setIcon(skeleton.Resource.IconNull);
        jpmMenu.add(fmiImport);
        fmiExport.setIcon(skeleton.Resource.IconNull);
        jpmMenu.add(fmiExport);

        attachAni(doc);
    }

    protected AnimationPanel getAnimationPanel()
    {
        return parent;
    }

    /**֡*/
    protected void clear()
    {
        removeAll();
        bgGroup = new ButtonGroup();
        Button = new ArrayList();

        if (Panel != null)
        {
            for (int i = 0; i < Panel.size(); i++)
            {
                if (Panel.get(i) != null)
                     ((EditorPanel) (Panel.get(i))).dispose();
            }
        }

        disposeAllEditor();
        Panel = new ArrayList();
        System.gc();
    }

    private void disposeAllEditor()
    {
        if (Panel != null)
        {
            for (int i = 0; i < Panel.size(); i++)
            {
                if (Panel.get(i) != null)
                {
                    ((EditorPanel) (Panel.get(i))).dispose();
                    disposeEditor((EditorPanel) (Panel.get(i)));
                }
            }
        }
    }

    /**¼һꡣ*/
    protected void attachAni(AnimationDoc Doc)
    {
        disposeAllEditor();
        removeAll();

        bgGroup = new ButtonGroup();
        Button = new ArrayList();
        Panel = new ArrayList();

        MSAni msani = null;

        if (Doc != null)
        {
            doc = Doc;
            msani = doc.getData();
        }
        else
            msani = null;

        if (msani != null)
        {
            for (int i = 0; i < doc.getData().getFrameCount(); i++)
                insertFrame(Button.size(), Doc.getData().getCursor(i));
        }

        IconButton ib = new IconButton();
        IconButtonListener listener = new IconButtonListener(ib, this);
        add(ib);
        bgGroup.add(ib);

        if (Button.size() > 0)
             ((IconButton) (Button.get(0))).setSelected(true);

        updateUI();

        if (parent != null)
            parent.updateRate();
    }

    /**ڵ<code>index</code>һ֡ꡣ*/
    private MSIcon insertFrame(int index, MSIcon msi)
    {
        try
        {
            IconButton ib = new IconButton(msi);
            IconButtonListener listener = new IconButtonListener(ib, this);
            bgGroup.add(ib);
            add(ib, index);
            Button.add(index, ib);
            Panel.add(index, null);
            return msi;
        }
        catch (Exception e)
        {
            return null;
        }
    }

    /**ɾ<code>index-1</code>֡ꡣ*/
    private void deleteFrame(int index)
    {
        IconButton ib = (IconButton) (Button.get(index));
        bgGroup.remove(ib);
        remove(ib);
        Button.remove(index);
        this.updateUI();

        if (Button.size() > index)
             ((IconButton) (Button.get(index))).setSelected(true);
        else
        {
            if (index > 0)
                 ((IconButton) (Button.get(index - 1))).setSelected(true);
        }

        if (Panel.get(index) != null)
        {
            ((EditorPanel) (Panel.get(index))).dispose();
            disposeEditor((EditorPanel) (Panel.get(index)));
        }
    }

    /**ϵͳ÷֪ͨÿؼͼ񱻸ı䡣*/
    protected void updateImage(ModifyData data)
    {
        switch (data.Level)
        {
            case 1 :
                switch (data.Operation)
                {
                    case 0 :
                        ((JToggleButton) (Button.get(data.index))).setSelected(
                            true);
                        break;
                    case 1 :
                        insertFrame(data.index, ((FrameData) (data.Data)).Icon);
                        ((JToggleButton) (Button.get(data.index))).setSelected(
                            true);
                        break;
                    case 2 :
                        deleteFrame(data.index);

                        if (data.index < doc.getData().getFrameCount())
                            (
                                (JToggleButton)
                                    (Button.get(data.index))).setSelected(
                                true);
                        else
                        {
                            if (doc.getData().getFrameCount() == 0)
                                return;
                            else
                                (
                                    (JToggleButton)
                                        (
                                            Button.get(
                                                doc.getData().getFrameCount()
                                                    - 1))).setSelected(
                                    true);
                        }
                        break;
                }
                break;
            case 2 :
                if (Panel.get(data.index) == null)
                    openEditor(data.index);
                else
                     ((EditorPanel) (Panel.get(data.index))).updateImage();
                ((IconButton) (Button.get(data.index))).updateIcon();
                break;
            case 3 :
                switch (data.Operation)
                {
                    case 0 :
                        if (Panel.get(data.index) == null)
                            openEditor(data.index);
                        break;
                    case 1 :
                        if (Panel.get(data.index) == null)
                            openEditor(data.index);
                        else
                            ((EditorPanel) (Panel.get(data.index)))
                                .updateImage();
                        ((IconButton) (Button.get(data.index))).updateIcon();

                        break;
                    case 2 :
                        break;
                }
                break;
        }

        updateUI();
        parent.updateRate();
    }

    /**֪ͨĵÿؼͼıͼ*/
    protected void sendModifyData(ModifyData data)
    {
        doc.modify(data);
    }

    /**ذťбеţһťΪ0*/
    protected int getButtonIndex(IconButton button)
    {
        return Button.indexOf(button);
    }

    /**ذť*/
    protected int getButtonCount()
    {
        return Button.size();
    }

    /**ص<code>index-1</code>ť*/
    protected IconButton getButtonAt(int index)
    {
        return (IconButton) (Button.get(index));
    }

    /**صǰİťš*/
    public int getCurrentIndex()
    {
        for (int i = 0; i < getButtonCount(); i++)
        {
            if (getButtonAt(i).isSelected())
                return i;
        }
        return -1;
    }

    /**ڵǰλòһ֡ꡣ*/
    public int insertBeforeCurrentFrame(MSIcon msi, int rate)
    {
        ModifyData data = new ModifyData();
        data.Level = 1;
        data.Operation = 1;
        data.index = getCurrentIndex();

        if (data.index == -1)
            data.index = Button.size();

        FrameData fd = new FrameData();
        fd.Icon = msi;
        fd.Rate = rate;
        data.Data = fd;
        sendModifyData(data);

        return data.index;
    }

    /**ڵǰ֡ǰ֡*/
    public void insertBeforeCurrentFrame()
    {
        int i;
        if ((i = getCurrentIndex()) == -1)
            i = doc.getData().getFrameCount();

        ImageFormation f =
            new ImageFormat(parent.getMainFrame()).showDialog(null);

        if (f == null)
            return;

        MSIcon msi = new MSIcon();

        Color[] palette = null;
        switch (f.colors)
        {
            case 2 :
                palette = MSIconData.DefaultPalette2;
                break;
            case 16 :
                palette = MSIconData.DefaultPalette16;
                break;
            case 256 :
                palette = MSIconData.DefaultPalette256;
                break;
            case 16777216 :
                palette = null;
                break;
        }

        msi.add(new Dimension(f.width, f.height), palette, new Point(0, 0));
        openEditor(insertBeforeCurrentFrame(msi, 2));
    }

    /**ɾǰ֡*/
    public int deleteCurrentFrame()
    {
        int i;
        if ((i = getCurrentIndex()) != -1)
        {
            ModifyData data = new ModifyData();
            data.Level = 1;
            data.Operation = 2;
            data.index = i;
            data.Data = null;
            sendModifyData(data);
        }

        return i;
    }

    /**Ҽ˵*/
    protected void showPopupMenu(Component invoker, int x, int y)
    {
        SwingUtilities.updateComponentTreeUI(jpmMenu);
        boolean state = (getCurrentIndex() != -1);

        fmiModify.setEnabled(state);
        fmiCut.setEnabled(state);
        fmiCopy.setEnabled(state);
        fmiPaste.setEnabled(true);
        fmiDelete.setEnabled(state);
        fmiExport.setEnabled(state);

        jpmMenu.show(invoker, x, y);
    }

    /**ļװһ֡ꡣ*/
    public void importFrameFromFile()
    {
        JFileChooser jfc = new JFileChooser(openPath);
        jfc.addChoosableFileFilter(sfIco);
        jfc.addChoosableFileFilter(sfCur);
        if (openFilter != null)
        {
            FileFilter[] filters = jfc.getChoosableFileFilters();
            jfc.setFileFilter(jfc.getAcceptAllFileFilter());

            for (int i = 0; i < filters.length; i++)
            {
                if (filters[i] == openFilter)
                {
                    jfc.setFileFilter(openFilter);
                    break;
                }

            }
        }

        if (jfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
        {
            openPath = jfc.getCurrentDirectory().getPath();
            openFilter = jfc.getFileFilter();

            try
            {
                MSIcon msi = new MSIcon(jfc.getSelectedFile().getPath());
                insertBeforeCurrentFrame(msi, 2);
            }
            catch (Exception e)
            {
                JOptionPane.showMessageDialog(
                    this,
                    skeleton.Resource.ErrorImportFrame,
                    parent.getMainFrame().getAppName(),
                    JOptionPane.ERROR_MESSAGE);

            }
        }
    }

    /**һ֡ͼ굽ļ*/
    public void exportFrameToFile()
    {
        boolean result;
        JFileChooser jfc = new JFileChooser(openPath);
        jfc.addChoosableFileFilter(sfIco);
        jfc.addChoosableFileFilter(sfCur);
        if (openFilter != null)
        {
            FileFilter[] filters = jfc.getChoosableFileFilters();
            jfc.setFileFilter(jfc.getAcceptAllFileFilter());

            for (int i = 0; i < filters.length; i++)
            {
                if (filters[i] == openFilter)
                {
                    jfc.setFileFilter(openFilter);
                    break;
                }

            }
        }

        if (jfc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
        {
            openPath = jfc.getCurrentDirectory().getPath();
            openFilter = jfc.getFileFilter();

            String filename = jfc.getSelectedFile().getPath();
            FileFilter sf = jfc.getFileFilter();

            if (FFileFilter.class.isInstance(sf))
                if (filename.lastIndexOf('.') < filename.lastIndexOf('\\'))
                    filename += "." + ((FFileFilter) sf).getDefExtension();

            File file = new File(filename);
            if (file.exists())
            {
                if (JOptionPane
                    .showConfirmDialog(
                        this,
                        fsdi.Resource.OverWritePrompt.replaceAll(
                            "%s",
                            file.getPath().replaceAll("\\\\", "\\\\\\\\")),
                        parent.getMainFrame().getAppName(),
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE)
                    == JOptionPane.NO_OPTION)
                    return;
            }

            MSIcon msi = doc.getData().getCursor(getCurrentIndex());

            if (filename
                .substring(filename.length() - 4)
                .toLowerCase()
                .equals(".ico"))
            {
                Point[] hotspot = new Point[msi.getIconCount()];

                for (int i = 0; i < hotspot.length; i++)
                    hotspot[i] = new Point(msi.get(i).getHotspot());

                msi.setIcon();

                result = msi.flowOut(filename);

                msi.setCursor();
                for (int i = 0; i < hotspot.length; i++)
                    msi.get(i).setHotspot(hotspot[i]);
            }
            else
                result = msi.flowOut(filename);

            if (!result)
                JOptionPane.showMessageDialog(
                    this,
                    skeleton.Resource.ErrorExportFrame,
                    parent.getMainFrame().getAppName(),
                    JOptionPane.ERROR_MESSAGE);

        }
    }
}

class IconButtonListener implements ActionListener, KeyListener, MouseListener
{
    private IconButton Owner;
    private SlidePanel Parent;

    public IconButtonListener(IconButton owner, SlidePanel panel)
    {
        Owner = owner;
        Parent = panel;
        Owner.addActionListener(this);
        Owner.addKeyListener(this);
        Owner.addMouseListener(this);
    }

    public void actionPerformed(ActionEvent e)
    {
        Parent.getAnimationPanel().getMainFrame().onUpdate();
        Parent.getAnimationPanel().updateRate();
    }

    public void mouseClicked(MouseEvent e)
    {
        if (e.getClickCount() == 2)
        {
            if (Parent.getButtonIndex(Owner) != -1)
                Parent.openEditor(Parent.getButtonIndex(Owner));
            else
                Parent.insertBeforeCurrentFrame();
        }
    }

    public void mouseEntered(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {
        if (e.isPopupTrigger())
            Parent.showPopupMenu(Owner, e.getX(), e.getY());
        Parent.getAnimationPanel().changeRate();
    }

    public void mouseReleased(MouseEvent e)
    {
        if (e.isPopupTrigger())
        {
            Owner.setSelected(true);
            Parent.showPopupMenu(Owner, e.getX(), e.getY());
        }
    }

    public void keyPressed(KeyEvent e)
    {
        if (e.getKeyCode() == KeyEvent.VK_DELETE)
        {
            Owner.setSelected(true);
            Parent.deleteCurrentFrame();
        }
    }

    public void keyReleased(KeyEvent e)
    {}

    public void keyTyped(KeyEvent e)
    {}
}
