package components.editor;

import skeleton.*;
import msicon.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>༭ڹ</p>*/
public class EToolBar extends JToolBar
{
    private EditorPanel owner;

    private JButton jbInsertImage;
    private JButton jbDeleteImage;
    private JButton jbMode;
    private JToggleButton jtbGrid;
    private JButton jbHotspot;

    private JComboBox jcbCombo;
    
    // Patch: ɾʱҪ¼
    private boolean self_modifying;

    protected void updateToolBar(int count)
    {
        int oldIndex = jcbCombo.getSelectedIndex();
        int oldCount = jcbCombo.getItemCount();

        synchronized(jcbCombo)
        {
            self_modifying = true;
            jcbCombo.removeAllItems();
            self_modifying = false;
        }

        updateCombo(getSelfIndex());

        if (oldCount != count)
            jcbCombo.setSelectedIndex(count - 1);
        else
            jcbCombo.setSelectedIndex(oldIndex);
    }

    public EToolBar(EditorPanel Owner, int index)
    {
        super();
        owner = Owner;

        jbInsertImage = new JButton(Resource.IconToolBarInsertImage);
        jbInsertImage.setToolTipText(Resource.ToolTipMenuImageInsert);
        jbInsertImage.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.insertImage();
            }
        });

        jbDeleteImage = new JButton(Resource.IconToolBarDeleteImage);
        jbDeleteImage.setToolTipText(Resource.ToolTipMenuImageDelete);
        jbDeleteImage.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.deleteImage();
            }
        });

        jbMode = new JButton(Resource.IconToolBarMode);
        jbMode.setToolTipText(Resource.ToolTipMenuImageMode);
        jbMode.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.mode();
            }
        });

        jbHotspot = new JButton(Resource.IconToolBarHotspot);
        jbHotspot.setToolTipText(Resource.ToolTipMenuImageHotspot);
        jbHotspot.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.hotspot();
            }
        });

        jtbGrid = new JToggleButton(Resource.IconToolBarGrid, true);
        jtbGrid.setToolTipText(Resource.ToolTipMenuViewGrid);
        jtbGrid.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getCanvas().refreshAll();
                owner.getFrame().onUpdate();
            }
        });

        jcbCombo = new JComboBox();
        jcbCombo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                synchronized(jcbCombo)
                {
                    if (self_modifying)
                        return;
                    updateCanvas(jcbCombo.getSelectedIndex());
                    owner.updateScroll();
                }
            }
        });

        add(jbInsertImage);
        add(jbDeleteImage);
        add(jbMode);
        add(jbHotspot);
        add(jtbGrid);

        addSeparator();
        add(jcbCombo);

        updateCombo(index);
    }

    public boolean isGridEnabled()
    {
        return jtbGrid.isSelected();
    }

    public void setGridEnabled(boolean aFlag)
    {
        jtbGrid.setSelected(aFlag);
        owner.getCanvas().refreshAll();
    }

    public void updatePalette()
    {
        int data = jcbCombo.getSelectedIndex();
        int index =
            owner.getFrame().getAnimation().getSlidePanel().getEditorIndex(
                owner);

        if (index == -1)
            index = 0;

        MSIcon msi =
            ((AnimationDoc) (owner.getFrame().getDocument()))
                .getData()
                .getCursor(
                index);

        Color[] palette = null;
        if (msi.get(data).getPaletteSize() != 16777216)
        {
            palette = new Color[msi.get(data).getPaletteSize()];
            for (int i = 0; i < msi.get(data).getPaletteSize(); i++)
                palette[i] = msi.get(data).getPaletteColor(i);
        }

        switch (msi.get(data).getPaletteSize())
        {
            case 2 :
                owner.getFrame().getPalette().setPalette2(palette);
                break;
            case 16 :
                owner.getFrame().getPalette().setPalette16(palette);
                break;
            case 256 :
                owner.getFrame().getPalette().setPalette256(palette);
                break;
            case 16777216 :
                owner.getFrame().getPalette().setPaletteTrueColor();
                break;
        }
    }

    public void updateCanvas(int data)
    {
        int index =
            owner.getFrame().getAnimation().getSlidePanel().getEditorIndex(
                owner);

        if (index == -1)
            return;

        updateCanvas(index, data);
    }

    public void updateCanvas(int icon, int data)
    {
        MSIcon msi =
            ((AnimationDoc) (owner.getFrame().getDocument()))
                .getData()
                .getCursor(
                icon);
        owner.getCanvas().attachIconData(msi.get(data));
        updatePalette();
    }

    public int getSelfIndex()
    {
        return owner.getFrame().getAnimation().getSlidePanel().getEditorIndex(
            owner);
    }

    public int getSelectedImageIndex()
    {
        return jcbCombo.getSelectedIndex();
    }

    public void updateCombo()
    {
        int index =
            owner.getFrame().getAnimation().getSlidePanel().getEditorIndex(
                owner);

        if (index == -1)
            return;

        updateCombo(index);
    }

    public void updateCombo(int index)
    {
        MSIcon msi =
            ((AnimationDoc) (owner.getFrame().getDocument()))
                .getData()
                .getCursor(
                index);

        for (int i = 0; i < msi.getIconCount(); i++)
        {
            String color = null;
            switch (msi.get(i).getPaletteSize())
            {
                case 2 :
                    color = Resource.Palette2Color;
                    break;
                case 16 :
                    color = Resource.Palette16Color;
                    break;
                case 256 :
                    color = Resource.Palette256Color;
                    break;
                case 16777216 :
                    color = Resource.PaletteTrueColor;
            }

            String description =
                msi.get(i).getWidth()
                    + "X"
                    + msi.get(i).getHeight()
                    + ", "
                    + color;

            jcbCombo.addItem(description);
        }

        updateCanvas(index, 0);
    }
}
