package components.editor;

import msicon.*;
import datatype.*;
import fclipboard.*;
import tinyPainter.dialog.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.IOException;

import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼ껭</p>*/
public class EditorCanvas
    extends JPanel
    implements MouseListener, MouseMotionListener
{
    private MSIconData data;
    private BufferedImage cache;
    private BufferedImage working;
    private BufferedImage calculate;
    private Graphics bg;
    private Graphics2D wg;
    private Graphics2D cg;
    private EditorPanel owner;
    private Point start;
    private Point end;
    private static final Color transparent = new Color(0, 0, 0, 0);
    private int button;
    private boolean pasteworking;
    private ImageData pastedata;
    private Rectangle pastesource;
    private boolean hotspot;
    private boolean paintagain = true;
    private boolean transformed;

    protected void rotate(int position)
    {
        if (!pasteworking)
            onSelAll();

        if (position == 0 || position == 1)
        {
            ImageData newData =
                new ImageData(
                    pastedata.getPosition().x,
                    pastedata.getPosition().y,
                    pastedata.getHeight(),
                    pastedata.getWidth());

            for (int y = 0; y < pastedata.getHeight(); y++)
            {
                for (int x = 0; x < pastedata.getWidth(); x++)
                {
                    if (position == 0)
                    {
                        newData.setColorAt(
                            pastedata.getHeight() - y - 1,
                            x,
                            pastedata.getColorAt(x, y));
                        newData.setMaskAt(
                            pastedata.getHeight() - y - 1,
                            x,
                            pastedata.getMaskAt(x, y));
                    }
                    else
                    {
                        newData.setColorAt(
                            y,
                            pastedata.getWidth() - x - 1,
                            pastedata.getColorAt(x, y));
                        newData.setMaskAt(
                            y,
                            pastedata.getWidth() - x - 1,
                            pastedata.getMaskAt(x, y));

                    }
                }
            }

            onClear();
            pasteworking = true;
            pastedata = newData;

            if (pastesource == null)
                pastesource =
                    new Rectangle(
                        pastedata.getPosition().x,
                        pastedata.getPosition().y,
                        pastedata.getWidth(),
                        pastedata.getHeight());
            else
                pastesource =
                    new Rectangle(
                        pastesource.getLocation().x,
                        pastesource.getLocation().y,
                        pastedata.getWidth(),
                        pastedata.getHeight());

            pastedata.setPosition(data.getWidth(), data.getHeight());
        }
        else
        {
            for (int y = 0; y < pastedata.getHeight() / 2; y++)
            {
                for (int x = 0; x < pastedata.getWidth(); x++)
                {
                    Color color1 = pastedata.getColorAt(x, y);
                    boolean mask1 = pastedata.getMaskAt(x, y);
                    Color color2 =
                        pastedata.getColorAt(
                            pastedata.getWidth() - x - 1,
                            pastedata.getHeight() - y - 1);
                    boolean mask2 =
                        pastedata.getMaskAt(
                            pastedata.getWidth() - x - 1,
                            pastedata.getHeight() - y - 1);

                    pastedata.setColorAt(x, y, color2);
                    pastedata.setMaskAt(x, y, mask2);
                    pastedata.setColorAt(
                        pastedata.getWidth() - x - 1,
                        pastedata.getHeight() - y - 1,
                        color1);
                    pastedata.setMaskAt(
                        pastedata.getWidth() - x - 1,
                        pastedata.getHeight() - y - 1,
                        mask1);
                }
            }
        }

        transformed = true;
        end = start = new Point(pastedata.getPosition());
        updateStroke(null);
    }

    protected void flip(int position)
    {
        if (!pasteworking)
            onSelAll();

        for (int y = 0;
            y
                < (position != 0
                    ? pastedata.getHeight() / 2
                    : pastedata.getHeight());
            y++)
        {
            for (int x = 0;
                x
                    < (position != 0
                        ? pastedata.getWidth()
                        : pastedata.getWidth() / 2);
                x++)
            {
                Color color1 = pastedata.getColorAt(x, y);
                boolean mask1 = pastedata.getMaskAt(x, y);
                Color color2 =
                    pastedata.getColorAt(
                        position == 0 ? pastedata.getWidth() - x - 1 : x,
                        position != 0 ? pastedata.getHeight() - y - 1 : y);
                boolean mask2 =
                    pastedata.getMaskAt(
                        position == 0 ? pastedata.getWidth() - x - 1 : x,
                        position != 0 ? pastedata.getHeight() - y - 1 : y);

                pastedata.setColorAt(x, y, color2);
                pastedata.setMaskAt(x, y, mask2);
                pastedata.setColorAt(
                    position == 0 ? pastedata.getWidth() - x - 1 : x,
                    position != 0 ? pastedata.getHeight() - y - 1 : y,
                    color1);
                pastedata.setMaskAt(
                    position == 0 ? pastedata.getWidth() - x - 1 : x,
                    position != 0 ? pastedata.getHeight() - y - 1 : y,
                    mask1);
            }
        }

        transformed = true;
        end = start = new Point(pastedata.getPosition());
        updateStroke(null);
    }

    protected void invert()
    {
        if (!pasteworking)
            onSelAll();

        for (int y = 0; y < pastedata.getHeight(); y++)
        {
            for (int x = 0; x < pastedata.getWidth(); x++)
            {
                Color color = pastedata.getColorAt(x, y);
                pastedata.setColorAt(
                    x,
                    y,
                    new Color(
                        255 - color.getRed(),
                        255 - color.getGreen(),
                        255 - color.getBlue()));
            }
        }

        transformed = true;
        end = start = new Point(pastedata.getPosition());
        updateStroke(null);
    }

    private static final Point[] positions =
        { new Point(-1, 0), new Point(0, -1), new Point(1, 0), new Point(0, 1)};

    protected boolean isPasting()
    {
        return pasteworking;
    }

    private Color getPasteColorAt(int x, int y)
    {
        if (x >= pastedata.getPosition().x
            && x < pastedata.getPosition().x + pastedata.getWidth()
            && y >= pastedata.getPosition().y
            && y < pastedata.getPosition().y + pastedata.getHeight())
        {
            if ((x / 4 + y / 4) % 2 == 0)
                return Color.lightGray;
            else
                return Color.white;
        }
        else
        {
            if ((x / 4 + y / 4) % 2 == 0)
                return data.mixColorAt(x, y, Color.lightGray);
            else
                return data.mixColorAt(x, y, Color.white);
        }
    }

    private boolean getPasteMaskAt(int x, int y)
    {
        if (x >= pastedata.getPosition().x
            && x < pastedata.getPosition().x + pastedata.getWidth()
            && y >= pastedata.getPosition().y
            && y < pastedata.getPosition().y + pastedata.getHeight())
            return true;
        else
            return data.getMaskAt(x, y);
    }

    protected void onCut()
    {
        onCopy();
        onClear();
    }

    protected void onCopy()
    {
        if (!pasteworking)
            onSelAll();

        try
        {
            FClipboard.setClipboardData(pastedata);
        }
        catch (IOException e)
        {}
    }

    public void doPaste(ImageData PasteData)
    {
        confirmPaste();
        pastedata = PasteData;
        owner.getFrame().getToolBox().setButtonIndex(0);
        end = start = new Point(0, 0);
        pasteworking = true;
        pastedata.setPosition(data.getWidth(), data.getHeight());
        pastesource =
            new Rectangle(0, 0, pastedata.getWidth(), pastedata.getHeight());
        updateStroke(null);
    }

    protected void onPaste()
    {
        confirmPaste();

        try
        {
            doPaste((ImageData) (FClipboard.getClipboardData()));
        }
        catch (Exception e)
        {}
    }

    protected void onClear()
    {
        if (!pasteworking)
            onSelAll();

        Rectangle oldSource =
            new Rectangle(
                pastesource.getLocation().x,
                pastesource.getLocation().y,
                (int) pastesource.getWidth(),
                (int) pastesource.getHeight());
        pastesource.setLocation(data.getWidth(), data.getHeight());
        confirmPaste();
        pastesource = oldSource;
    }

    protected void onSelAll()
    {
        owner.getFrame().getToolBox().setButtonIndex(0);
        confirmPaste();
        end = start = new Point(0, 0);
        pasteworking = true;
        pastedata =
            new ImageData(0, 0, data.getWidth(), data.getHeight(), data);
        pastesource = new Rectangle(0, 0, data.getWidth(), data.getHeight());
        updateStroke(null);
    }

    protected void updateStroke(MouseEvent e)
    {
        if (hotspot)
        {
            repaint();
            return;
        }

        if (e != null)
        {
            end =
                new Point(
                    e.getX() / skeleton.Resource.EditPanelPixelSize,
                    e.getY() / skeleton.Resource.EditPanelPixelSize);

            if (e.isShiftDown())
            {
                int index = owner.getFrame().getToolBox().getButtonIndex();

                switch (index)
                {
                    case 5 :
                        int width = Math.abs(end.x - start.x);
                        int height = Math.abs(end.y - start.y);

                        if (width > height * 2)
                            height = 0;
                        else if (height > width * 2)
                            width = 0;
                        else
                            width =
                                height =
                                    (int) (Math.min(width, height)
                                        + (Math.max(width, height)
                                            - Math.min(width, height))
                                            / Math.sqrt(2));

                        if (start.x != end.x)
                            end.x =
                                start.x
                                    - (start.x - end.x)
                                        / Math.abs(start.x - end.x)
                                        * width;
                        if (start.y != end.y)
                            end.y =
                                start.y
                                    - (start.y - end.y)
                                        / Math.abs(start.y - end.y)
                                        * height;
                        break;
                    case 0 :
                    case 6 :
                    case 7 :
                    case 8 :
                    case 9 :
                    case 10 :
                    case 11 :
                    case 12 :
                    case 13 :
                    case 14 :
                        width = Math.abs(end.x - start.x);
                        height = Math.abs(end.y - start.y);

                        width = height = Math.min(width, height);

                        if (width == 0)
                            return;

                        end.x =
                            start.x
                                - (start.x - end.x)
                                    / Math.abs(start.x - end.x)
                                    * width;
                        end.y =
                            start.y
                                - (start.y - end.y)
                                    / Math.abs(start.y - end.y)
                                    * height;

                        break;
                }
            }
        }

        int index = owner.getFrame().getToolBox().getButtonIndex();
        Color Color1 =
            button == MouseEvent.BUTTON1 ? Color.WHITE : Color.lightGray;
        Color Color2 =
            button != MouseEvent.BUTTON1 ? Color.WHITE : Color.lightGray;
        cg.setColor(Color1);

        switch (index)
        {
            case 0 :
            case 4 :
                if (pasteworking)
                {
                    wg.clearRect(
                        0,
                        0,
                        data.getWidth() * skeleton.Resource.EditPanelPixelSize,
                        data.getHeight()
                            * skeleton.Resource.EditPanelPixelSize);
                    for (int y = 0; y < pastedata.getHeight(); y++)
                    {
                        for (int x = 0; x < pastedata.getWidth(); x++)
                        {
                            if (((x + pastedata.getPosition().x) / 4
                                + (y + pastedata.getPosition().y) / 4)
                                % 2
                                == 0)
                                wg.setColor(Color2);
                            else
                                wg.setColor(Color1);

                            wg.fillRect(
                                (x + pastedata.getPosition().x)
                                    * skeleton.Resource.EditPanelPixelSize,
                                (y + pastedata.getPosition().y)
                                    * skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize);
                        }
                    }

                    for (int y = 0; y < pastedata.getHeight(); y++)
                    {
                        if (y + pastesource.y - start.y + end.y < 0)
                            continue;

                        if (y + pastesource.y - start.y + end.y
                            >= data.getHeight())
                            break;

                        for (int x = 0; x < pastedata.getWidth(); x++)
                        {
                            if (x + pastesource.x - start.x + end.x < 0)
                                continue;

                            if (x + pastesource.x - start.x + end.x
                                >= data.getWidth())
                                break;

                            wg.setColor(
                                pastedata.mixColorAt(
                                    x,
                                    y,
                                    getPasteColorAt(
                                        x + pastesource.x - start.x + end.x,
                                        y + pastesource.y - start.y + end.y)));

                            wg.fillRect(
                                (x + pastesource.x - start.x + end.x)
                                    * skeleton.Resource.EditPanelPixelSize,
                                (y + pastesource.y - start.y + end.y)
                                    * skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize);

                            if (!(pastedata.getMaskAt(x, y)
                                && getPasteMaskAt(
                                    x + pastesource.x - start.x + end.x,
                                    y + pastesource.y - start.y + end.y))
                                && owner.isGridEnabled())
                            {
                                wg.setColor(Color.BLACK);
                                wg.drawRect(
                                    (x + pastesource.x - start.x + end.x)
                                        * skeleton.Resource.EditPanelPixelSize,
                                    (y + pastesource.y - start.y + end.y)
                                        * skeleton.Resource.EditPanelPixelSize,
                                    skeleton.Resource.EditPanelPixelSize - 1,
                                    skeleton.Resource.EditPanelPixelSize - 1);
                            }
                        }
                    }

                    pastesource.x += end.x - start.x;
                    pastesource.y += end.y - start.y;
                    start = new Point(end);

                    wg.setColor(Color.BLACK);
                    wg.drawRect(
                        pastesource.x * skeleton.Resource.EditPanelPixelSize,
                        pastesource.y * skeleton.Resource.EditPanelPixelSize,
                        pastesource.width
                            * skeleton.Resource.EditPanelPixelSize
                            - 1,
                        pastesource.height
                            * skeleton.Resource.EditPanelPixelSize
                            - 1);
                    wg.setColor(Color.WHITE);
                    wg.drawRect(
                        pastesource.x * skeleton.Resource.EditPanelPixelSize
                            + 1,
                        pastesource.y * skeleton.Resource.EditPanelPixelSize
                            + 1,
                        pastesource.width
                            * skeleton.Resource.EditPanelPixelSize
                            - 3,
                        pastesource.height
                            * skeleton.Resource.EditPanelPixelSize
                            - 3);
                }
                else
                {
                    int x1 = Math.min(start.x, end.x);
                    int y1 = Math.min(start.y, end.y);
                    int x2 = Math.max(start.x, end.x);
                    int y2 = Math.max(start.y, end.y);
                    wg.clearRect(
                        0,
                        0,
                        data.getWidth() * skeleton.Resource.EditPanelPixelSize,
                        data.getHeight()
                            * skeleton.Resource.EditPanelPixelSize);
                    int sx, sy, ex, ey;
                    sx = (x1 < 0) ? 0 : x1;
                    sy = (y1 < 0) ? 0 : y1;
                    ex = (x2 > data.getWidth() - 1) ? data.getWidth() - 1 : x2;
                    ey =
                        (y2 > data.getHeight() - 1) ? data.getHeight() - 1 : y2;
                    if (sx > ex || sy > ey)
                        return;
                    wg.setColor(Color.BLACK);
                    wg.drawRect(
                        sx * skeleton.Resource.EditPanelPixelSize,
                        sy * skeleton.Resource.EditPanelPixelSize,
                        (ex - sx + 1) * skeleton.Resource.EditPanelPixelSize
                            - 1,
                        (ey - sy + 1) * skeleton.Resource.EditPanelPixelSize
                            - 1);
                    wg.setColor(Color.WHITE);
                    wg.drawRect(
                        sx * skeleton.Resource.EditPanelPixelSize + 1,
                        sy * skeleton.Resource.EditPanelPixelSize + 1,
                        (ex - sx + 1) * skeleton.Resource.EditPanelPixelSize
                            - 3,
                        (ey - sy + 1) * skeleton.Resource.EditPanelPixelSize
                            - 3);
                }
                break;
            case 1 :
                int lineWidth = owner.getFrame().getToolBox().getLineWidth();
                cg.drawLine(start.x, start.y, end.x, end.y);
                int x1 = Math.min(start.x, end.x);
                int y1 = Math.min(start.y, end.y);
                int x2 = Math.max(start.x, end.x);
                int y2 = Math.max(start.y, end.y);
                start = new Point(end);

                drawWorking(
                    x1 - lineWidth,
                    y1 - lineWidth,
                    x2 + lineWidth,
                    y2 + lineWidth);

                break;
            case 2 :
                if (button == MouseEvent.BUTTON1)
                {
                    owner.getFrame().getPalette().setLeftButtonColor(
                        data.getColorAt(end));
                    owner.getFrame().getPalette().setLeftButtonTransparent(
                        data.getMaskAt(end));
                }
                else if (button == MouseEvent.BUTTON3)
                {
                    owner.getFrame().getPalette().setRightButtonColor(
                        data.getColorAt(end));
                    owner.getFrame().getPalette().setRightButtonTransparent(
                        data.getMaskAt(end));
                }
                break;
            case 3 :
                break;
            default :
                wg.clearRect(
                    0,
                    0,
                    skeleton.Resource.EditPanelPixelSize * data.getWidth(),
                    skeleton.Resource.EditPanelPixelSize * data.getHeight());

                cg.clearRect(
                    0,
                    0,
                    skeleton.Resource.EditPanelPixelSize * data.getWidth(),
                    skeleton.Resource.EditPanelPixelSize * data.getHeight());

                Shape shape = null;

                x1 = Math.min(start.x, end.x);
                y1 = Math.min(start.y, end.y);
                x2 = Math.max(start.x, end.x);
                y2 = Math.max(start.y, end.y);
                lineWidth = owner.getFrame().getToolBox().getLineWidth();

                if (index == 8 || index == 11 || index == 14)
                    lineWidth = 1;

                switch (index)
                {
                    case 5 :
                        shape = new Line2D.Float(start, end);
                        break;
                    case 6 :
                    case 7 :
                    case 8 :
                        shape =
                            new Rectangle2D.Float(
                                x1 + lineWidth / 2,
                                y1 + lineWidth / 2,
                                x2 - x1 - lineWidth + 1,
                                y2 - y1 - lineWidth + 1);
                        break;
                    case 9 :
                    case 10 :
                    case 11 :
                        shape =
                            new RoundRectangle2D.Float(
                                x1 + lineWidth / 2,
                                y1 + lineWidth / 2,
                                x2 - x1 - lineWidth + 1,
                                y2 - y1 - lineWidth + 1,
                                8,
                                8);
                        break;
                    case 12 :
                    case 13 :
                    case 14 :
                        shape =
                            new Ellipse2D.Float(
                                x1 + lineWidth / 2,
                                y1 + lineWidth / 2,
                                x2 - x1 - lineWidth + 1,
                                y2 - y1 - lineWidth + 1);
                        break;
                }

                cg.setColor(Color1);

                switch (index)
                {
                    case 5 :
                    case 6 :
                    case 9 :
                    case 12 :
                        cg.draw(shape);
                        break;
                    case 7 :
                    case 10 :
                    case 13 :
                        cg.setColor(Color2);
                        cg.fill(shape);
                        cg.setColor(Color1);
                        cg.draw(shape);
                        break;
                    case 8 :
                    case 11 :
                    case 14 :
                        cg.setColor(Color1);
                        cg.draw(shape);
                        cg.fill(shape);
                }

                int sx = (x1 - lineWidth < 0) ? 0 : x1 - lineWidth;
                int sy = (y1 - lineWidth < 0) ? 0 : y1 - lineWidth;
                int ex =
                    (x2 + lineWidth > data.getWidth() - 1)
                        ? data.getWidth() - 1
                        : x2 + lineWidth;
                int ey =
                    (y2 + lineWidth > data.getHeight() - 1)
                        ? data.getHeight() - 1
                        : y2 + lineWidth;
                if (sx > ex || sy > ey)
                    return;
                drawWorking(sx, sy, ex, ey);
        }
    }

    protected void setHotspot()
    {
        hotspot = true;
        updateStroke(null);
    }

    private void drawWorking(int sx, int sy, int width, int height)
    {
        for (int y = sy; y <= sy + height; y++)
        {
            for (int x = sx; x <= sx + width; x++)
            {
                if (x >= 0
                    && x < data.getWidth()
                    && y >= 0
                    && y < data.getHeight())
                {
                    if (calculate.getRGB(x, y) == Color.WHITE.getRGB())
                    {
                        if (owner
                            .getFrame()
                            .getPalette()
                            .isLeftButtonTransparent())
                        {
                            if ((x / 4 + y / 4) % 2 == 0)
                                wg.setColor(
                                    new Color(
                                        Color.lightGray.getRGB()
                                            ^ owner
                                                .getFrame()
                                                .getPalette()
                                                .getLeftButtonColor()
                                                .getRGB()));
                            else
                                wg.setColor(
                                    new Color(
                                        Color.WHITE.getRGB()
                                            ^ owner
                                                .getFrame()
                                                .getPalette()
                                                .getLeftButtonColor()
                                                .getRGB()));

                            wg.fillRect(
                                (x * skeleton.Resource.EditPanelPixelSize),
                                (y * skeleton.Resource.EditPanelPixelSize),
                                skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize);
                        }
                        else
                        {
                            wg.setColor(Color.BLACK);
                            if (calculate.getRGB(x, y) != Color.BLACK.getRGB()
                                && (owner.getToolBar() == null
                                    || (owner.getToolBar() != null
                                        && owner.getToolBar().isGridEnabled())))
                            {
                                wg.setColor(Color.BLACK);
                                wg.drawRect(
                                    x * skeleton.Resource.EditPanelPixelSize,
                                    y * skeleton.Resource.EditPanelPixelSize,
                                    skeleton.Resource.EditPanelPixelSize - 1,
                                    skeleton.Resource.EditPanelPixelSize - 1);
                                wg.setColor(
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getLeftButtonColor());

                                wg.fillRect(
                                    (x * skeleton.Resource.EditPanelPixelSize
                                        + 1),
                                    (y * skeleton.Resource.EditPanelPixelSize
                                        + 1),
                                    skeleton.Resource.EditPanelPixelSize - 2,
                                    skeleton.Resource.EditPanelPixelSize - 2);
                            }
                            else
                            {
                                wg.setColor(
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getLeftButtonColor());

                                wg.fillRect(
                                    (x * skeleton.Resource.EditPanelPixelSize),
                                    (y * skeleton.Resource.EditPanelPixelSize),
                                    skeleton.Resource.EditPanelPixelSize,
                                    skeleton.Resource.EditPanelPixelSize);
                            }
                        }
                    }
                    else if (
                        calculate.getRGB(x, y) == Color.lightGray.getRGB())
                    {
                        if (owner
                            .getFrame()
                            .getPalette()
                            .isRightButtonTransparent())
                        {
                            if ((x / 4 + y / 4) % 2 == 0)
                                wg.setColor(
                                    new Color(
                                        Color.lightGray.getRGB()
                                            ^ owner
                                                .getFrame()
                                                .getPalette()
                                                .getRightButtonColor()
                                                .getRGB()));
                            else
                                wg.setColor(
                                    new Color(
                                        Color.WHITE.getRGB()
                                            ^ owner
                                                .getFrame()
                                                .getPalette()
                                                .getRightButtonColor()
                                                .getRGB()));
                            wg.fillRect(
                                (x * skeleton.Resource.EditPanelPixelSize),
                                (y * skeleton.Resource.EditPanelPixelSize),
                                skeleton.Resource.EditPanelPixelSize,
                                skeleton.Resource.EditPanelPixelSize);
                        }
                        else
                        {
                            wg.setColor(Color.BLACK);
                            if (calculate.getRGB(x, y) != Color.BLACK.getRGB()
                                && (owner.getToolBar() == null
                                    || (owner.getToolBar() != null
                                        && owner.getToolBar().isGridEnabled())))
                            {
                                wg.setColor(Color.BLACK);
                                wg.drawRect(
                                    x * skeleton.Resource.EditPanelPixelSize,
                                    y * skeleton.Resource.EditPanelPixelSize,
                                    skeleton.Resource.EditPanelPixelSize - 1,
                                    skeleton.Resource.EditPanelPixelSize - 1);
                                wg.setColor(
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getRightButtonColor());
                                wg.fillRect(
                                    (x * skeleton.Resource.EditPanelPixelSize
                                        + 1),
                                    (y * skeleton.Resource.EditPanelPixelSize
                                        + 1),
                                    skeleton.Resource.EditPanelPixelSize - 2,
                                    skeleton.Resource.EditPanelPixelSize - 2);
                            }
                            else
                            {
                                wg.setColor(
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getRightButtonColor());
                                wg.fillRect(
                                    (x * skeleton.Resource.EditPanelPixelSize),
                                    (y * skeleton.Resource.EditPanelPixelSize),
                                    skeleton.Resource.EditPanelPixelSize,
                                    skeleton.Resource.EditPanelPixelSize);
                            }
                        }
                    }
                }
            }
        }
    }

    synchronized public void confirmPaste()
    {
        if (!pasteworking)
            return;

        pasteworking = false;

        if (pastesource.getLocation().equals(pastedata.getPosition())
            && !transformed)
            return;

        int x, y, width, height;

        //ͼεʵС

        //ȡy
        x =
            (int) Math.min(
                pastesource.getLocation().x,
                pastedata.getPosition().getX());
        y =
            (int) Math.min(
                pastesource.getLocation().y,
                pastedata.getPosition().getY());

        width =
            (int) Math.max(
                pastesource.getLocation().x,
                pastedata.getPosition().getX())
                + pastedata.getWidth()
                - x;
        height =
            (int) Math.max(
                pastesource.getLocation().y,
                pastedata.getPosition().getY())
                + pastedata.getHeight()
                - y;

        if (width <= 0 || height <= 0)
            return;

        ImageData idata = new ImageData(x, y, width, height);

        for (int cy = 0; cy < height; cy++)
        {
            for (int cx = 0; cx < width; cx++)
            {
                int rx = cx + x;
                int ry = cy + y;
                idata.setColorAt(cx, cy, data.getColorAt(rx, ry));
                idata.setMaskAt(cx, cy, data.getMaskAt(rx, ry));
            }
        }

        for (int cy = pastedata.getPosition().y;
            cy < pastedata.getPosition().y + pastesource.getHeight();
            cy++)
        {
            for (int cx = pastedata.getPosition().x;
                cx < pastedata.getPosition().x + pastesource.getWidth();
                cx++)
            {
                idata.setColorAt(cx - x, cy - y, null);
                idata.setMaskAt(cx - x, cy - y, true);
            }
        }

        for (int cy = (int) pastesource.getY();
            cy < (int) pastesource.getY() + pastesource.getHeight();
            cy++)
        {
            for (int cx = (int) pastesource.getX();
                cx < (int) pastesource.getX() + pastesource.getWidth();
                cx++)
            {
                if (idata.getColorAt(cx - x, cy - y) == null)
                {
                    Color temp =
                        pastedata.getColorAt(
                            cx - (int) pastesource.getX(),
                            cy - (int) pastesource.getY());
                    idata.setMaskAt(
                        cx - x,
                        cy - y,
                        pastedata.getMaskAt(
                            cx - (int) pastesource.getX(),
                            cy - (int) pastesource.getY()));
                    idata.setColorAt(
                        cx - x,
                        cy - y,
                        new Color(
                            temp.getRed(),
                            temp.getGreen(),
                            temp.getBlue()));
                    continue;
                }

                idata.setColorAt(
                    cx - x,
                    cy - y,
                    pastedata.getColorAt(
                        cx - (int) pastesource.getX(),
                        cy - (int) pastesource.getY()));
                idata.setMaskAt(
                    cx - x,
                    cy - y,
                    pastedata.getMaskAt(
                        cx - (int) pastesource.getX(),
                        cy - (int) pastesource.getY()));

                if (pastedata
                    .getMaskAt(
                        cx - (int) pastesource.getX(),
                        cy - (int) pastesource.getY()))
                {
                    Color temp = idata.getColorAt(cx - x, cy - y);
                    idata.setColorAt(
                        cx - x,
                        cy - y,
                        new Color(
                            temp.getRed(),
                            temp.getGreen(),
                            temp.getBlue(),
                            0));
                }
            }
        }

        for (int cy = 0; cy < height; cy++)
        {
            for (int cx = 0; cx < width; cx++)
            {
                // ??
                int rx = cx + x;
                int ry = cy + y;

                if (idata.getColorAt(rx, ry) == null)
                    idata.setColorAt(rx, ry, Color.BLACK);
            }
        }

        ModifyData modify = new ModifyData();
        modify.Level = 3;
        modify.Operation = 1;
        modify.index = owner.getToolBar().getSelfIndex();
        ImageModify m = new ImageModify();
        m.index = owner.getToolBar().getSelectedImageIndex();
        m.data = idata;
        modify.Data = m;
        owner.getFrame().getDocument().modify(modify);

        transformed = false;
    }

    private void editImage()
    {
        int x, y, width, height;

        //ͼεʵС

        //ȡy
        for (y = 0; y < data.getHeight(); y++)
        {
            for (x = 0; x < data.getWidth(); x++)
            {
                if (calculate.getRGB(x, y) != Color.BLACK.getRGB())
                    break;
            }

            if (x < data.getWidth())
                break;
        }

        //ȡx
        for (x = 0; x < data.getWidth(); x++)
        {
            int k = 0;
            for (; k < data.getHeight(); k++)
            {
                if (calculate.getRGB(x, k) != Color.BLACK.getRGB())
                    break;
            }

            if (k < data.getHeight())
                break;
        }

        //ȡheight
        for (height = data.getHeight() - y; height >= 0; height--)
        {
            int j = 0;
            for (j = 0; j < data.getWidth(); j++)
            {
                if (calculate.getRGB(j, y + height - 1)
                    != Color.BLACK.getRGB())
                    break;
            }

            if (j < data.getWidth())
                break;
        }

        //ȡwidth
        for (width = data.getWidth() - x; width >= 0; width--)
        {
            int k = 0;
            for (; k < data.getHeight(); k++)
            {
                if (calculate.getRGB(x + width - 1, k) != Color.BLACK.getRGB())
                    break;
            }

            if (k < data.getHeight())
                break;
        }

        if (width <= 0 || height <= 0)
            return;
        ImageData idata = new ImageData(x, y, width, height);
        for (int cy = y; cy < y + height; cy++)
        {
            for (int cx = x; cx < x + width; cx++)
            {
                if (calculate.getRGB(cx, cy) == Color.WHITE.getRGB())
                {
                    idata.setColorAt(
                        cx - x,
                        cy - y,
                        owner.getFrame().getPalette().getLeftButtonColor());
                    idata.setMaskAt(
                        cx - x,
                        cy - y,
                        owner
                            .getFrame()
                            .getPalette()
                            .isLeftButtonTransparent());
                }
                else if (calculate.getRGB(cx, cy) == Color.lightGray.getRGB())
                {
                    idata.setColorAt(
                        cx - x,
                        cy - y,
                        owner.getFrame().getPalette().getRightButtonColor());
                    idata.setMaskAt(
                        cx - x,
                        cy - y,
                        owner
                            .getFrame()
                            .getPalette()
                            .isRightButtonTransparent());
                }
                else
                    idata.setColorAt(cx - x, cy - y, transparent);
            }
        }

        ModifyData modify = new ModifyData();
        modify.Level = 3;
        modify.Operation = 1;
        modify.index = owner.getToolBar().getSelfIndex();
        ImageModify m = new ImageModify();
        m.index = owner.getToolBar().getSelectedImageIndex();
        m.data = idata;
        modify.Data = m;
        owner.getFrame().getDocument().modify(modify);
    }

    public void mouseDragged(MouseEvent e)
    {
        owner.setStatus(
            e.getX() / skeleton.Resource.EditPanelPixelSize,
            e.getY() / skeleton.Resource.EditPanelPixelSize);
        if (hotspot)
            return;
        if (button == 0)
            return;
        updateStroke(e);
        repaint();
    }

    public void mouseMoved(MouseEvent e)
    {
        owner.setStatus(
            e.getX() / skeleton.Resource.EditPanelPixelSize,
            e.getY() / skeleton.Resource.EditPanelPixelSize);
        if (hotspot)
        {
            setCursor(Cursor.getDefaultCursor());
            return;
        }

        if (pasteworking)
        {
            int x1 = pastesource.x;
            int y1 = pastesource.y;
            int x2 = pastesource.x + pastesource.width;
            int y2 = pastesource.y + pastesource.height;
            if (e.getX() >= x1 * skeleton.Resource.EditPanelPixelSize
                && e.getX() <= x2 * skeleton.Resource.EditPanelPixelSize
                && e.getY() >= y1 * skeleton.Resource.EditPanelPixelSize
                && e.getY() <= y2 * skeleton.Resource.EditPanelPixelSize)
                setCursor(skeleton.Resource.CursorMove);
            else
                setCursor(skeleton.Resource.CursorCross);
        }
        else
        {
            wg.clearRect(
                0,
                0,
                skeleton.Resource.EditPanelPixelSize * data.getWidth(),
                skeleton.Resource.EditPanelPixelSize * data.getHeight());
        }

        int index = owner.getFrame().getToolBox().getButtonIndex();
        switch (index)
        {
            case 1 :
                wg.clearRect(
                    0,
                    0,
                    skeleton.Resource.EditPanelPixelSize * data.getWidth(),
                    skeleton.Resource.EditPanelPixelSize * data.getHeight());
                cg.clearRect(0, 0, data.getWidth(), data.getHeight());
                cg.setStroke(
                    new BasicStroke(
                        owner.getFrame().getToolBox().getLineWidth(),
                        BasicStroke.CAP_ROUND,
                        BasicStroke.JOIN_MITER));
                int lineWidth = owner.getFrame().getToolBox().getLineWidth();
                int x = e.getX() / skeleton.Resource.EditPanelPixelSize;
                int y = e.getY() / skeleton.Resource.EditPanelPixelSize;
                cg.setColor(Color.WHITE);
                cg.drawLine(x, y, x, y);
                drawWorking(
                    x - lineWidth,
                    y - lineWidth,
                    x + lineWidth,
                    y + lineWidth);
                setCursor(skeleton.Resource.CursorCross);
                break;
            case 2 :
                setCursor(skeleton.Resource.CursorEyedropper);
                break;
            case 3 :
                wg.clearRect(
                    0,
                    0,
                    skeleton.Resource.EditPanelPixelSize * data.getWidth(),
                    skeleton.Resource.EditPanelPixelSize * data.getHeight());
                setCursor(skeleton.Resource.CursorPaint);
                break;
            default :
                if (!pasteworking)
                    setCursor(skeleton.Resource.CursorCross);
        }

        repaint();
    }

    public void mouseClicked(MouseEvent e)
    {
        if (hotspot)
        {
            hotspot = false;
            paintagain = true;
            ModifyData mdata = new ModifyData();
            mdata.Level = 3;
            mdata.Operation = 0;
            mdata.index = owner.getToolBar().getSelfIndex();
            HotspotInfo info = new HotspotInfo();
            info.index = owner.getToolBar().getSelectedImageIndex();
            info.x = e.getX() / skeleton.Resource.EditPanelPixelSize;
            info.y = e.getY() / skeleton.Resource.EditPanelPixelSize;

            if (info.x < 0
                || info.x >= data.getWidth()
                || info.y < 0
                || info.y >= data.getHeight())
                return;

            mdata.Data = info;
            owner.getFrame().getDocument().modify(mdata);
        }

        int index = owner.getFrame().getToolBox().getButtonIndex();

        if (index == 4)
        {
            if (pasteworking)
                confirmPaste();

            TPFontDialog tpfDialog = new TPFontDialog(owner.getFrame());
            if (tpfDialog.showDialog() == TPFontDialog.OK_OPTION)
            {
                cg.clearRect(0, 0, data.getWidth() * 2, data.getHeight() * 2);
                cg.setColor(Color.WHITE);
                cg.setFont(tpfDialog.getSelectedFont());
                cg.drawString(tpfDialog.getInputText(), 0, data.getHeight());
                pastedata =
                    new ImageData(
                        0,
                        0,
                        data.getWidth() * 2,
                        data.getHeight() * 2);
                pastedata.setPosition(data.getWidth(), data.getHeight());
                for (int y = 0; y < data.getHeight() * 2; y++)
                {
                    for (int x = 0; x < data.getWidth() * 2; x++)
                    {
                        if (calculate.getRGB(x, y) == Color.WHITE.getRGB())
                        {
                            if (e.getButton() == MouseEvent.BUTTON1)
                            {
                                pastedata.setColorAt(
                                    x,
                                    y,
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getLeftButtonColor());
                                pastedata.setMaskAt(
                                    x,
                                    y,
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .isLeftButtonTransparent());
                            }
                            else if (e.getButton() == MouseEvent.BUTTON3)
                            {
                                pastedata.setColorAt(
                                    x,
                                    y,
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .getRightButtonColor());
                                pastedata.setMaskAt(
                                    x,
                                    y,
                                    owner
                                        .getFrame()
                                        .getPalette()
                                        .isRightButtonTransparent());
                            }
                        }
                        else
                        {
                            pastedata.setColorAt(x, y, Color.BLACK);
                            pastedata.setMaskAt(x, y, true);
                            pastesource =
                                new Rectangle(
                                    0,
                                    0,
                                    data.getWidth() * 2,
                                    data.getHeight() * 2);
                            pasteworking = true;
                        }
                    }
                }
                updateStroke(e);
            }

            tpfDialog.dispose();
        }
    }

    public void mouseEntered(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {
        if (hotspot || e.getButton() == 0)
            return;
        paintagain = false;
        int index = owner.getFrame().getToolBox().getButtonIndex();
        if (button != 0 && index != 0 && index != 4)
        {
            cg.clearRect(0, 0, data.getWidth(), data.getHeight());
            wg.clearRect(
                0,
                0,
                data.getWidth() * skeleton.Resource.EditPanelPixelSize,
                data.getHeight() * skeleton.Resource.EditPanelPixelSize);
            button = 0;
            repaint();
            return;
        }

        start =
            new Point(
                e.getX() / skeleton.Resource.EditPanelPixelSize,
                e.getY() / skeleton.Resource.EditPanelPixelSize);
        cg.clearRect(0, 0, data.getWidth(), data.getHeight());

        switch (index)
        {
            case 0 :
                if (pasteworking)
                {
                    int x1 = pastesource.x;
                    int y1 = pastesource.y;
                    int x2 = pastesource.x + pastesource.width;
                    int y2 = pastesource.y + pastesource.height;
                    if (e.getX() >= x1 * skeleton.Resource.EditPanelPixelSize
                        && e.getX() <= x2 * skeleton.Resource.EditPanelPixelSize
                        && e.getY() >= y1 * skeleton.Resource.EditPanelPixelSize
                        && e.getY() <= y2 * skeleton.Resource.EditPanelPixelSize)
                        start =
                            new Point(
                                e.getX() / skeleton.Resource.EditPanelPixelSize,
                                e.getY()
                                    / skeleton.Resource.EditPanelPixelSize);
                    else
                        confirmPaste();
                }
                end = start;
                updateStroke(e);
                break;
            case 2 :
                if (e.getButton() == MouseEvent.BUTTON1)
                {
                    owner.getFrame().getPalette().setLeftButtonColor(
                        data.getColorAt(start));
                    owner.getFrame().getPalette().setLeftButtonTransparent(
                        data.getMaskAt(start));
                }
                else if (e.getButton() == MouseEvent.BUTTON3)
                {
                    owner.getFrame().getPalette().setRightButtonColor(
                        data.getColorAt(start));
                    owner.getFrame().getPalette().setRightButtonTransparent(
                        data.getMaskAt(start));
                }

                button = e.getButton();
                break;
            case 3 :
                Color color = data.getColorAt(start.x, start.y);
                boolean Mask = data.getMaskAt(start.x, start.y);
                cg.clearRect(0, 0, data.getWidth(), data.getHeight());
                if (e.getButton() == MouseEvent.BUTTON1)
                    cg.setColor(Color.WHITE);
                else if (e.getButton() == MouseEvent.BUTTON3)
                    cg.setColor(Color.lightGray);
                Stack s = new Stack();
                s.push(new Point(start));
                while (!s.isEmpty())
                {
                    Point point = (Point) (s.pop());
                    cg.drawLine(point.x, point.y, point.x, point.y);
                    for (int i = 0; i < 4; i++)
                    {
                        Point newPoint =
                            new Point(
                                point.x + positions[i].x,
                                point.y + positions[i].y);
                        if (newPoint.x < 0
                            || newPoint.x >= data.getWidth()
                            || newPoint.y < 0
                            || newPoint.y >= data.getHeight())
                            continue;
                        if (data.getColorAt(newPoint).equals(color)
                            && Mask == data.getMaskAt(newPoint)
                            && calculate.getRGB(newPoint.x, newPoint.y)
                                == Color.BLACK.getRGB())
                            s.push(newPoint);
                    }
                }

                button = e.getButton();
                drawWorking(0, 0, data.getWidth(), data.getHeight());
                editImage();
                break;
            case 4 :
                if (!pasteworking)
                    mouseClicked(e);
                else
                    updateStroke(e);
                break;
            case 1 :
            case 5 :
            case 6 :
            case 7 :
            case 9 :
            case 10 :
            case 12 :
            case 13 :
                cg.setStroke(
                    new BasicStroke(
                        owner.getFrame().getToolBox().getLineWidth(),
                        BasicStroke.CAP_ROUND,
                        BasicStroke.JOIN_MITER));
                break;
            case 8 :
            case 11 :
            case 14 :
                cg.setStroke(
                    new BasicStroke(
                        1,
                        BasicStroke.CAP_ROUND,
                        BasicStroke.JOIN_MITER));
        }
        button = e.getButton();
    }

    public void mouseReleased(MouseEvent e)
    {
        if (hotspot || button == 0)
            return;

        int index = owner.getFrame().getToolBox().getButtonIndex();

        updateStroke(e);
        if (index != 0 && index != 3)
            editImage();

        if (index == 0 && !pasteworking)
        {
            int x1 = Math.min(start.x, end.x);
            int y1 = Math.min(start.y, end.y);
            int x2 = Math.max(start.x, end.x);
            int y2 = Math.max(start.y, end.y);
            int sx, sy, ex, ey;
            sx = (x1 < 0) ? 0 : x1;
            sy = (y1 < 0) ? 0 : y1;
            ex = (x2 > data.getWidth() - 1) ? data.getWidth() - 1 : x2;
            ey = (y2 > data.getHeight() - 1) ? data.getHeight() - 1 : y2;
            if (sx > ex || sy > ey)
                return;

            pasteworking = true;
            pastedata = new ImageData();
            pastedata.getImageData(sx, sy, ex - sx + 1, ey - sy + 1, data);
            pastesource = new Rectangle(sx, sy, ex - sx + 1, ey - sy + 1);
        }

        button = 0;
        repaint();
    }

    protected EditorCanvas(EditorPanel Owner)
    {
        this(Owner, null);
    }

    protected EditorCanvas(EditorPanel Owner, MSIconData Data)
    {
        owner = Owner;
        if (Data != null)
            attachIconData(Data);
        else
            data = null;
        addMouseListener(this);
        addMouseMotionListener(this);
        pasteworking = false;
    }

    private void updateIconDataAt(int x, int y, boolean Repaint)
    {
        if ((x / 4 + y / 4) % 2 == 0)
        {
            if (data != null)
                bg.setColor(data.mixColorAt(x, y, Color.lightGray));
            else
                bg.setColor(Color.lightGray);
        }
        else
        {
            if (data != null)
                bg.setColor(data.mixColorAt(x, y, Color.white));
            else
                bg.setColor(Color.white);
        }

        bg.fillRect(
            x * skeleton.Resource.EditPanelPixelSize,
            y * skeleton.Resource.EditPanelPixelSize,
            skeleton.Resource.EditPanelPixelSize,
            skeleton.Resource.EditPanelPixelSize);
        if ((owner.getToolBar() == null
            || (owner.getToolBar() != null && owner.getToolBar().isGridEnabled()))
            && !data.getMaskAt(x, y))
        {
            bg.setColor(Color.BLACK);
            bg.drawRect(
                x * skeleton.Resource.EditPanelPixelSize,
                y * skeleton.Resource.EditPanelPixelSize,
                skeleton.Resource.EditPanelPixelSize - 1,
                skeleton.Resource.EditPanelPixelSize - 1);
        }

        if (Repaint)
            repaint();
    }

    protected void attachIconData(MSIconData Data)
    {
        if (Data == null)
            return;
        int width = Data.getWidth();
        int height = Data.getHeight();
        cache =
            new BufferedImage(
                width * skeleton.Resource.EditPanelPixelSize,
                height * skeleton.Resource.EditPanelPixelSize,
                BufferedImage.TYPE_3BYTE_BGR);
        working =
            new BufferedImage(
                width * skeleton.Resource.EditPanelPixelSize,
                height * skeleton.Resource.EditPanelPixelSize,
                BufferedImage.TYPE_4BYTE_ABGR);
        calculate =
            new BufferedImage(
                width * 2,
                height * 2,
                BufferedImage.TYPE_4BYTE_ABGR);
        bg = cache.createGraphics();
        wg = working.createGraphics();
        cg = calculate.createGraphics();
        cg.setColor(Color.WHITE);
        cg.setBackground(Color.BLACK);
        wg.setBackground(transparent);
        data = Data;
        refreshAll();
        wg.clearRect(
            0,
            0,
            width * skeleton.Resource.EditPanelPixelSize,
            height * skeleton.Resource.EditPanelPixelSize);
        repaint();
    }

    public void refreshAll()
    {
        int width = data.getWidth();
        int height = data.getHeight();
        for (int y = 0; y < height; y++)
            for (int x = 0; x < width; x++)
                updateIconDataAt(x, y, false);
        if (start != null && end != null)
            updateStroke(null);
        repaint();
    }

    public Dimension getPreferredSize()
    {
        if (data == null)
            return new Dimension(0, 0);
        return new Dimension(
            data.getWidth() * skeleton.Resource.EditPanelPixelSize,
            data.getHeight() * skeleton.Resource.EditPanelPixelSize);
    }

    public Dimension getMaximumSize()
    {
        return getPreferredSize();
    }

    public Dimension getMinimumSize()
    {
        return getPreferredSize();
    }

    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        if (data != null)
        {
            g.drawImage(
                cache,
                0,
                0,
                data.getWidth() * skeleton.Resource.EditPanelPixelSize,
                data.getHeight() * skeleton.Resource.EditPanelPixelSize,
                this);
            g.drawImage(
                working,
                0,
                0,
                data.getWidth() * skeleton.Resource.EditPanelPixelSize,
                data.getHeight() * skeleton.Resource.EditPanelPixelSize,
                this);
        }

        if (hotspot || paintagain)
        {
            g.drawImage(
                skeleton.Resource.ImageHotspot,
                (int) ((data.getHotspot().x + 0.5)
                    * skeleton.Resource.EditPanelPixelSize)
                    - 7,
                (int) ((data.getHotspot().y + 0.5)
                    * skeleton.Resource.EditPanelPixelSize)
                    - 7,
                this);
        }
    }
}
