package components.editor;

import msicon.*;
import datatype.*;
import skeleton.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>༭</p>*/
public class EditorPanel
    extends JInternalFrame
    implements InternalFrameListener, Editor
{
    private MainFrame frame;
    private EToolBar jtbToolBar;
    private EditorCanvas canvas;
    private JScrollPane jspScroll;
    private EStatusBar status;

    public void confirmPaste()
    {
        canvas.confirmPaste();
    }

    public void onCut()
    {
        canvas.onCut();
    }

    public void onCopy()
    {
        canvas.onCopy();
    }

    public void onPaste()
    {
        canvas.onPaste();
    }

    public void onClear()
    {
        canvas.onClear();
    }

    public void onSelAll()
    {
        canvas.onSelAll();
    }

    public boolean isPasting()
    {
        return canvas.isPasting();
    }

    public void updateImage()
    {
        confirmPaste();
        jtbToolBar.updateToolBar(
            ((AnimationDoc) (frame.getDocument()))
                .getData()
                .getCursor(jtbToolBar.getSelfIndex())
                .getIconCount());
        canvas.attachIconData(
            ((AnimationDoc) (frame.getDocument()))
                .getData()
                .getCursor(jtbToolBar.getSelfIndex())
                .get(jtbToolBar.getSelectedImageIndex()));
    }

    public void rotate(int direction)
    {
        canvas.rotate(direction);
    }

    public void flip(int direction)
    {
        canvas.flip(direction);
    }

    public void invert()
    {
        canvas.invert();
    }

    public void insertImage()
    {
        confirmPaste();

        ImageFormat format = new ImageFormat(frame);
        ImageFormation formation = format.showDialog(null);

        if (formation == null)
            return;

        ModifyData d = new ModifyData();
        d.Level = 2;
        d.Operation = 1;
        d.index = jtbToolBar.getSelfIndex();

        ImageInfo info = new ImageInfo();

        info.index =
            ((AnimationDoc) (frame.getDocument()))
                .getData()
                .getCursor(jtbToolBar.getSelfIndex())
                .getIconCount();
        MSIcon icon = new MSIcon();

        switch (formation.colors)
        {
            case 2 :
                icon.add(
                    new Dimension(formation.width, formation.height),
                    MSIconData.DefaultPalette2,
                    new Point(0, 0));
                break;
            case 16 :
                icon.add(
                    new Dimension(formation.width, formation.height),
                    MSIconData.DefaultPalette16,
                    new Point(0, 0));
                break;
            case 256 :
                icon.add(
                    new Dimension(formation.width, formation.height),
                    MSIconData.DefaultPalette256,
                    new Point(0, 0));
                break;
            case 16777216 :
                icon.add(
                    new Dimension(formation.width, formation.height),
                    null,
                    new Point(0, 0));
                break;
        }

        info.data = icon.get(0);
        d.Data = info;

        frame.getDocument().modify(d);
    }

    public void deleteImage()
    {
        confirmPaste();
        ModifyData d = new ModifyData();

        if (((AnimationDoc) (frame.getDocument()))
            .getData()
            .getCursor(jtbToolBar.getSelfIndex())
            .getIconCount()
            > 1)
        {
            d.Level = 2;
            d.Operation = 2;
            d.index = jtbToolBar.getSelfIndex();

            ImageInfo info = new ImageInfo();

            info.index = jtbToolBar.getSelectedImageIndex();
            info.data = null;
            d.Data = info;
        }
        else
        {
            d.Level = 1;
            d.Operation = 2;
            d.index = jtbToolBar.getSelfIndex();
            d.Data = null;
        }

        frame.getDocument().modify(d);
    }

    public void mode()
    {
        confirmPaste();

        MSAni doc = ((AnimationDoc) (frame.getDocument())).getData();

        ImageFormation formation = new ImageFormation();
        if (formation == null)
            return;

        MSIconData data =
            doc.getCursor(jtbToolBar.getSelfIndex()).get(
                jtbToolBar.getSelectedImageIndex());
        formation.colors = data.getPaletteSize();
        formation.width = data.getWidth();
        formation.height = data.getHeight();
        formation.exact = data.getColorsCount();

        ImageFormat format = new ImageFormat(frame);
        formation = format.showDialog(formation);

        if (formation == null)
            return;

        ModifyData d = new ModifyData();
        d.Level = 2;
        d.Operation = 0;
        d.index = jtbToolBar.getSelfIndex();

        ImageInfo info = new ImageInfo();

        MSIconData oldData =
            ((AnimationDoc) (frame.getDocument()))
                .getData()
                .getCursor(jtbToolBar.getSelfIndex())
                .get(jtbToolBar.getSelectedImageIndex());
        info.index = jtbToolBar.getSelectedImageIndex();

        MSIcon icon = new MSIcon();
        icon.add(
            new Dimension(formation.width, formation.height),
            null,
            oldData.getHotspot());

        for (int y = 0;
            y < Math.min(oldData.getHeight(), formation.height);
            y++)
        {
            for (int x = 0;
                x < Math.min(oldData.getWidth(), formation.width);
                x++)
            {
                icon.get(0).setColorAt(x, y, oldData.getColorAt(x, y));
                icon.get(0).setMaskAt(x, y, oldData.getMaskAt(x, y));
            }
        }

        if (formation.palettetype == ImageFormat.PALETTE_OPTIMIZED)
            icon.get(0).setPaletteSize(formation.colors);
        else if (formation.palettetype == ImageFormat.PALETTE_STANDARD)
        {
            switch (formation.colors)
            {
                case 2 :
                    icon.get(0).setPalette(MSIconData.DefaultPalette2);
                    break;
                case 16 :
                    icon.get(0).setPalette(MSIconData.DefaultPalette16);
                    break;
                case 256 :
                    icon.get(0).setPalette(MSIconData.DefaultPalette256);
                    break;
                case 16777216 :
                    icon.get(0).setPalette(null);
                    break;
            }
        }

        info.data = icon.get(0);
        d.Data = info;

        frame.getDocument().modify(d);
    }

    public void hotspot()
    {
        confirmPaste();
        canvas.setHotspot();
    }

    public void showGrid(boolean aFlag)
    {
        jtbToolBar.setGridEnabled(aFlag);
    }

    public boolean isGridEnabled()
    {
        return jtbToolBar.isGridEnabled();
    }

    protected MainFrame getFrame()
    {
        return frame;
    }

    public EditorCanvas getCanvas()
    {
        return canvas;
    }

    protected EToolBar getToolBar()
    {
        return jtbToolBar;
    }

    public void internalFrameActivated(InternalFrameEvent e)
    {
        frame.onUpdate();
        frame.getPalette().setPrevious(this);
        jtbToolBar.updatePalette();
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {}

    public void internalFrameClosing(InternalFrameEvent e)
    {
        confirmPaste();
        frame.getAnimation().getSlidePanel().disposeEditor(this);
        dispose();
        frame.onUpdate();
    }

    public void internalFrameDeactivated(InternalFrameEvent e)
    {}

    public void internalFrameDeiconified(InternalFrameEvent e)
    {}

    public void internalFrameIconified(InternalFrameEvent e)
    {}

    public void internalFrameOpened(InternalFrameEvent e)
    {
        frame.getToolBox().show();
        frame.getPalette().show();
        internalFrameActivated(e);
    }

    protected void setBackColor(Color color)
    {}

    protected void setForeColor(Color color)
    {}

    protected void updateScroll()
    {
        jspScroll.updateUI();
    }

    protected void setStatus(int x, int y)
    {
        status.setStatus("(" + x + ", " + y + ")");
    }

    public EditorPanel(MainFrame parent, int index)
    {
        super(
            Resource.TitleEditor
                + " - "
                + parent.getDocument().getFileTitle()
                + " : "
                + (index + 1),
            true,
            true,
            true,
            true);

        frame = parent;
        status = new EStatusBar();

        setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(this);

        setFrameIcon(Resource.IconEditor);

        getContentPane().add(
            jspScroll = new JScrollPane(canvas = new EditorCanvas(this)),
            "Center");

        JPanel panel = new JPanel();
        panel.add(jtbToolBar = new EToolBar(this, index));
        panel.setLayout(new FlowLayout(FlowLayout.LEFT));
        getContentPane().add(panel, "North");

        getContentPane().add(status, "South");

        frame.addInternalFrame(this);
        pack();
        setLocation(frame.getToolBox().getWidth(), 0);
        setVisible(true);

        frame.onUpdate();
        frame.getPalette().setPrevious(this);
        jtbToolBar.updatePalette();
    }
}
