package components.mainframe;
import fmenu.*;

import datatype.*;
import components.editor.*;
import impure.*;
import msicon.*;
import skeleton.*;

import java.io.File;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/

public class AMenuBar extends JMenuBar
{
    private MainFrame owner;

    FMenu fmFile;

    FMenuItem fmiFileNew;
    FMenuItem fmiFileOpen;
    FMenuItem fmiFileSave;
    FMenuItem fmiFileSaveAs;
    FMenuItem fmiFileInfo;
    FMenuItem fmiFileMouseSetting;
    FMenuItem fmiFileExit;

    FMenu fmEdit;

    FMenuItem fmiEditUndo;
    FMenuItem fmiEditRedo;
    FMenuItem fmiEditModify;
    FMenuItem fmiEditCut;
    FMenuItem fmiEditCopy;
    FMenuItem fmiEditPaste;
    FMenuItem fmiEditClear;
    FMenuItem fmiEditSelAll;
    FMenuItem fmiEditInsertFrame;
    FMenuItem fmiEditDeleteFrame;
    FMenuItem fmiEditImport;
    FMenuItem fmiEditExport;

    FMenu fmImage;

    FMenuItem fmiImageMode;
    FMenuItem fmiImageInsert;
    FMenuItem fmiImageDelete;
    FMenu fmImageRotate;
    FMenuItem fmiImageRotate90CW;
    FMenuItem fmiImageRotate90ACW;
    FMenuItem fmiImageRotate180;
    FMenu fmImageFlip;
    FMenuItem fmiImageFlipHorizontal;
    FMenuItem fmiImageFlipVertical;
    FMenuItem fmiImageInvert;
    FMenuItem fmiImageHotspot;
    FMenuItem fmiImageExtract;

    FMenu fmView;

    FCheckBoxMenuItem fmiViewStatusBar;
    FCheckBoxMenuItem fmiViewAnimation;
    FCheckBoxMenuItem fmiViewToolBox;
    FCheckBoxMenuItem fmiViewPalette;
    FCheckBoxMenuItem fmiViewPreview;
    FCheckBoxMenuItem fmiViewGrid;

    FMenu fmLookAndFeel;

    ButtonGroup bgLookAndFeel;

    FRadioButtonMenuItem fmiMetal;
    FRadioButtonMenuItem fmiMotif;
    FRadioButtonMenuItem fmiWindows;

    FMenu fmHelp;

    FMenuItem fmiHelpContent;
    FMenuItem fmiHelpAbout;

    private void packAll()
    {
        owner.getAnimation().pack();
        owner.getPreview().pack();
        owner.getToolBox().pack();
        owner.getPalette().pack();
    }

    public AMenuBar(MainFrame Owner)
    {
        owner = Owner;

        fmFile = new FMenu(Resource.MenuFile);

        fmiFileNew = new FMenuItem(Resource.MenuFileNew);
        fmiFileNew.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onNew();
            }
        });
        fmiFileNew.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileNew));

        fmiFileOpen = new FMenuItem(Resource.MenuFileOpen);
        fmiFileOpen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onOpen();
            }
        });
        fmiFileOpen.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileOpen));

        fmiFileSave = new FMenuItem(Resource.MenuFileSave);
        fmiFileSave.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onSave();
            }
        });
        fmiFileSave.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileSave));

        fmiFileSaveAs = new FMenuItem(Resource.MenuFileSaveAs);
        fmiFileSaveAs.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onSaveAs();
            }
        });
        fmiFileSaveAs.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileSaveAs));

        fmiFileInfo = new FMenuItem(Resource.MenuFileInfo);
        fmiFileInfo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                FileInfo dlg = new FileInfo(owner);
                InfoString info = new InfoString();
                info.NameInfo =
                    ((AnimationDoc) (owner.getDocument()))
                        .getData()
                        .getNameInfo();
                info.ArtInfo =
                    ((AnimationDoc) (owner.getDocument()))
                        .getData()
                        .getArtInfo();
                info = dlg.showDialog(info);

                if (info == null)
                    return;

                ((AnimationDoc) (owner.getDocument())).getData().setNameInfo(
                    info.NameInfo);
                ((AnimationDoc) (owner.getDocument())).getData().setArtInfo(
                    info.ArtInfo);
            }
        });
        fmiFileInfo.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileInfo));

        fmiFileMouseSetting = new FMenuItem(Resource.MenuFileMouseSetting);
        fmiFileMouseSetting.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                Pollute.shellOpen(Pollute.getSystemDirectory() + "\\main.cpl");
            }
        });
        fmiFileMouseSetting.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileMouseSetting));

        fmiFileExit = new FMenuItem(Resource.MenuFileExit);
        fmiFileExit.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onExit();
            }
        });
        fmiFileExit.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuFileExit));

        fmEdit = new FMenu(Resource.MenuEdit);

        fmiEditUndo = new FMenuItem(Resource.MenuEditUndo);
        fmiEditUndo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().undo();
            }
        });
        fmiEditUndo.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditUndo));

        fmiEditRedo = new FMenuItem(Resource.MenuEditRedo);
        fmiEditRedo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().redo();
            }
        });
        fmiEditRedo.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditRedo));

        fmiEditModify = new FMenuItem(Resource.MenuEditModify);
        fmiEditModify.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().openEditor(
                    owner.getAnimation().getSlidePanel().getCurrentIndex());
            }
        });
        fmiEditModify.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditModify));

        fmiEditCut = new FMenuItem(Resource.MenuEditCut);
        fmiEditCut.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onCut();
            }
        });
        fmiEditCut.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditCut));

        fmiEditCopy = new FMenuItem(Resource.MenuEditCopy);
        fmiEditCopy.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onCopy();
            }
        });
        fmiEditCopy.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditCopy));

        fmiEditPaste = new FMenuItem(Resource.MenuEditPaste);
        fmiEditPaste.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onPaste();
            }
        });
        fmiEditPaste.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditPaste));

        fmiEditClear = new FMenuItem(Resource.MenuEditClear);
        fmiEditClear.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onClear();
            }
        });
        fmiEditClear.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditClear));

        fmiEditSelAll = new FMenuItem(Resource.MenuEditSelAll);
        fmiEditSelAll.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onSelAll();
            }
        });
        fmiEditSelAll.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditSelAll));

        fmiEditInsertFrame = new FMenuItem(Resource.MenuEditInsertFrame);
        fmiEditInsertFrame.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().insertBeforeCurrentFrame();
            }
        });
        fmiEditInsertFrame.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditInsertFrame));

        fmiEditDeleteFrame = new FMenuItem(Resource.MenuEditDeleteFrame);
        fmiEditDeleteFrame.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().deleteCurrentFrame();
            }
        });
        fmiEditDeleteFrame.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditDeleteFrame));

        fmiEditImport = new FMenuItem(Resource.MenuEditImport);
        fmiEditImport.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().importFrameFromFile();
            }
        });
        fmiEditImport.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditImport));

        fmiEditExport = new FMenuItem(Resource.MenuEditExport);
        fmiEditExport.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().exportFrameToFile();
            }
        });
        fmiEditExport.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuEditExport));

        fmImage = new FMenu(Resource.MenuImage);

        fmiImageMode = new FMenuItem(Resource.MenuImageMode);
        fmiImageMode.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).mode();
            }
        });
        fmiImageMode.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageMode));

        fmiImageInsert = new FMenuItem(Resource.MenuImageInsert);
        fmiImageInsert.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).insertImage();
            }
        });
        fmiImageInsert.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageInsert));

        fmiImageDelete = new FMenuItem(Resource.MenuImageDelete);
        fmiImageDelete.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).deleteImage();
            }
        });
        fmiImageDelete.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageDelete));

        fmImageRotate = new FMenu(Resource.MenuImageRotate);
        fmImageRotate.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageRotate));

        fmiImageRotate90CW = new FMenuItem(Resource.MenuImageRotate90CW);
        fmiImageRotate90CW.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).rotate(0);
            }
        });
        fmiImageRotate90CW.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageRotate90CW));

        fmiImageRotate90ACW = new FMenuItem(Resource.MenuImageRotate90ACW);
        fmiImageRotate90ACW.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).rotate(1);
            }
        });
        fmiImageRotate90ACW.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageRotate90ACW));

        fmiImageRotate180 = new FMenuItem(Resource.MenuImageRotate180);
        fmiImageRotate180.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).rotate(2);
            }
        });
        fmiImageRotate180.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageRotate180));

        fmImageFlip = new FMenu(Resource.MenuImageFlip);
        fmImageFlip.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageFlip));

        fmiImageFlipHorizontal =
            new FMenuItem(Resource.MenuImageFlipHorizontal);
        fmiImageFlipHorizontal.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).flip(0);
            }
        });
        fmiImageFlipHorizontal.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageFlipHorizontal));

        fmiImageFlipVertical = new FMenuItem(Resource.MenuImageFlipVertical);
        fmiImageFlipVertical.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).flip(1);
            }
        });
        fmiImageFlipVertical.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageFlipVertical));

        fmiImageInvert = new FMenuItem(Resource.MenuImageInvert);
        fmiImageInvert.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).invert();
            }
        });
        fmiImageInvert.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageInvert));

        fmiImageHotspot = new FMenuItem(Resource.MenuImageHotspot);
        fmiImageHotspot.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).hotspot();
            }
        });
        fmiImageHotspot.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageHotspot));

        fmiImageExtract = new FMenuItem(Resource.MenuImageExtract);
        fmiImageExtract.addActionListener(new ActionListener()
        {
            private final SunFileFilter sfIco =
                new SunFileFilter("ico", Resource.DescriptionIconFile);
            private final SunFileFilter sfCur =
                new SunFileFilter("cur", Resource.DescriptionCursorFile);
            private final SunFileFilter sfDll =
                new SunFileFilter("dll", Resource.DescriptionDllFile);
            private final SunFileFilter sfExe =
                new SunFileFilter("exe", Resource.DescriptionExeFile);

            private String openPath;
            private FileFilter openFilter;

            public void actionPerformed(ActionEvent ae)
            {
                JFileChooser jfc = new JFileChooser(openPath);
                jfc.addChoosableFileFilter(sfIco);
                jfc.addChoosableFileFilter(sfCur);
                jfc.addChoosableFileFilter(sfDll);
                jfc.addChoosableFileFilter(sfExe);

                if (openFilter != null)
                {
                    FileFilter[] filters = jfc.getChoosableFileFilters();
                    jfc.setFileFilter(jfc.getAcceptAllFileFilter());

                    for (int i = 0; i < filters.length; i++)
                    {
                        if (filters[i] == openFilter)
                        {
                            jfc.setFileFilter(openFilter);
                            break;
                        }

                    }
                }

                if (jfc.showOpenDialog(owner) == JFileChooser.APPROVE_OPTION)
                {
                    openPath = jfc.getCurrentDirectory().getPath();
                    openFilter = jfc.getFileFilter();
                    String filename = jfc.getSelectedFile().getPath();

                    ExtractIcon ei = new ExtractIcon(owner);

                    MSIconData data = null;
                    if ((data = ei.showDialog(filename)) != null)
                    {
                        ImageData idata =
                            new ImageData(
                                0,
                                0,
                                data.getWidth(),
                                data.getHeight(),
                                data);
                        ((EditorPanel) (owner.getActiveFrame()))
                            .getCanvas()
                            .doPaste(
                            idata);
                    }
                }
            }
        });
        fmiImageExtract.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuImageExtract));

        fmView = new FMenu(Resource.MenuView);

        fmiViewStatusBar = new FCheckBoxMenuItem(Resource.MenuViewStatusBar);
        fmiViewStatusBar.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.setStatusBarVisible(fmiViewStatusBar.getState());
            }
        });
        fmiViewStatusBar.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewStatusBar));

        fmiViewAnimation = new FCheckBoxMenuItem(Resource.MenuViewAnimation);
        fmiViewAnimation.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().setVisible(fmiViewAnimation.getState());
                owner.onUpdate();
            }
        });
        fmiViewAnimation.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewAnimation));

        fmiViewToolBox = new FCheckBoxMenuItem(Resource.MenuViewToolBox);
        fmiViewToolBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getToolBox().setVisible(fmiViewToolBox.getState());
                owner.onUpdate();
            }
        });
        fmiViewToolBox.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewToolBox));

        fmiViewPalette = new FCheckBoxMenuItem(Resource.MenuViewPalette);
        fmiViewPalette.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getPalette().setVisible(fmiViewPalette.getState());
                owner.onUpdate();
            }
        });
        fmiViewPalette.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewPalette));

        fmiViewPreview = new FCheckBoxMenuItem(Resource.MenuViewPreview);
        fmiViewPreview.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getPreview().setVisible(fmiViewPreview.getState());
                owner.onUpdate();
            }
        });
        fmiViewPreview.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewPreview));

        fmiViewGrid = new FCheckBoxMenuItem(Resource.MenuViewGrid);
        fmiViewGrid.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                ((EditorPanel) (owner.getActiveFrame())).showGrid(
                    fmiViewGrid.isSelected());
            }
        });
        fmiViewGrid.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewGrid));

        fmLookAndFeel = new FMenu(Resource.MenuViewLookAndFeel);
        fmLookAndFeel.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuViewLookAndFeel));

        fmiMetal = new FRadioButtonMenuItem("&Metal", true);
        fmiMetal.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                try
                {
                    UIManager.setLookAndFeel(
                        new javax.swing.plaf.metal.MetalLookAndFeel());
                    SwingUtilities.updateComponentTreeUI(owner);
                    packAll();
                }
                catch (Exception exp)
                {
                    exp.printStackTrace();
                }
            }
        });

        fmiMotif = new FRadioButtonMenuItem("Mo&tif");
        fmiMotif.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                try
                {
                    UIManager.setLookAndFeel(
                        "com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                    SwingUtilities.updateComponentTreeUI(owner);
                    packAll();
                }
                catch (Exception exp)
                {
                    exp.printStackTrace();
                }
            }
        });

        fmiWindows = new FRadioButtonMenuItem("&Windows");
        fmiWindows.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                try
                {
                    UIManager.setLookAndFeel(
                        "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                    SwingUtilities.updateComponentTreeUI(owner);
                    packAll();
                }
                catch (Exception exp)
                {
                    exp.printStackTrace();
                }
            }
        });

        bgLookAndFeel = new ButtonGroup();
        bgLookAndFeel.add(fmiMetal);
        bgLookAndFeel.add(fmiMotif);
        bgLookAndFeel.add(fmiWindows);

        fmHelp = new FMenu(Resource.MenuHelp);

        fmiHelpContent = new FMenuItem(Resource.MenuHelpContent);
        fmiHelpContent.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                try
                {
                    File help = new File("./Help/index.html");
                    if (!help.exists())
                        throw new Exception();
                    Pollute.shellOpen(help.getPath());
                }
                catch (Exception e)
                {
                    JOptionPane.showMessageDialog(
                        owner,
                        Resource.CantLoadHelpFile,
                        Resource.AppName,
                        JOptionPane.ERROR_MESSAGE);
                }
            }
        });
        fmiHelpContent.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuHelpContent));

        fmiHelpAbout = new FMenuItem(Resource.MenuHelpAbout);
        fmiHelpAbout.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onAbout();
            }
        });
        fmiHelpAbout.addChangeListener(
            new StatusChange(owner, Resource.ToolTipMenuHelpAbout));

        fmiFileNew.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_MASK));
        fmiFileNew.setIcon(Resource.IconToolBarNew);
        fmFile.add(fmiFileNew);

        fmiFileOpen.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_O, InputEvent.CTRL_MASK));
        fmiFileOpen.setIcon(Resource.IconToolBarOpen);
        fmFile.add(fmiFileOpen);

        fmiFileSave.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK));
        fmiFileSave.setIcon(Resource.IconToolBarSave);
        fmFile.add(fmiFileSave);

        fmiFileSaveAs.setIcon(Resource.IconNull);
        fmFile.add(fmiFileSaveAs);

        fmFile.addSeparator();

        fmiFileInfo.setIcon(Resource.IconToolBarInfo);
        fmFile.add(fmiFileInfo);

        fmFile.addSeparator();

        fmiFileMouseSetting.setIcon(Resource.IconNull);
        fmFile.add(fmiFileMouseSetting);

        fmFile.addSeparator();

        fmiFileExit.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.ALT_MASK));
        fmiFileExit.setIcon(Resource.IconNull);
        fmFile.add(fmiFileExit);

        fmiEditUndo.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_Z, InputEvent.CTRL_MASK));
        fmiEditUndo.setIcon(Resource.IconToolBarUndo);
        fmEdit.add(fmiEditUndo);

        fmiEditRedo.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_Y, InputEvent.CTRL_MASK));
        fmiEditRedo.setIcon(Resource.IconToolBarRedo);
        fmEdit.add(fmiEditRedo);

        fmEdit.addSeparator();

        fmiEditModify.setIcon(Resource.IconEditor);
        fmEdit.add(fmiEditModify);

        fmEdit.addSeparator();

        fmiEditCut.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK));
        fmiEditCut.setIcon(Resource.IconToolBarCut);
        fmEdit.add(fmiEditCut);

        fmiEditCopy.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK));
        fmiEditCopy.setIcon(Resource.IconToolBarCopy);
        fmEdit.add(fmiEditCopy);

        fmiEditPaste.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.CTRL_MASK));
        fmiEditPaste.setIcon(Resource.IconToolBarPaste);
        fmEdit.add(fmiEditPaste);

        fmiEditClear.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
        fmiEditClear.setIcon(Resource.IconNull);
        fmEdit.add(fmiEditClear);

        fmEdit.addSeparator();

        fmiEditSelAll.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_A, KeyEvent.CTRL_MASK));
        fmiEditSelAll.setIcon(Resource.IconNull);
        fmEdit.add(fmiEditSelAll);

        fmEdit.addSeparator();

        fmiEditInsertFrame.setIcon(Resource.IconToolBarInsertFrame);
        fmEdit.add(fmiEditInsertFrame);

        fmiEditDeleteFrame.setIcon(Resource.IconToolBarDeleteFrame);
        fmEdit.add(fmiEditDeleteFrame);

        fmEdit.addSeparator();

        fmiEditImport.setIcon(Resource.IconNull);
        fmEdit.add(fmiEditImport);

        fmiEditExport.setIcon(Resource.IconNull);
        fmEdit.add(fmiEditExport);

        fmiImageMode.setIcon(Resource.IconToolBarMode);
        fmImage.add(fmiImageMode);

        fmImage.addSeparator();

        fmiImageInsert.setIcon(Resource.IconToolBarInsertImage);
        fmImage.add(fmiImageInsert);

        fmiImageDelete.setIcon(Resource.IconToolBarDeleteImage);
        fmImage.add(fmiImageDelete);

        fmImage.addSeparator();

        fmImageRotate.setIcon(Resource.IconNull);
        fmImage.add(fmImageRotate);

        fmiImageRotate90CW.setIcon(Resource.IconToolBarRotate90CW);
        fmImageRotate.add(fmiImageRotate90CW);

        fmiImageRotate90ACW.setIcon(Resource.IconToolBarRotate90ACW);
        fmImageRotate.add(fmiImageRotate90ACW);

        fmiImageRotate180.setIcon(Resource.IconToolBarRotate180);
        fmImageRotate.add(fmiImageRotate180);

        fmImageFlip.setIcon(Resource.IconNull);
        fmImage.add(fmImageFlip);

        fmiImageFlipHorizontal.setIcon(Resource.IconToolBarFlipHorizontal);
        fmImageFlip.add(fmiImageFlipHorizontal);

        fmiImageFlipVertical.setIcon(Resource.IconToolBarFlipVertical);
        fmImageFlip.add(fmiImageFlipVertical);

        fmImage.addSeparator();

        fmiImageInvert.setIcon(Resource.IconToolBarInvert);
        fmImage.add(fmiImageInvert);

        fmiImageHotspot.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_H, KeyEvent.CTRL_MASK));
        fmiImageHotspot.setIcon(Resource.IconToolBarHotspot);
        fmImage.add(fmiImageHotspot);

        fmImage.addSeparator();

        fmiImageExtract.setIcon(Resource.IconNull);
        fmImage.add(fmiImageExtract);

        fmiViewStatusBar.setIcon(Resource.IconNull);
        fmView.add(fmiViewStatusBar);

        fmView.addSeparator();

        fmiViewAnimation.setIcon(Resource.IconToolBarAnimation);
        fmView.add(fmiViewAnimation);

        fmiViewToolBox.setIcon(Resource.IconToolBarToolBox);
        fmView.add(fmiViewToolBox);

        fmiViewPalette.setIcon(Resource.IconToolBarPalette);
        fmView.add(fmiViewPalette);

        fmiViewPreview.setIcon(Resource.IconToolBarPreview);
        fmView.add(fmiViewPreview);

        fmView.addSeparator();

        fmiViewGrid.setIcon(Resource.IconToolBarGrid);
        fmView.add(fmiViewGrid);

        fmView.addSeparator();

        fmLookAndFeel.add(fmiMetal);
        fmLookAndFeel.add(fmiMotif);
        fmLookAndFeel.add(fmiWindows);
        fmLookAndFeel.setIcon(Resource.IconNull);

        fmView.add(fmLookAndFeel);

        fmiHelpContent.setIcon(Resource.IconToolBarContent);
        fmHelp.add(fmiHelpContent);

        fmiHelpAbout.setIcon(Resource.IconToolBarAbout);

        fmHelp.addSeparator();

        fmHelp.add(fmiHelpAbout);

        add(fmFile);
        add(fmEdit);
        add(fmImage);
        add(fmView);
        add(fmHelp);

        fmiViewAnimation.setSelected(true);
        fmiViewStatusBar.setSelected(true);
    }

    public void updateMenu()
    {
        fmiFileSave.setEnabled(
            ((AnimationDoc) (owner.getDocument())).getData().getFrameCount()
                > 0);
        fmiFileSaveAs.setEnabled(
            ((AnimationDoc) (owner.getDocument())).getData().getFrameCount()
                > 0);

        fmiEditUndo.setEnabled(owner.getDocument().canUndo());
        fmiEditRedo.setEnabled(owner.getDocument().canRedo());

        boolean state;

        if (owner != null
            && owner.getAnimation() != null
            && owner.getAnimation().getSlidePanel() != null)
            state =
                (owner.getAnimation().getSlidePanel().getCurrentIndex() != -1);
        else
            state = false;

        fmiEditModify.setEnabled(state);
        if (owner.getActiveFrame() == owner.getAnimation())
        {
            fmiEditCut.setEnabled(state);
            fmiEditCopy.setEnabled(state);
            fmiEditPaste.setEnabled(true);
            fmiEditClear.setEnabled(state);
            fmiEditSelAll.setEnabled(false);
        }
        else if (owner.getActiveFrame() == owner.getPreview())
        {
            fmiEditCut.setEnabled(false);
            fmiEditCopy.setEnabled(false);
            fmiEditPaste.setEnabled(false);
            fmiEditClear.setEnabled(false);
            fmiEditSelAll.setEnabled(false);
        }
        else if (owner.getActiveFrame() == owner.getToolBox())
        {
            fmiEditCut.setEnabled(false);
            fmiEditCopy.setEnabled(false);
            fmiEditPaste.setEnabled(false);
            fmiEditClear.setEnabled(false);
            fmiEditSelAll.setEnabled(false);
        }
        else if (owner.getActiveFrame() == owner.getPalette())
        {
            fmiEditCut.setEnabled(false);
            fmiEditCopy.setEnabled(false);
            fmiEditPaste.setEnabled(false);
            fmiEditClear.setEnabled(false);
            fmiEditSelAll.setEnabled(false);
        }
        else if (EditorPanel.class.isInstance(owner.getActiveFrame()))
        {
            fmiEditCut.setEnabled(true);
            fmiEditCopy.setEnabled(true);
            fmiEditPaste.setEnabled(true);
            fmiEditClear.setEnabled(true);
            fmiEditSelAll.setEnabled(true);
        }
        else if (owner.getActiveFrame() == null)
        {
            fmiEditCut.setEnabled(false);
            fmiEditCopy.setEnabled(false);
            fmiEditPaste.setEnabled(false);
            fmiEditClear.setEnabled(false);
            fmiEditSelAll.setEnabled(false);
        }

        fmiEditDeleteFrame.setEnabled(state);
        fmiEditExport.setEnabled(state);

        if (owner.getAnimation() != null
            && owner.getPreview() != null
            && owner.getToolBox() != null
            && owner.getPalette() != null)
        {
            fmiViewAnimation.setSelected(owner.getAnimation().isVisible());
            fmiViewPreview.setSelected(owner.getPreview().isVisible());
            fmiViewToolBox.setSelected(owner.getToolBox().isVisible());
            fmiViewPalette.setSelected(owner.getPalette().isVisible());
        }

        if (state = EditorPanel.class.isInstance(owner.getActiveFrame()))
        {
            fmiViewGrid.setSelected(
                ((EditorPanel) (owner.getActiveFrame())).isGridEnabled());
        }
        else
        {
            fmiViewGrid.setSelected(true);
        }

        fmImage.setEnabled(state);
        fmiImageHotspot.setEnabled(state);
        fmiViewGrid.setEnabled(state);
    }
}

class StatusChange implements ChangeListener
{
    private MainFrame owner;
    private String oldStatus;
    private String status;
    private boolean enabled;
    private boolean checked;

    public StatusChange(MainFrame Owner, String Status)
    {
        status = Status;
        owner = Owner;
        enabled = true;
        checked = false;
    }

    public void stateChanged(ChangeEvent ce)
    {
        if (((JMenuItem) (ce.getSource())).isEnabled() != enabled)
        {
            enabled = ((JMenuItem) (ce.getSource())).isEnabled();
            return;
        }

        if (JCheckBoxMenuItem.class.isInstance(ce.getSource()))
        {
            if (((JMenuItem) (ce.getSource())).isSelected() != checked)
            {
                checked = ((JMenuItem) (ce.getSource())).isSelected();
                return;
            }
        }

        if (oldStatus == null)
            oldStatus = owner.setStatus(status);
        else
        {
            owner.setStatus(oldStatus);
            oldStatus = null;
        }
    }
}
