package components.mainframe;

import datatype.*;

import components.editor.*;
import skeleton.*;

import javax.swing.*;
import java.awt.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class AToolBar extends JToolBar
{
    private MainFrame owner;

    JButton jbNew;
    JButton jbOpen;
    JButton jbSave;

    JButton jbCut;
    JButton jbCopy;
    JButton jbPaste;

    JButton jbUndo;
    JButton jbRedo;

    JButton jbInsert;
    JButton jbDelete;

    JToggleButton jtbAnimation;
    JToggleButton jtbToolBox;
    JToggleButton jtbPalette;
    JToggleButton jtbPreview;

    JButton jbAbout;

    public AToolBar(MainFrame Owner)
    {
        super();
        owner = Owner;

        jbNew = new JButton(Resource.IconToolBarNew);
        jbNew.setToolTipText(Resource.ToolTipMenuFileNew);
        jbNew.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onNew();
            }
        });

        jbOpen = new JButton(Resource.IconToolBarOpen);
        jbOpen.setToolTipText(Resource.ToolTipMenuFileOpen);
        jbOpen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onOpen();
            }
        });

        jbSave = new JButton(Resource.IconToolBarSave);
        jbSave.setToolTipText(Resource.ToolTipMenuFileSave);
        jbSave.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onSave();
            }
        });

        jbCut = new JButton(Resource.IconToolBarCut);
        jbCut.setToolTipText(Resource.ToolTipMenuEditCut);
        jbCut.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onCut();
            }
        });

        jbCopy = new JButton(Resource.IconToolBarCopy);
        jbCopy.setToolTipText(Resource.ToolTipMenuEditCopy);
        jbCopy.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onCopy();
            }
        });

        jbPaste = new JButton(Resource.IconToolBarPaste);
        jbPaste.setToolTipText(Resource.ToolTipMenuEditPaste);
        jbPaste.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                if (owner.getActiveFrame() == null)
                    return;

                if (Editor.class.isInstance(owner.getActiveFrame()))
                     ((Editor) owner.getActiveFrame()).onPaste();
            }
        });

        jbUndo = new JButton(Resource.IconToolBarUndo);
        jbUndo.setToolTipText(Resource.ToolTipMenuEditUndo);
        jbUndo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().undo();
            }
        });

        jbRedo = new JButton(Resource.IconToolBarRedo);
        jbRedo.setToolTipText(Resource.ToolTipMenuEditRedo);
        jbRedo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().redo();
            }
        });

        jbInsert = new JButton(Resource.IconToolBarInsertFrame);
        jbInsert.setToolTipText(Resource.ToolTipMenuEditInsertFrame);
        jbInsert.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().insertBeforeCurrentFrame();
            }
        });

        jbDelete = new JButton(Resource.IconToolBarDeleteFrame);
        jbDelete.setToolTipText(Resource.ToolTipMenuEditDeleteFrame);
        jbDelete.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().getSlidePanel().deleteCurrentFrame();
            }
        });

        jbRedo = new JButton(Resource.IconToolBarRedo);
        jbRedo.setToolTipText(Resource.ToolTipMenuEditRedo);
        jbRedo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().redo();
            }
        });

        jbRedo = new JButton(Resource.IconToolBarRedo);
        jbRedo.setToolTipText(Resource.ToolTipMenuEditRedo);
        jbRedo.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getDocument().redo();
            }
        });

        jtbAnimation = new JToggleButton(Resource.IconToolBarAnimation, true);
        jtbAnimation.setToolTipText(Resource.ToolTipMenuViewAnimation);
        jtbAnimation.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getAnimation().setVisible(jtbAnimation.isSelected());
                owner.onUpdate();
            }
        });

        jtbToolBox = new JToggleButton(Resource.IconToolBarToolBox);
        jtbToolBox.setToolTipText(Resource.ToolTipMenuViewToolBox);
        jtbToolBox.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getToolBox().setVisible(jtbToolBox.isSelected());
                owner.onUpdate();
            }
        });

        jtbPalette = new JToggleButton(Resource.IconToolBarPalette);
        jtbPalette.setToolTipText(Resource.ToolTipMenuViewPalette);
        jtbPalette.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getPalette().setVisible(jtbPalette.isSelected());
                owner.onUpdate();
            }
        });

        jtbPreview = new JToggleButton(Resource.IconToolBarPreview);
        jtbPreview.setToolTipText(Resource.ToolTipMenuViewPreview);
        jtbPreview.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.getPreview().setVisible(jtbPreview.isSelected());
                owner.onUpdate();
            }
        });

        jbAbout = new JButton(Resource.IconToolBarAbout);
        jbAbout.setToolTipText(Resource.ToolTipMenuHelpAbout);
        jbAbout.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                owner.onAbout();
            }
        });

        add(jbNew);
        add(jbOpen);
        add(jbSave);

        addSeparator();

        add(jbCut);
        add(jbCopy);
        add(jbPaste);

        addSeparator();

        add(jbUndo);
        add(jbRedo);

        addSeparator();

        add(jbInsert);
        add(jbDelete);

        addSeparator();

        add(jtbAnimation);
        add(jtbToolBox);
        add(jtbPalette);
        add(jtbPreview);

        addSeparator();

        add(jbAbout);
    }

    public void updateToolBar()
    {
        jbSave.setEnabled(
            ((AnimationDoc) (owner.getDocument())).getData().getFrameCount()
                > 0);

        jbUndo.setEnabled(owner.getDocument().canUndo());
        jbRedo.setEnabled(owner.getDocument().canRedo());

        if (owner.getActiveFrame() == owner.getAnimation())
        {
            if (owner.getAnimation() != null
                && owner.getAnimation().getSlidePanel() != null)
            {
                jbCut.setEnabled(
                    owner.getAnimation().getSlidePanel().getCurrentIndex()
                        != -1);
                jbCopy.setEnabled(
                    owner.getAnimation().getSlidePanel().getCurrentIndex()
                        != -1);
                jbDelete.setEnabled(
                    owner.getAnimation().getSlidePanel().getCurrentIndex()
                        != -1);

                jbPaste.setEnabled(true);
            }
            else
            {
                jbCut.setEnabled(false);
                jbCopy.setEnabled(false);
                jbDelete.setEnabled(false);
            }
        }
        else if (EditorPanel.class.isInstance(owner.getActiveFrame()))
        {
            jbCut.setEnabled(true);
            jbCopy.setEnabled(true);
            jbPaste.setEnabled(true);
        }
        else if (owner.getActiveFrame() == owner.getPreview())
        {
            jbCut.setEnabled(false);
            jbCopy.setEnabled(false);
            jbPaste.setEnabled(false);
        }
        else if (owner.getActiveFrame() == owner.getToolBox())
        {
            jbCut.setEnabled(false);
            jbCopy.setEnabled(false);
            jbPaste.setEnabled(false);
        }
        else if (owner.getActiveFrame() == owner.getPalette())
        {
            jbCut.setEnabled(false);
            jbCopy.setEnabled(false);
            jbPaste.setEnabled(false);
        }
        else
        {
            jbCut.setEnabled(false);
            jbCopy.setEnabled(false);
            jbPaste.setEnabled(false);
        }

        if (owner.getAnimation() != null
            && owner.getPreview() != null
            && owner.getToolBox() != null
            && owner.getPalette() != null)
        {
            jtbAnimation.setSelected(owner.getAnimation().isVisible());
            jtbPreview.setSelected(owner.getPreview().isVisible());
            jtbToolBox.setSelected(owner.getToolBox().isVisible());
            jtbPalette.setSelected(owner.getPalette().isVisible());
        }
    }
}
