package components.mainframe;

import skeleton.*;
import impure.*;
import components.animation.*;

import msicon.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class ExtractIcon extends JDialog implements ActionListener
{
    private ArrayList buttons;
    private ButtonGroup bgGroup;
    private JPanel iconpanel;
    private JRadioButton jrbSmall;
    private JRadioButton jrbLarge;
    private JButton jbOK;
    private JButton jbCancel;
    private Frame owner;
    private int index;
    private boolean succeed;

    public void actionPerformed(ActionEvent e)
    {
        index = buttons.indexOf(e.getSource());
    }

    /**ûѡͼʱ
     * 򷵻ͼꡣ
     * 򷵻<code>null</code>*/
    public MSIconData showDialog(String filename)
    {
        succeed = false;

        int count;
        if ((count = Pollute.getIconCount(filename)) == 0)
        {
            JOptionPane.showMessageDialog(
                owner,
                Resource.ExtractNoIcon,
                Resource.ExtractDialogTitle,
                JOptionPane.ERROR_MESSAGE);
            return null;
        }

        bgGroup = new ButtonGroup();
        buttons = new ArrayList();

        for (int i = 0; i < count; i++)
        {
            IconButton ib =
                new IconButton(
                    Pollute.extractIcon(filename, i, Pollute.LARGE_ICON_ONLY));
            ib.setSelected(i == 0);
            bgGroup.add(ib);
            buttons.add(ib);
            ib.addActionListener(this);
            iconpanel.add(ib);
        }

        try
        {
            setLocation(
                getParent().getX() + (getParent().getWidth() - getWidth()) / 2,
                getParent().getY()
                    + (getParent().getHeight() - getHeight()) / 2);
        }
        catch (NullPointerException e)
        {
            setLocation(
                (Toolkit.getDefaultToolkit().getScreenSize().width
                    - getWidth())
                    / 2,
                (Toolkit.getDefaultToolkit().getScreenSize().height
                    - getHeight())
                    / 2);
        }
        SwingUtilities.updateComponentTreeUI(this);
        show();

        if (succeed)
        {
            if (jrbSmall.isSelected())
                return Pollute.extractIcon(
                    filename,
                    index,
                    Pollute.SMALL_ICON_ONLY).get(
                    0);
            else
                return Pollute.extractIcon(
                    filename,
                    index,
                    Pollute.LARGE_ICON_ONLY).get(
                    0);
        }
        else
            return null;
    }

    public ExtractIcon(Frame Owner)
    {
        super(Owner, Resource.ExtractDialogTitle, true);
        owner = Owner;

        iconpanel = new JPanel();
        iconpanel.setLayout(new FlowLayout(FlowLayout.LEFT));

        jrbSmall = new JRadioButton(Resource.FormatImageSizeSmall);
        jrbLarge = new JRadioButton(Resource.FormatImageSizeNormal, true);

        ButtonGroup group = new ButtonGroup();
        group.add(jrbSmall);
        group.add(jrbLarge);

        JPanel panel = new JPanel();
        panel.add(jrbSmall);
        panel.add(jrbLarge);

        getContentPane().add(panel, "Center");

        jbOK = new JButton(Resource.DialogOK);
        jbOK.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                succeed = true;
                ExtractIcon.this.dispose();
            }
        });

        jbCancel = new JButton(Resource.DialogCancel);
        jbCancel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                ExtractIcon.this.dispose();
            }
        });

        JPanel jpBottom = new JPanel();
        jpBottom = new JPanel();
        jpBottom.add(jbOK);
        jpBottom.add(jbCancel);

        getRootPane().setDefaultButton(jbOK);

        JScrollPane jsp;

        getContentPane().add(
            jsp =
                new JScrollPane(
                    iconpanel,
                    JScrollPane.VERTICAL_SCROLLBAR_NEVER,
                    JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS),
            "North");
        jsp.setPreferredSize(
            new Dimension(
                Resource.AnimationPanelWidth,
                Resource.AnimationPanelHeight));
        getContentPane().add(jpBottom, "South");

        pack();
        setResizable(false);
    }
}
