package components.mainframe;

import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class FileInfo extends JDialog
{
    private JLabel lbName;
    private JTextArea jtaName;
    private JLabel lbArt;
    private JTextArea jtaArt;
    private JButton jbOK;
    private JButton jbCancel;
    private Frame owner;
    private InfoString info;
    private boolean succeed;

    public InfoString showDialog(InfoString oldInfo)
    {
        succeed = false;
        if (oldInfo != null)
        {
            jtaName.setText(oldInfo.NameInfo);
            jtaArt.setText(oldInfo.ArtInfo);
        }

        try
        {
            setLocation(
                getParent().getX() + (getParent().getWidth() - getWidth()) / 2,
                getParent().getY()
                    + (getParent().getHeight() - getHeight()) / 2);
        }
        catch (NullPointerException e)
        {
            setLocation(
                (Toolkit.getDefaultToolkit().getScreenSize().width
                    - getWidth())
                    / 2,
                (Toolkit.getDefaultToolkit().getScreenSize().height
                    - getHeight())
                    / 2);
        }
        SwingUtilities.updateComponentTreeUI(this);
        show();

        if (succeed)
            return info;
        else
            return null;
    }

    public FileInfo(Frame Owner)
    {
        super(Owner, Resource.FileInfoDialogTitle, true);
        owner = Owner;

        info = new InfoString();

        JPanel jpTop = new JPanel();
        jpTop.setLayout(new BoxLayout(jpTop, BoxLayout.Y_AXIS));

        lbName = new JLabel(Resource.FileInfoFileInfo);
        jtaName = new JTextArea(5, 32);

        lbArt = new JLabel(Resource.FileInfoArtInfo);
        jtaArt = new JTextArea(5, 32);

        jtaName.setLineWrap(true);
        jtaArt.setLineWrap(true);

        jpTop.add(lbName);
        jpTop.add(
            new JScrollPane(
                jtaName,
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));
        jpTop.add(lbArt);
        jpTop.add(
            new JScrollPane(
                jtaArt,
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));

        jbOK = new JButton(Resource.DialogOK);
        jbOK.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                info.NameInfo = jtaName.getText();
                info.ArtInfo = jtaArt.getText();
                succeed = true;
                FileInfo.this.dispose();
            }
        });

        jbCancel = new JButton(Resource.DialogCancel);
        jbCancel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                FileInfo.this.dispose();
            }
        });

        JPanel jpBottom = new JPanel();
        jpBottom = new JPanel();
        jpBottom.add(jbOK);
        jpBottom.add(jbCancel);

        getRootPane().setDefaultButton(jbOK);

        getContentPane().add(jpTop, "Center");
        getContentPane().add(jpBottom, "South");

        pack();
        setResizable(false);
    }
}
