package components.palette;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ɫť</p>*/
public class ColorButton extends JToggleButton
{
    private BufferedImage bImage;
    private Color buttoncolor;
    private boolean transparent;

    /**һհ׵İť*/
    protected ColorButton()
    {
        this(Color.black, false);
    }

    /**ʹͼһͼİť*/
    protected ColorButton(Color color, boolean Transparent)
    {
        updateColor(color, Transparent);
    }

    public Color getColor()
    {
        return buttoncolor;
    }

    public boolean isTransparent()
    {
        return transparent;
    }

    public void setColor(Color newColor)
    {
        updateColor(newColor, transparent);
    }

    public void setTransparent(boolean Transparent)
    {
        updateColor(buttoncolor, Transparent);
    }

    public void updateColor(Color newColor, boolean Transparent)
    {
        buttoncolor = newColor;
        transparent = Transparent;

        bImage = new BufferedImage(16, 16, BufferedImage.TYPE_3BYTE_BGR);
        Graphics g = bImage.createGraphics();

        for (int y = 0; y < 16; y++)
        {
            for (int x = 0; x < 16; x++)
            {
                if (transparent)
                {
                    if ((x / 4 + y / 4) % 2 == 0)
                        g.setColor(
                            new Color(
                                buttoncolor.getRGB()
                                    ^ Color.lightGray.getRGB()));
                    else
                        g.setColor(
                            new Color(
                                buttoncolor.getRGB() ^ Color.WHITE.getRGB()));
                }
                else
                    g.setColor(buttoncolor);

                g.drawLine(x, y, x, y);
            }
        }

        repaint();
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(16, 16);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(16, 16);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(16, 16);
    }

    public void paint(Graphics g)
    {
        g.drawImage(bImage, 0, 0, 16, 16, this);

        if (isSelected())
        {
            g.setColor(Color.BLACK);
            g.drawRect(0, 0, 15, 15);
            g.setColor(Color.WHITE);
            g.drawRect(1, 1, 13, 13);
        }
    }
}
