package components.palette;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>16ɫɫ</p>*/
public class Palette16 extends JPanel implements MouseListener
{
    private Color[] Palette;
    private int index;
    private BufferedImage cache;
    private PalettePanel parent;

    public void mouseClicked(MouseEvent e)
    {
        int x = (e.getPoint().x - 8) / 32;
        int y = e.getPoint().y / 32;

        if (x > 7 || y > 1)
            return;

        index = y * 8 + x;
        parent.setColor(Palette[index]);
    }

    public void mouseEntered(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {}

    public void mouseReleased(MouseEvent e)
    {}

    protected int getPalette()
    {
        return index;
    }

    protected Palette16(PalettePanel owner, Color[] palette)
    {
        parent = owner;

        if (palette.length != 16)
            throw new RuntimeException();

        Palette = palette;
        rebuildPalette();

        addMouseListener(this);
    }

    protected void setPalette(Color[] palette)
    {
        Palette = palette;
        rebuildPalette();
    }

    protected void rebuildPalette()
    {
        cache = new BufferedImage(256, 64, BufferedImage.TYPE_3BYTE_BGR);

        Graphics g = cache.createGraphics();
        for (int i = 0; i < 16; i++)
        {
            g.setColor(Palette[i]);
            g.fillRect((i % 8) * 32, (i / 8) * 32, 32, 32);
        }

        repaint();
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(272, 64);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(272, 64);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(272, 64);
    }

    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.drawImage(cache, 8, 0, 256, 64, this);
    }
}
