package components.palette;

import msicon.*;

import skeleton.*;
import components.editor.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ɫ</p>*/
public class PalettePanel
    extends JInternalFrame
    implements InternalFrameListener
{
    private MainFrame frame;
    private JCheckBox jcbButton;
    private JLabel label;

    private Palette2 palette2;
    private Palette16 palette16;
    private Palette256 palette256;
    private PaletteTrueColor truecolor;

    private ColorButton activecolor;
    private ColorButton backcolor;
    private ColorButton forecolor;

    private EditorPanel previous;

    private JTabbedPane jtpTab;

    public void setLeftButtonColor(Color color)
    {
        forecolor.setColor(color);
        updateLabel();
        updateCheck();
    }

    public void setPrevious(EditorPanel Previous)
    {
        previous = Previous;
    }

    private Color[] palette2(Color[] palette)
    {
        Color[] result = new Color[2];

        for (int i = 0; i < 2; i++)
            result[i] =
                new Color(
                    Utilities
                        .getNearestColor(palette, MSIconData.DefaultPalette2[i])
                        .getRGB());

        return result;
    }

    private Color[] palette16(Color[] palette)
    {
        Color[] result = new Color[16];

        for (int i = 0; i < 16; i++)
            result[i] =
                new Color(
                    Utilities
                        .getNearestColor(
                            palette,
                            MSIconData.DefaultPalette16[i])
                        .getRGB());

        return result;
    }

    public void setPalette2(Color[] palette)
    {
        jtpTab.setSelectedIndex(0);
        jtpTab.setEnabledAt(1, false);
        jtpTab.setEnabledAt(2, false);
        jtpTab.setEnabledAt(3, false);
        palette2.setPalette(palette);
        forecolor.setColor(
            Utilities.getNearestColor(palette, forecolor.getColor()));
        backcolor.setColor(
            Utilities.getNearestColor(palette, backcolor.getColor()));
    }

    public void setPalette16(Color[] palette)
    {
        jtpTab.setSelectedIndex(1);
        jtpTab.setEnabledAt(1, true);
        jtpTab.setEnabledAt(2, false);
        jtpTab.setEnabledAt(3, false);
        palette2.setPalette(palette2(palette));
        palette16.setPalette(palette);
        forecolor.setColor(
            Utilities.getNearestColor(palette, forecolor.getColor()));
        backcolor.setColor(
            Utilities.getNearestColor(palette, backcolor.getColor()));
    }

    public void setPalette256(Color[] palette)
    {
        jtpTab.setSelectedIndex(2);
        jtpTab.setEnabledAt(1, true);
        jtpTab.setEnabledAt(2, true);
        jtpTab.setEnabledAt(3, false);
        palette2.setPalette(palette2(palette));
        palette16.setPalette(palette16(palette));
        palette256.setPalette(palette);
        forecolor.setColor(
            Utilities.getNearestColor(palette, forecolor.getColor()));
        backcolor.setColor(
            Utilities.getNearestColor(palette, backcolor.getColor()));
    }

    public void setPaletteTrueColor()
    {
        jtpTab.setSelectedIndex(3);
        jtpTab.setEnabledAt(1, true);
        jtpTab.setEnabledAt(2, true);
        jtpTab.setEnabledAt(3, true);
    }

    public void setRightButtonColor(Color color)
    {
        backcolor.setColor(color);
        updateLabel();
        updateCheck();
    }

    public void setLeftButtonTransparent(boolean transparent)
    {
        forecolor.setTransparent(transparent);
    }

    public void setRightButtonTransparent(boolean transparent)
    {
        backcolor.setTransparent(transparent);
    }

    public Color getLeftButtonColor()
    {
        return forecolor.getColor();
    }

    public Color getRightButtonColor()
    {
        return backcolor.getColor();
    }

    public boolean isLeftButtonTransparent()
    {
        return forecolor.isTransparent();
    }

    public boolean isRightButtonTransparent()
    {
        return backcolor.isTransparent();
    }

    public void internalFrameActivated(InternalFrameEvent e)
    {
        frame.onUpdate();
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {}

    public void internalFrameClosing(InternalFrameEvent e)
    {
        setVisible(false);
        frame.onUpdate();
    }

    public void internalFrameDeactivated(InternalFrameEvent e)
    {}

    public void internalFrameDeiconified(InternalFrameEvent e)
    {}

    public void internalFrameIconified(InternalFrameEvent e)
    {}

    public void internalFrameOpened(InternalFrameEvent e)
    {}

    protected void setBackColor(Color color)
    {}

    protected void setForeColor(Color color)
    {}

    public PalettePanel(MainFrame parent)
    {
        super(Resource.PaletteTitle, false, true, false, false);

        frame = parent;

        putClientProperty("JInternalFrame.isPalette", Boolean.TRUE);
        setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(this);

        setFrameIcon(Resource.IconToolBarPalette);

        jtpTab = new JTabbedPane();

        palette2 = new Palette2(this, MSIconData.DefaultPalette2);
        jtpTab.add(Resource.Palette2Color, palette2);
        palette16 = new Palette16(this, MSIconData.DefaultPalette16);
        jtpTab.add(Resource.Palette16Color, palette16);
        palette256 = new Palette256(this, MSIconData.DefaultPalette256);
        jtpTab.add(Resource.Palette256Color, palette256);
        truecolor = new PaletteTrueColor(this);
        jtpTab.add(Resource.PaletteTrueColor, truecolor);

        getContentPane().add(jtpTab, "North");

        JPanel panel = new JPanel();
        panel.add(forecolor = new ColorButton(Color.BLACK, false));
        panel.add(backcolor = new ColorButton(Color.BLACK, true));

        ButtonGroup bgGroup = new ButtonGroup();
        bgGroup.add(activecolor = forecolor);
        bgGroup.add(backcolor);
        forecolor.setSelected(true);

        jcbButton = new JCheckBox(Resource.PaletteTransparent);
        panel.add(jcbButton);

        forecolor.addActionListener(new ButtonListener(this));
        backcolor.addActionListener(new ButtonListener(this));
        jcbButton.addActionListener(new CheckListener(this));

        getContentPane().add(panel, "Center");
        getContentPane().add(
            label = new JLabel(Resource.PaletteForeground + "#000000"),
            "South");

        pack();
    }

    protected void setActiveButton(ColorButton button)
    {
        activecolor = button;
    }

    protected ColorButton getActiveButton()
    {
        return activecolor;
    }

    protected JCheckBox getCheck()
    {
        return jcbButton;
    }

    protected void setColor(Color color)
    {
        activecolor.setColor(color);
        updateLabel();
    }

    protected void updateLabel()
    {
        Color color = activecolor.getColor();
        truecolor.update(color.getRed(), color.getGreen(), color.getBlue());

        String red = Integer.toHexString(color.getRed());
        if (red.length() < 2)
            red = "0" + red;
        String green = Integer.toHexString(color.getGreen());
        if (green.length() < 2)
            green = "0" + green;
        String blue = Integer.toHexString(color.getBlue());
        if (blue.length() < 2)
            blue = "0" + blue;
        label.setText(
            ((activecolor == forecolor)
                ? Resource.PaletteForeground
                : Resource.PaletteBackground)
                + "#"
                + red
                + green
                + blue);
    }

    protected void updateCheck()
    {
        jcbButton.setSelected(activecolor.isTransparent());
    }
}

class ButtonListener implements ActionListener
{
    private PalettePanel parent;

    ButtonListener(PalettePanel owner)
    {
        parent = owner;
    }

    public void actionPerformed(ActionEvent e)
    {
        parent.getCheck().setSelected(
            ((ColorButton) (e.getSource())).isTransparent());
        parent.setActiveButton((ColorButton) (e.getSource()));
        parent.updateLabel();
    }
}

class CheckListener implements ActionListener
{
    private PalettePanel parent;

    CheckListener(PalettePanel owner)
    {
        parent = owner;
    }

    public void actionPerformed(ActionEvent e)
    {
        parent.getActiveButton().setTransparent(
            ((JCheckBox) (e.getSource())).isSelected());
    }
}
