package components.palette;

import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ɫɫ</p>*/
public class PaletteTrueColor extends JPanel
{
    private int red;
    private int green;
    private int blue;

    private PaletteHandle redHandle;
    private PaletteHandle greenHandle;
    private PaletteHandle blueHandle;

    private PalettePanel parent;

    protected PaletteTrueColor(PalettePanel owner)
    {
        parent = owner;

        red = 0;
        green = 0;
        blue = 0;

        setLayout(null);

        redHandle =
            new PaletteHandle(this, Resource.ImagePaletteChooserRed, 0, 0);
        add(redHandle);
        greenHandle =
            new PaletteHandle(this, Resource.ImagePaletteChooserGreen, 0, 24);
        add(greenHandle);
        blueHandle =
            new PaletteHandle(this, Resource.ImagePaletteChooserBlue, 0, 48);
        add(blueHandle);
    }

    protected Color getPalette()
    {
        return new Color(red, green, blue);
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(272, 64);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(272, 64);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(272, 64);
    }

    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);

        g.drawImage(Resource.ImagePaletteSampleRed, 8, 8, 256, 8, this);
        g.drawImage(Resource.ImagePaletteSampleGreen, 8, 32, 256, 8, this);
        g.drawImage(Resource.ImagePaletteSampleBlue, 8, 56, 256, 8, this);
    }

    protected void refresh()
    {
        red = redHandle.getX();
        green = greenHandle.getX();
        blue = blueHandle.getX();
        parent.setColor(new Color(red, green, blue));
    }

    /**ɫαλá*/
    protected void update(int Red, int Green, int Blue)
    {
        redHandle.setLocation(red = Red, redHandle.getY());
        greenHandle.setLocation(green = Green, greenHandle.getY());
        blueHandle.setLocation(blue = Blue, blueHandle.getY());
    }
}

class PaletteHandle
    extends JPanel
    implements MouseListener, MouseMotionListener
{
    private PaletteTrueColor parent;
    private Image image;
    private int x;
    private int y;
    private int posX;

    public void mouseClicked(MouseEvent e)
    {}

    public void mouseEntered(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {
        posX = e.getPoint().x;
    }

    public void mouseReleased(MouseEvent e)
    {}

    public void mouseDragged(MouseEvent e)
    {
        int newLocation = getX() - posX + e.getX();

        if (newLocation < x)
            newLocation = x;
        else if (newLocation - x > 255)
            newLocation = x + 255;

        setLocation(newLocation, y);
        parent.refresh();
    }

    public void mouseMoved(MouseEvent e)
    {}

    protected PaletteHandle(
        PaletteTrueColor owner,
        Image HandlePicture,
        int X,
        int Y)
    {
        parent = owner;
        image = HandlePicture;
        x = X;
        y = Y;
        setSize(16, 8);
        setLocation(x, y);

        addMouseListener(this);
        addMouseMotionListener(this);
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(16, 8);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(16, 8);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(16, 8);
    }

    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.drawImage(image, 0, 0, 16, 8, this);
    }
}
