package components.preview;

import msicon.*;

import datatype.*;

import java.awt.*;
import java.awt.image.*;
import java.util.*;

import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class CursorCanvas extends JPanel
{
    MSAni msani;
    ArrayList bImage;
    Graphics bg;
    int curindex;
    PreviewTimer timer;

    protected CursorCanvas(MSAni Ani)
    {
        super();

        if (Ani != null)
            attachAni(Ani);
    }

    protected void stop()
    {
        if (timer != null)
        {
            timer.Stop();
            timer = null;
        }
    }

    private void insertFrame(int index)
    {
        bImage.add(index, new FrameInfo());
        updateIcon(index);

        if (timer == null)
        {
            timer = new PreviewTimer(this);
            timer.start();
        }
    }

    private void deleteFrame(int index)
    {
        if (curindex == index)
            curindex = 0;

        bImage.remove(index);
    }

    protected void updateImage(ModifyData data)
    {
        switch (data.Level)
        {
            case 1 :
                switch (data.Operation)
                {
                    case 1 :
                        insertFrame(data.index);
                        break;
                    case 2 :
                        deleteFrame(data.index);
                        break;
                }
                break;
            case 2 :
                updateIcon(data.index);
                break;
            case 3 :
                updateIcon(data.index);
                break;
        }
    }

    protected int getCount()
    {
        return msani.getFrameCount();
    }

    protected int getCurIndex()
    {
        return curindex;
    }

    protected int getRate(int index)
    {
        return msani.getRate(index);
    }

    public void attachAni(MSAni Ani)
    {
        msani = Ani;
        bImage = new ArrayList();

        int i;
        for (i = 0; i < msani.getFrameCount(); i++)
        {
            bImage.add(new FrameInfo());
            updateIcon(i);
        }

        if (i > 0)
        {
            if (timer != null)
                timer.Stop();

            timer = new PreviewTimer(this);
            timer.start();
        }
    }

    private void updateIconAt(int index, int x, int y, boolean Repaint)
    {
        MSIcon msi = msani.getCursor(index);

        if (msi != null
            && x
                - msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getWidth()
                + 1
                + msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHotspot()
                    .x
                >= 0
            && x
                - msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getWidth()
                + 1
                + msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHotspot()
                    .x
                < msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getWidth()
            && y
                - msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHeight()
                + 1
                + msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHotspot()
                    .y
                >= 0
            && y
                - msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHeight()
                + msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHotspot()
                    .y
                <= msani
                    .getCursor(index)
                    .get(((FrameInfo) (bImage.get(index))).bestIndex)
                    .getHeight())
        {
            bg.setColor(
                msi.get(
                    ((FrameInfo) (bImage.get(index))).bestIndex).mixColorAt(
                    x
                        - msani
                            .getCursor(index)
                            .get(((FrameInfo) (bImage.get(index))).bestIndex)
                            .getWidth()
                        + 1
                        + msani
                            .getCursor(index)
                            .get(((FrameInfo) (bImage.get(index))).bestIndex)
                            .getHotspot()
                            .x,
                    y
                        - msani
                            .getCursor(index)
                            .get(((FrameInfo) (bImage.get(index))).bestIndex)
                            .getHeight()
                        + 1
                        + msani
                            .getCursor(index)
                            .get(((FrameInfo) (bImage.get(index))).bestIndex)
                            .getHotspot()
                            .y,
                    Color.white));
        }
        else
            bg.setColor(Color.white);

        bg.drawLine(x, y, x, y);

        if (Repaint)
            repaint();
    }

    private void updateIcon(int index)
    {
        MSIcon msi = msani.getCursor(index);

        int i = 0;
        int mostColors = 0;
        int width = 0, height = 0;

        for (int k = 0; k < msi.getIconCount(); k++)
        {
            if (msi.get(k).getPaletteSize() > mostColors)
            {
                mostColors = msi.get(k).getPaletteSize();
                i = k;
            }
        }

        ((FrameInfo) (bImage.get(index))).bestIndex = i;
        int Range =
            (int) ((msi.get(i).getWidth() - 32) * (msi.get(i).getWidth() - 32)
                + (msi.get(i).getHeight() - 32) * (msi.get(i).getHeight() - 32));

        for (int k = 1; k < msi.getIconCount(); k++)
        {
            if (msi.get(k).getPaletteSize() < mostColors)
                continue;
            int nRange =
                (int) ((msi.get(k).getWidth() - 32)
                    * (msi.get(k).getWidth() - 32)
                    + (msi.get(k).getHeight() - 32)
                        * (msi.get(k).getHeight() - 32));
            if (nRange < Range)
            {
                Range = nRange;
                ((FrameInfo) (bImage.get(index))).bestIndex = k;
            }
        }

        width = msi.get(((FrameInfo) (bImage.get(index))).bestIndex).getWidth();
        height =
            msi.get(((FrameInfo) (bImage.get(index))).bestIndex).getHeight();

        ((FrameInfo) (bImage.get(index))).Cache =
            new BufferedImage(
                width * 2 - 1,
                height * 2 - 1,
                BufferedImage.TYPE_3BYTE_BGR);
        bg = ((FrameInfo) (bImage.get(index))).Cache.createGraphics();

        for (int y = 0; y < height * 2 - 1; y++)
            for (int x = 0; x < width * 2 - 1; x++)
                updateIconAt(index, x, y, false);

        repaint();
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(63, 63);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(63, 63);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(63, 63);
    }

    public void paint(Graphics g)
    {
        if (bImage.size() <= curindex)
            curindex = 0;

        if (bImage.size() == 0)
        {
            g.setColor(Color.white);
            g.fillRect(0, 0, 63, 63);
            return;
        }

        g.drawImage(
            ((FrameInfo) (bImage.get(curindex))).Cache,
            0,
            0,
            63,
            63,
            this);
    }

    protected void next()
    {
        if (++curindex >= msani.getFrameCount())
            curindex = 0;
        repaint();
    }
}

class PreviewTimer extends Thread
{
    private CursorCanvas owner;
    private boolean bStop;

    public void run()
    {
        try
        {
            while (!bStop && owner.getCount() > 0)
            {
                sleep(owner.getRate(owner.getCurIndex()) * 10);
                owner.next();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    protected void Stop()
    {
        bStop = true;
    }

    protected PreviewTimer(CursorCanvas Owner)
    {
        owner = Owner;
        bStop = false;
    }
}

class FrameInfo
{
    protected int bestIndex;
    protected BufferedImage Cache;
}
