package components.preview;

import fsdi.*;
import skeleton.*;

import java.awt.*;

import javax.swing.*;
import javax.swing.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Ԥ</p>*/
public class PreviewPanel
    extends JInternalFrame
    implements FView, InternalFrameListener
{
    private MainFrame frame;
    private AnimationDoc doc;
    private CursorCanvas cc;

    public void setVisible(boolean aFlag)
    {
        super.setVisible(aFlag);

        if (cc != null)
        {
            if (aFlag)
                cc.attachAni(doc.getData());
            else
                cc.stop();
        }
    }

    public void internalFrameActivated(InternalFrameEvent e)
    {
        frame.onUpdate();
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {}

    public void internalFrameClosing(InternalFrameEvent e)
    {
        setVisible(false);
        frame.onUpdate();
    }

    public void internalFrameDeactivated(InternalFrameEvent e)
    {}

    public void internalFrameDeiconified(InternalFrameEvent e)
    {}

    public void internalFrameIconified(InternalFrameEvent e)
    {}

    public void internalFrameOpened(InternalFrameEvent e)
    {}

    public void attachFrame(FFrame Frame)
    {
        frame = (MainFrame) Frame;
        doc = (AnimationDoc) (frame.getDocument());

        setFrameIcon(skeleton.Resource.IconToolBarPreview);

        frame.addInternalFrame(this);

        cc = new CursorCanvas(doc.getData());
        getContentPane().setLayout(new FlowLayout());
        getContentPane().add(cc);

        pack();
    }

    public void updateView()
    {
        if (isVisible())
        {
            if (doc.getModifyData() == null)
                cc.attachAni(doc.getData());
            else
                cc.updateImage(doc.getModifyData());
        }
    }

    public PreviewPanel()
    {
        super("", false, true, false, false);
        putClientProperty("JInternalFrame.isPalette", Boolean.TRUE);
        setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(this);
    }
}
