package components.toolbox;

import skeleton.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼ</p>*/
public class ToolBoxPanel
    extends JInternalFrame
    implements InternalFrameListener
{
    private MainFrame frame;
    private ButtonPanel tools;
    private JPanel extra;
    private LinePanel pen;

    public int getLineWidth()
    {
        return pen.getLineWidth();
    }

    public int getButtonIndex()
    {
        return tools.getCurrentToolIndex();
    }

    public void setButtonIndex(int index)
    {
        tools.setCurrentToolIndex(index);
    }

    public void internalFrameActivated(InternalFrameEvent e)
    {
        frame.onUpdate();
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {}

    public void internalFrameClosing(InternalFrameEvent e)
    {
        setVisible(false);
        frame.onUpdate();
    }

    public void internalFrameDeactivated(InternalFrameEvent e)
    {}

    public void internalFrameDeiconified(InternalFrameEvent e)
    {}

    public void internalFrameIconified(InternalFrameEvent e)
    {}

    public void internalFrameOpened(InternalFrameEvent e)
    {}

    protected void showLine()
    {
        pen.setVisible(true);
    }

    protected void showNothing()
    {
        pen.setVisible(false);
    }

    public ToolBoxPanel(MainFrame parent)
    {
        super("", false, true, false, false);

        frame = parent;

        putClientProperty("JInternalFrame.isPalette", Boolean.TRUE);
        setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(this);

        getContentPane().add(tools = new ButtonPanel(this), "North");
        getContentPane().add(extra = new JPanel(), "South");

        pen = new LinePanel();

        extra.add(pen);
        extra.setPreferredSize(new Dimension(80, 80));

        setFrameIcon(Resource.IconToolBarToolBox);
        pack();
    }

    protected MainFrame getFrame()
    {
        return frame;
    }
}
