package datatype;
import msicon.*;

import java.awt.*;
import java.io.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼݡ</p>*/
public class ImageData implements Serializable
{
    /**ͼϽxꡣ*/
    private int x;

    /**ͼϽyꡣ*/
    private int y;

    /**ͼȡ*/
    private int Width;

    /**ͼ߶ȡ*/
    private int Height;

    /**ͼݣ24λʷʽš*/
    private Color[][] Image;

    /**ͼ롣*/
    private boolean[][] Mask;

    public ImageData()
    {
        Image = null;
        Mask = null;
        Width = 0;
        Height = 0;
        x = 0;
        y = 0;
    }

    /**һͼ
     * ȸ߶Ϊ<code>width*height</code>
     * ϽΪ<code>(x, y)</code>*/
    public ImageData(int X, int Y, int width, int height)
    {
        Width = width;
        Height = height;
        x = X;
        y = Y;

        Image = new Color[Height][Width];
        Mask = new boolean[Height][Width];

        for (int y = 0; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                Image[y][x] = Color.black;
                Mask[y][x] = true;
            }
        }
    }

    /**ͼнȡһͼ
     * ȸ߶Ϊ<code>width*height</code>
     * ϽΪ<code>(x, y)</code>*/
    public ImageData(int X, int Y, int width, int height, MSIconData msid)
    {
        getImageData(X, Y, width, height, msid);
    }

    /**ͼнȡһͼ
     * ȸ߶Ϊ<code>width*height</code>
     * ϽΪ<code>(x, y)</code>*/
    public void getImageData(
        int X,
        int Y,
        int width,
        int height,
        MSIconData msid)
    {
        Width = width;
        Height = height;
        x = X;
        y = Y;

        Image = new Color[Height][Width];
        Mask = new boolean[Height][Width];

        for (int m = 0; m < Height; m++)
        {
            for (int n = 0; n < Width; n++)
            {
                if (x + n >= 0
                    && x + n < msid.getWidth()
                    && y + m >= 0
                    && y + m < msid.getHeight())
                {
                    Image[m][n] = msid.getColorAt(x + n, y + m);
                    Mask[m][n] = msid.getMaskAt(x + n, y + m);
                }
                else
                {
                    Image[m][n] = new Color(0, 0, 0, 0);
                    Mask[m][n] = true;
                }
            }
        }
    }

    /**ͼͼС*/
    public void setImageData(MSIconData msid)
    {
        for (int m = 0; m < Height; m++)
        {
            for (int n = 0; n < Width; n++)
            {
                if (x + n >= 0
                    && x + n < msid.getWidth()
                    && y + m >= 0
                    && y + m < msid.getHeight())
                {
                    if (Image[m][n].getAlpha() != 0)
                    {
                        msid.setColorAt(x + n, y + m, Image[m][n]);
                        msid.setMaskAt(x + n, y + m, Mask[m][n]);
                    }
                    else
                    {
                        msid.setColorAt(
                            x + n,
                            y + m,
                            new Color(
                                (Image[m][n].getRGB() | 0xff000000)
                                    ^ msid.getColorAt(x + n, y + m).getRGB()));
                        msid.setMaskAt(
                            x + n,
                            y + m,
                            Mask[m][n] && msid.getMaskAt(x + n, y + m));
                    }
                }
            }
        }
    }

    /**ȡͼȡ*/
    public int getWidth()
    {
        return Width;
    }

    /**ͼȣõĿȡ*/
    public int setWidth(int width)
    {
        return setSize(width, getHeight()).width;
    }

    /**ȡͼ߶ȡ*/
    public int getHeight()
    {
        return Height;
    }

    /**ͼ߶ȣõĸ߶ȡ*/
    public int setHeight(int height)
    {
        return setSize(getWidth(), height).height;
    }

    /**ȡͼߴ硣*/
    public Dimension getSize()
    {
        return new Dimension(Width, Height);
    }

    /**ͼߴ硣*/
    public Dimension setSize(int width, int height)
    {
        Width = width;
        Height = height;

        Color[][] newImage = new Color[Height][Width];
        boolean[][] newMask = new boolean[Height][Width];

        int y;
        for (y = 0; y < Math.min(height, Image.length); y++)
        {
            int x;
            for (x = 0; x < Math.min(width, Image[0].length); x++)
            {
                newImage[y][x] = Image[y][x];
                newMask[y][x] = Mask[y][x];
            }

            for (; x < Width; x++)
            {
                newImage[y][x] = Color.black;
                newMask[y][x] = true;
            }
        }
        for (; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                newImage[y][x] = Color.black;
                newMask[y][x] = true;
            }
        }

        Image = newImage;
        Mask = newMask;

        return new Dimension(Width, Height);
    }

    /**ȡͼλá*/
    public Point getPosition()
    {
        return new Point(x, y);
    }

    /**ͼλá*/
    public Point setPosition(int X, int Y)
    {
        x = X;
        y = Y;
        return new Point(x, y);
    }

    /**ѯָǷ͸
     * õ͸򷵻<code>true</code>
     * ͸
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean getMaskAt(int x, int y)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Mask[y][x];
        else
            return false;
    }

    /**ָǷ͸
     * ú(x, y)͸״̬Ϊֵָ
     * ɹúָ͸״̬
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean setMaskAt(int x, int y, boolean mask)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Mask[y][x] = mask;
        else
            return false;
    }
    /**ȡָɫ
     * ɹúָɫ
     * ָ겻ͼΧڣ
     * 򷵻<code>null</code>*/
    public Color getColorAt(int x, int y)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Image[y][x];
        else
            return null;
    }

    /**ָɫ
     * úָɫΪֵָ
     * ɹúָɫ
     * ָ겻ͼΧڣ
     * 򷵻<code>null</code>*/
    public Color setColorAt(int x, int y, Color color)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Image[y][x] = color;
        else
            return null;
    }

    /**ȡָ뱳Ϻɫ
     * õ͸úظõָıɫ
     * ɫ
     * õ㲻͸úظõɫ
     * ָ겻ͼΧڣ
     * ú<code>null</code>*/
    public Color mixColorAt(int x, int y, Color color)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
        {
            if (Mask[y][x])
                return new Color(color.getRGB() ^ Image[y][x].getRGB());
            else
                return Image[y][x];
        }
        else
            return null;
    }
}
