package fclipboard;

import java.io.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ݴӼ뵽ڴС</p>*/
public class FClipInputStream extends InputStream
{
    private byte[] clipdata;
    private int mark;
    private int curpos;

    protected FClipInputStream()
    {
        clipdata = getClipboardData();
        mark = 0;
        curpos = 0;
    }

    public int available()
    {
        if (clipdata != null)
            return clipdata.length - curpos - 1;
        else
            return 0;
    }

    public void close()
    {
        clipdata = null;
        System.gc();
    }

    public void mark(int readlimit)
    {
        mark = curpos;
    }

    public boolean markSupported()
    {
        return true;
    }

    public int read()
    {
        if (clipdata != null && curpos < clipdata.length)
        {
            int value = clipdata[curpos++];
            if (value >= 0)
                return value;
            else
                return value + 256;
        }
        else
            return -1;
    }

    public int read(byte[] b)
    {
        return read(b, 0, b.length);
    }

    public int read(byte[] b, int off, int len)
    {
        if (clipdata != null && curpos < clipdata.length)
        {
            int i;
            for (i = 0; i < len; i++)
            {
                int data = read();
                if (data == -1)
                    break;

                if (data > 127)
                    data -= 256;

                b[off + i] = (byte) data;
            }

            return i;
        }
        else
            return -1;
    }

    public void reset()
    {
        curpos = mark;
    }

    public long skip(long n)
    {
        if (clipdata != null)
        {
            int actual = (int) n;
            if (curpos + n > clipdata.length)
                actual = clipdata.length - curpos;

            curpos += actual;
            return actual;
        }
        else
            return 0;
    }

    private static native byte[] getClipboardData();
    static {
        java
            .security
            .AccessController
            .doPrivileged(new java.security.PrivilegedAction()
        {
            public Object run()
            {
                System.loadLibrary("FClip");
                return null;
            }
        });
    }
}
