package msicon;

import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼ࣬
 * ڱͼļеͼϢ</p>*/

public class MSIconData implements Serializable
{
    private int Width;
    private int Height;
    private Color[] Palette;
    private int[][] Image;
    private boolean[][] Mask;
    private Point Hotspot;

    /**ϵͳĬ2ɫɫ塣*/
    public static final Color[] DefaultPalette2 =
        { new Color(0x00, 0x00, 0x00), new Color(0xff, 0xff, 0xff)};

    /**ϵͳĬ16ɫɫ塣*/
    public static final Color[] DefaultPalette16 =
        {
            new Color(0x00, 0x00, 0x00),
            new Color(0x80, 0x00, 0x00),
            new Color(0x00, 0x80, 0x00),
            new Color(0x80, 0x80, 0x00),
            new Color(0x00, 0x00, 0x80),
            new Color(0x80, 0x00, 0x80),
            new Color(0x00, 0x80, 0x80),
            new Color(0xc0, 0xc0, 0xc0),
            new Color(0x80, 0x80, 0x80),
            new Color(0xff, 0x00, 0x00),
            new Color(0x00, 0xff, 0x00),
            new Color(0xff, 0xff, 0x00),
            new Color(0x00, 0x00, 0xff),
            new Color(0xff, 0x00, 0xff),
            new Color(0x00, 0xff, 0xff),
            new Color(0xff, 0xff, 0xff)};

    /**ϵͳĬ256ɫɫ塣*/
    public static final Color[] DefaultPalette256 =
        {
            new Color(0x00, 0x00, 0x00),
            new Color(0x00, 0x00, 0x40),
            new Color(0x00, 0x00, 0x80),
            new Color(0x00, 0x00, 0xff),
            new Color(0x00, 0x20, 0x00),
            new Color(0x00, 0x20, 0x40),
            new Color(0x00, 0x20, 0x80),
            new Color(0x00, 0x20, 0xff),
            new Color(0x00, 0x40, 0x00),
            new Color(0x00, 0x40, 0x40),
            new Color(0x00, 0x40, 0x80),
            new Color(0x00, 0x40, 0xff),
            new Color(0x00, 0x60, 0x00),
            new Color(0x00, 0x60, 0x40),
            new Color(0x00, 0x60, 0x80),
            new Color(0x00, 0x60, 0xff),
            new Color(0x00, 0x80, 0x00),
            new Color(0x00, 0x80, 0x40),
            new Color(0x00, 0x80, 0x80),
            new Color(0x00, 0x80, 0xff),
            new Color(0x00, 0xa0, 0x00),
            new Color(0x00, 0xa0, 0x40),
            new Color(0x00, 0xa0, 0x80),
            new Color(0x00, 0xa0, 0xff),
            new Color(0x00, 0xc0, 0x00),
            new Color(0x00, 0xc0, 0x40),
            new Color(0x00, 0xc0, 0x80),
            new Color(0x00, 0xc0, 0xff),
            new Color(0x00, 0xff, 0x00),
            new Color(0x00, 0xff, 0x40),
            new Color(0x00, 0xff, 0x80),
            new Color(0x00, 0xff, 0xff),
            new Color(0x20, 0x00, 0x00),
            new Color(0x20, 0x00, 0x40),
            new Color(0x20, 0x00, 0x80),
            new Color(0x20, 0x00, 0xff),
            new Color(0x20, 0x20, 0x00),
            new Color(0x20, 0x20, 0x40),
            new Color(0x20, 0x20, 0x80),
            new Color(0x20, 0x20, 0xff),
            new Color(0x20, 0x40, 0x00),
            new Color(0x20, 0x40, 0x40),
            new Color(0x20, 0x40, 0x80),
            new Color(0x20, 0x40, 0xff),
            new Color(0x20, 0x60, 0x00),
            new Color(0x20, 0x60, 0x40),
            new Color(0x20, 0x60, 0x80),
            new Color(0x20, 0x60, 0xff),
            new Color(0x20, 0x80, 0x00),
            new Color(0x20, 0x80, 0x40),
            new Color(0x20, 0x80, 0x80),
            new Color(0x20, 0x80, 0xff),
            new Color(0x20, 0xa0, 0x00),
            new Color(0x20, 0xa0, 0x40),
            new Color(0x20, 0xa0, 0x80),
            new Color(0x20, 0xa0, 0xff),
            new Color(0x20, 0xc0, 0x00),
            new Color(0x20, 0xc0, 0x40),
            new Color(0x20, 0xc0, 0x80),
            new Color(0x20, 0xc0, 0xff),
            new Color(0x20, 0xff, 0x00),
            new Color(0x20, 0xff, 0x40),
            new Color(0x20, 0xff, 0x80),
            new Color(0x20, 0xff, 0xff),
            new Color(0x40, 0x00, 0x00),
            new Color(0x40, 0x00, 0x40),
            new Color(0x40, 0x00, 0x80),
            new Color(0x40, 0x00, 0xff),
            new Color(0x40, 0x20, 0x00),
            new Color(0x40, 0x20, 0x40),
            new Color(0x40, 0x20, 0x80),
            new Color(0x40, 0x20, 0xff),
            new Color(0x40, 0x40, 0x00),
            new Color(0x40, 0x40, 0x40),
            new Color(0x40, 0x40, 0x80),
            new Color(0x40, 0x40, 0xff),
            new Color(0x40, 0x60, 0x00),
            new Color(0x40, 0x60, 0x40),
            new Color(0x40, 0x60, 0x80),
            new Color(0x40, 0x60, 0xff),
            new Color(0x40, 0x80, 0x00),
            new Color(0x40, 0x80, 0x40),
            new Color(0x40, 0x80, 0x80),
            new Color(0x40, 0x80, 0xff),
            new Color(0x40, 0xa0, 0x00),
            new Color(0x40, 0xa0, 0x40),
            new Color(0x40, 0xa0, 0x80),
            new Color(0x40, 0xa0, 0xff),
            new Color(0x40, 0xc0, 0x00),
            new Color(0x40, 0xc0, 0x40),
            new Color(0x40, 0xc0, 0x80),
            new Color(0x40, 0xc0, 0xff),
            new Color(0x40, 0xff, 0x00),
            new Color(0x40, 0xff, 0x40),
            new Color(0x40, 0xff, 0x80),
            new Color(0x40, 0xff, 0xff),
            new Color(0x60, 0x00, 0x00),
            new Color(0x60, 0x00, 0x40),
            new Color(0x60, 0x00, 0x80),
            new Color(0x60, 0x00, 0xff),
            new Color(0x60, 0x20, 0x00),
            new Color(0x60, 0x20, 0x40),
            new Color(0x60, 0x20, 0x80),
            new Color(0x60, 0x20, 0xff),
            new Color(0x60, 0x40, 0x00),
            new Color(0x60, 0x40, 0x40),
            new Color(0x60, 0x40, 0x80),
            new Color(0x60, 0x40, 0xff),
            new Color(0x60, 0x60, 0x00),
            new Color(0x60, 0x60, 0x40),
            new Color(0x60, 0x60, 0x80),
            new Color(0x60, 0x60, 0xff),
            new Color(0x60, 0x80, 0x00),
            new Color(0x60, 0x80, 0x40),
            new Color(0x60, 0x80, 0x80),
            new Color(0x60, 0x80, 0xff),
            new Color(0x60, 0xa0, 0x00),
            new Color(0x60, 0xa0, 0x40),
            new Color(0x60, 0xa0, 0x80),
            new Color(0x60, 0xa0, 0xff),
            new Color(0x60, 0xc0, 0x00),
            new Color(0x60, 0xc0, 0x40),
            new Color(0x60, 0xc0, 0x80),
            new Color(0x60, 0xc0, 0xff),
            new Color(0x60, 0xff, 0x00),
            new Color(0x60, 0xff, 0x40),
            new Color(0x60, 0xff, 0x80),
            new Color(0x60, 0xff, 0xff),
            new Color(0x80, 0x00, 0x00),
            new Color(0x80, 0x00, 0x40),
            new Color(0x80, 0x00, 0x80),
            new Color(0x80, 0x00, 0xff),
            new Color(0x80, 0x20, 0x00),
            new Color(0x80, 0x20, 0x40),
            new Color(0x80, 0x20, 0x80),
            new Color(0x80, 0x20, 0xff),
            new Color(0x80, 0x40, 0x00),
            new Color(0x80, 0x40, 0x40),
            new Color(0x80, 0x40, 0x80),
            new Color(0x80, 0x40, 0xff),
            new Color(0x80, 0x60, 0x00),
            new Color(0x80, 0x60, 0x40),
            new Color(0x80, 0x60, 0x80),
            new Color(0x80, 0x60, 0xff),
            new Color(0x80, 0x80, 0x00),
            new Color(0x80, 0x80, 0x40),
            new Color(0x80, 0x80, 0x80),
            new Color(0x80, 0x80, 0xff),
            new Color(0x80, 0xa0, 0x00),
            new Color(0x80, 0xa0, 0x40),
            new Color(0x80, 0xa0, 0x80),
            new Color(0x80, 0xa0, 0xff),
            new Color(0x80, 0xc0, 0x00),
            new Color(0x80, 0xc0, 0x40),
            new Color(0x80, 0xc0, 0x80),
            new Color(0x80, 0xc0, 0xff),
            new Color(0x80, 0xff, 0x00),
            new Color(0x80, 0xff, 0x40),
            new Color(0x80, 0xff, 0x80),
            new Color(0x80, 0xff, 0xff),
            new Color(0xa0, 0x00, 0x00),
            new Color(0xa0, 0x00, 0x40),
            new Color(0xa0, 0x00, 0x80),
            new Color(0xa0, 0x00, 0xff),
            new Color(0xa0, 0x20, 0x00),
            new Color(0xa0, 0x20, 0x40),
            new Color(0xa0, 0x20, 0x80),
            new Color(0xa0, 0x20, 0xff),
            new Color(0xa0, 0x40, 0x00),
            new Color(0xa0, 0x40, 0x40),
            new Color(0xa0, 0x40, 0x80),
            new Color(0xa0, 0x40, 0xff),
            new Color(0xa0, 0x60, 0x00),
            new Color(0xa0, 0x60, 0x40),
            new Color(0xa0, 0x60, 0x80),
            new Color(0xa0, 0x60, 0xff),
            new Color(0xa0, 0x80, 0x00),
            new Color(0xa0, 0x80, 0x40),
            new Color(0xa0, 0x80, 0x80),
            new Color(0xa0, 0x80, 0xff),
            new Color(0xa0, 0xa0, 0x00),
            new Color(0xa0, 0xa0, 0x40),
            new Color(0xa0, 0xa0, 0x80),
            new Color(0xa0, 0xa0, 0xff),
            new Color(0xa0, 0xc0, 0x00),
            new Color(0xa0, 0xc0, 0x40),
            new Color(0xa0, 0xc0, 0x80),
            new Color(0xa0, 0xc0, 0xff),
            new Color(0xa0, 0xff, 0x00),
            new Color(0xa0, 0xff, 0x40),
            new Color(0xa0, 0xff, 0x80),
            new Color(0xa0, 0xff, 0xff),
            new Color(0xc0, 0x00, 0x00),
            new Color(0xc0, 0x00, 0x40),
            new Color(0xc0, 0x00, 0x80),
            new Color(0xc0, 0x00, 0xff),
            new Color(0xc0, 0x20, 0x00),
            new Color(0xc0, 0x20, 0x40),
            new Color(0xc0, 0x20, 0x80),
            new Color(0xc0, 0x20, 0xff),
            new Color(0xc0, 0x40, 0x00),
            new Color(0xc0, 0x40, 0x40),
            new Color(0xc0, 0x40, 0x80),
            new Color(0xc0, 0x40, 0xff),
            new Color(0xc0, 0x60, 0x00),
            new Color(0xc0, 0x60, 0x40),
            new Color(0xc0, 0x60, 0x80),
            new Color(0xc0, 0x60, 0xff),
            new Color(0xc0, 0x80, 0x00),
            new Color(0xc0, 0x80, 0x40),
            new Color(0xc0, 0x80, 0x80),
            new Color(0xc0, 0x80, 0xff),
            new Color(0xc0, 0xa0, 0x00),
            new Color(0xc0, 0xa0, 0x40),
            new Color(0xc0, 0xa0, 0x80),
            new Color(0xc0, 0xa0, 0xff),
            new Color(0xc0, 0xc0, 0x00),
            new Color(0xc0, 0xc0, 0x40),
            new Color(0xc0, 0xc0, 0x80),
            new Color(0xc0, 0xc0, 0xff),
            new Color(0xc0, 0xff, 0x00),
            new Color(0xc0, 0xff, 0x40),
            new Color(0xc0, 0xff, 0x80),
            new Color(0xc0, 0xff, 0xff),
            new Color(0xff, 0x00, 0x00),
            new Color(0xff, 0x00, 0x40),
            new Color(0xff, 0x00, 0x80),
            new Color(0xff, 0x00, 0xff),
            new Color(0xff, 0x20, 0x00),
            new Color(0xff, 0x20, 0x40),
            new Color(0xff, 0x20, 0x80),
            new Color(0xff, 0x20, 0xff),
            new Color(0xff, 0x40, 0x00),
            new Color(0xff, 0x40, 0x40),
            new Color(0xff, 0x40, 0x80),
            new Color(0xff, 0x40, 0xff),
            new Color(0xff, 0x60, 0x00),
            new Color(0xff, 0x60, 0x40),
            new Color(0xff, 0x60, 0x80),
            new Color(0xff, 0x60, 0xff),
            new Color(0xff, 0x80, 0x00),
            new Color(0xff, 0x80, 0x40),
            new Color(0xff, 0x80, 0x80),
            new Color(0xff, 0x80, 0xff),
            new Color(0xff, 0xa0, 0x00),
            new Color(0xff, 0xa0, 0x40),
            new Color(0xff, 0xa0, 0x80),
            new Color(0xff, 0xa0, 0xff),
            new Color(0xff, 0xc0, 0x00),
            new Color(0xff, 0xc0, 0x40),
            new Color(0xff, 0xc0, 0x80),
            new Color(0xff, 0xc0, 0xff),
            new Color(0xff, 0xff, 0x00),
            new Color(0xff, 0xff, 0x40),
            new Color(0xff, 0xff, 0x80),
            new Color(0xff, 0xff, 0xff)};

    /**һͼ꣬
     * Ϊ32
     * ߶Ϊ32
     * ɫΪϵͳĬ16ɫɫ壬
     * ٵλΪ(0, 0)*/
    protected MSIconData()
    {
        this(new Dimension(32, 32), DefaultPalette16, new Point(0, 0));
    }

    /**һͼ꣬
     * ȸ߶Ϊ<code>size</code>
     * ɫΪ<code>palette</code>
     * ٵλΪhotspot*/
    protected MSIconData(Dimension size, Color[] palette, Point hotspot)
    {
        if (palette != null)
        {
            if (palette.length != 2
                && palette.length != 16
                && palette.length != 256)
                throw new RuntimeException();
        }

        Width = size.width;
        Height = size.height;
        Palette = palette;
        Hotspot = hotspot;

        Image = new int[Height][Width];
        Mask = new boolean[Height][Width];

        int Black;
        if (palette != null)
            Black = Utilities.getNearestColorIndex(Palette, Color.black);
        else
            Black = 0;

        for (int y = 0; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                Image[y][x] = Black;
                Mask[y][x] = true;
            }
        }
    }

    /**ȡͼȡ*/
    public int getWidth()
    {
        return Width;
    }

    /**ͼȣõĿȡ*/
    public int setWidth(int width)
    {
        return setSize(width, getHeight()).width;
    }

    /**ȡͼ߶ȡ*/
    public int getHeight()
    {
        return Height;
    }

    /**ͼ߶ȣõĸ߶ȡ*/
    public int setHeight(int height)
    {
        return setSize(getWidth(), height).height;
    }

    /**ȡͼߴ硣*/
    public Dimension getSize()
    {
        return new Dimension(Width, Height);
    }

    /**ͼߴ硣*/
    public Dimension setSize(Dimension size)
    {
        return new Dimension(size.width, size.height);
    }

    /**ͼߴ硣*/
    public Dimension setSize(int width, int height)
    {
        Width = width;
        Height = height;

        int Black;
        if (Palette != null)
            Black = Utilities.getNearestColorIndex(Palette, Color.black);
        else
            Black = 0;

        int[][] newImage = new int[Height][Width];
        boolean[][] newMask = new boolean[Height][Width];

        int y;
        for (y = 0; y < Math.min(height, Image.length); y++)
        {
            int x;
            for (x = 0; x < Math.min(width, Image[0].length); x++)
            {
                newImage[y][x] = Image[y][x];
                newMask[y][x] = Mask[y][x];
            }

            for (; x < Width; x++)
            {
                newImage[y][x] = Black;
                newMask[y][x] = true;
            }
        }
        for (; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                newImage[y][x] = Black;
                newMask[y][x] = true;
            }
        }

        Image = newImage;
        Mask = newMask;

        return new Dimension(Width, Height);
    }

    /**ȡͼٵλá*/
    public Point getHotspot()
    {
        return Hotspot;
    }

    /**ͼٵλá*/
    public Point setHotspot(int x, int y)
    {
        Hotspot.x = x;
        Hotspot.y = y;
        return Hotspot;
    }

    /**ͼٵλá*/
    public Point setHotspot(Point hotspot)
    {
        return Hotspot = hotspot;
    }

    /**ȡɫ<code>index-1</code>ɫ
     * ɫڣ򷵻<code>null</code>*/
    public Color getPaletteColor(int index)
    {
        if (Palette == null)
            return null;

        if (index >= 0 && index < Palette.length)
            return Palette[index];
        else
            return null;
    }

    /**õɫ<code>index-1</code>ɫ
     * úõɫֵ
     * ɫųΧ򷵻<code>null</code>*/
    public Color setPaletteColor(int index, Color color)
    {
        if (Palette == null)
            return null;

        //޸ĵĵɫΪĬϵɫ壬
        //ΪĬϵɫ崴һݸ
        if (Palette == DefaultPalette2
            || Palette == DefaultPalette16
            || Palette == DefaultPalette256)
        {
            Color[] newPalette = new Color[Palette.length];
            System.arraycopy(Palette, 0, newPalette, 0, Palette.length);
            Palette = newPalette;
        }

        if (color != null && index >= 0 && index < Palette.length)
        {
            Color oldColor = new Color(Palette[index].getRGB());
            Palette[index] = color;
            int NearestIndex =
                Utilities.getNearestColorIndex(Palette, oldColor);

            for (int y = 0; y < Height; y++)
            {
                for (int x = 0; x < Width; x++)
                {
                    if (Image[y][x] == index)
                        Image[y][x] = NearestIndex;
                }
            }

            return Palette[index] = color;
        }
        else
            return null;
    }

    /**ѯɫɫĿ*/
    public int getPaletteSize()
    {
        if (Palette == null)
            return 16777216;

        return Palette.length;
    }

    /**Żɫ壬ɫĿ*/
    private int optimizePalette(int n)
    {
        Color[] newPalette = new Color[n];
        ArrayList Colors = new ArrayList();
        ArrayList Counts = new ArrayList();

        for (int y = 0; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                int i;
                for (i = 0; i < Colors.size(); i++)
                {
                    if (((Color) (Colors.get(i))).getRGB()
                        == getColorAt(x, y).getRGB())
                    {
                        Counts.set(
                            i,
                            new Integer(
                                ((Integer) (Counts.get(i))).intValue() + 1));
                        break;
                    }
                }

                if (i == Colors.size())
                {
                    Colors.add(new Color(getColorAt(x, y).getRGB()));
                    Counts.add(new Integer(1));
                }
            }
        }

        int i;

        for (i = 0; i < Math.min(n, Colors.size()); i++)
        {
            int maxCount = -1;
            int maxIndex = -1;

            for (int j = 0; j < Colors.size(); j++)
            {
                int cCount = ((Integer) (Counts.get(j))).intValue();
                if (cCount > maxCount)
                {
                    maxCount = cCount;
                    maxIndex = j;
                }
            }

            Counts.set(maxIndex, new Integer(-1));
            newPalette[i] =
                new Color(((Color) (Colors.get(maxIndex))).getRGB());
        }

        for (; i < n; i++)
        {
            switch (n)
            {
                case 16 :
                    newPalette[i] = new Color(DefaultPalette16[i].getRGB());
                    break;
                case 256 :
                    newPalette[i] = new Color(DefaultPalette256[i].getRGB());
                    break;
            }
        }

        setPalette(newPalette);
        return newPalette.length;
    }

    /** ȡͼʵõɫ*/
    public int getColorsCount()
    {
        ArrayList Colors = new ArrayList();

        for (int y = 0; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                int i;
                for (i = 0; i < Colors.size(); i++)
                {
                    if (((Color) (Colors.get(i))).getRGB()
                        == getColorAt(x, y).getRGB())
                        break;
                }

                if (i == Colors.size())
                    Colors.add(new Color(getColorAt(x, y).getRGB()));
            }
        }
        return Colors.size();
    }

    /** ɫɫĿΪ<code>n</code>*/
    public int setPaletteSize(int n)
    {
        if (n != 2 && n != 16 && n != 256 && n != 16777216)
            return getPaletteSize();

        if (n == getPaletteSize())
            return getPaletteSize();

        if (n == 16777216)
        {
            for (int y = 0; y < Height; y++)
                for (int x = 0; x < Width; x++)
                    Image[y][x] = getColorAt(x, y).getRGB();

            Palette = null;
        }
        else
        {
            if (getPaletteSize() < n)
            {
                Color[] newPalette = new Color[n];
                int i;
                for (i = 0; i < Palette.length; i++)
                    newPalette[i] = new Color(Palette[i].getRGB());

                for (; i < n; i++)
                {
                    switch (n)
                    {
                        case 16 :
                            newPalette[i] =
                                new Color(DefaultPalette16[i].getRGB());
                            break;
                        case 256 :
                            newPalette[i] =
                                new Color(DefaultPalette256[i].getRGB());
                            break;
                    }
                }
                Palette = newPalette;
            }
            else
                optimizePalette(n);
        }

        System.gc();
        return getPaletteSize();
    }

    /**ȡɫš
     * úָɫţ
     * ɫڵɫеıš
     * ָ겻ͼΧڣ
     * 򷵻-1*/
    public int getPixelAt(Point position)
    {
        return getPixelAt(position.x, position.y);
    }

    /**ȡɫš
     * ú(x, y)ɫţ
     * ɫڵɫеıš
     * ָ겻ͼΧڣ
     * 򷵻-1*/
    public int getPixelAt(int x, int y)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Image[y][x];
        else
            return -1;
    }

    /**ɫš
     * úָɫΪֵָ
     * ɹúָɫš
     * ָ겻ͼΧڣ
     * ߸ɫųΧ
     * 򷵻-1*/
    public int setPixelAt(Point position, int index)
    {
        return setPixelAt(position.x, position.y, index);
    }

    /**ɫš
     * ú(x, y)ɫΪֵָ
     * ɹúָɫš
     * ָ겻ͼΧڣ
     * ߸ɫųΧ
     * 򷵻-1*/
    public int setPixelAt(int x, int y, int index)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
        {
            if (index >= 0 && index < getPaletteSize())
                return Image[y][x] = index;
            else
                return -1;
        }
        else
            return -1;
    }

    /**õɫ塣*/
    public boolean setPalette(Color[] newPalette)
    {
        if (newPalette != null)
        {
            if (newPalette.length != 2
                && newPalette.length != 16
                && newPalette.length != 256)
                return false;
        }
        for (int y = 0; y < Height; y++)
        {
            for (int x = 0; x < Width; x++)
            {
                if (newPalette != null)
                    Image[y][x] =
                        Utilities.getNearestColorIndex(
                            newPalette,
                            getColorAt(x, y));
                else
                    Image[y][x] = getColorAt(x, y).getRGB();
            }
        }

        Palette = newPalette;
        System.gc();
        return true;
    }

    /**ѯָǷ͸
     * õ͸򷵻<code>true</code>
     * ͸
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean getMaskAt(Point position)
    {
        return getMaskAt(position.x, position.y);
    }

    /**ѯָǷ͸
     * õ͸򷵻<code>true</code>
     * ͸
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean getMaskAt(int x, int y)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Mask[y][x];
        else
            return false;
    }

    /**ָǷ͸
     * ú(x, y)͸״̬Ϊֵָ
     * ɹúָ͸״̬
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean setMaskAt(Point position, boolean mask)
    {
        return setMaskAt(position.x, position.y, mask);
    }

    /**ָǷ͸
     * ú(x, y)͸״̬Ϊֵָ
     * ɹúָ͸״̬
     * ָ겻ͼΧڣ
     * 򷵻<code>false</code>*/
    public boolean setMaskAt(int x, int y, boolean mask)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
            return Mask[y][x] = mask;
        else
            return false;
    }

    /**ȡָɫ
     * ɹúָɫ
     * ָ겻ͼΧڣ
     * 򷵻<code>null</code>*/
    public Color getColorAt(Point position)
    {
        return getColorAt(position.x, position.y);
    }

    /**ȡָɫ
     * ɹúָɫ
     * ָ겻ͼΧڣ
     * 򷵻<code>null</code>*/
    public Color getColorAt(int x, int y)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
        {
            if (Palette != null)
                return Palette[Image[y][x]];
            else
                return new Color(Image[y][x]);
        }
        else
            return null;
    }

    /**ָɫ
     * úָɫΪֵָ
     * ɫûиɫ
     * ʹһɫ
     * ɹúָɫš
     * ָ겻ͼΧڣ
     * ߸ɫųΧ
     * 򷵻-1*/
    public int setColorAt(Point position, Color color)
    {
        return setColorAt(position.x, position.y, color);
    }

    /**ָɫ
     * úָɫΪֵָ
     * ɫûиɫ
     * ʹһɫ
     * ɹúָɫš
     * ָ겻ͼΧڣ
     * ߸ɫųΧ
     * 򷵻-1*/
    public int setColorAt(int x, int y, Color color)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
        {
            if (Palette != null)
                return Image[y][x] =
                    Utilities.getNearestColorIndex(Palette, color);
            else
                return Image[y][x] = color.getRGB();
        }
        else
            return -1;
    }

    /**ȡָ뱳Ϻɫ
     * õ͸úָıɫ
     * õ㲻͸úظõɫ
     * ָ겻ͼΧڣ
     * ú<code>null</code>*/
    public Color mixColorAt(Point position, Color color)
    {
        return mixColorAt(position.x, position.y, color);
    }

    /**ȡָ뱳Ϻɫ
     * õ͸úظõָıɫ
     * ɫ
     * õ㲻͸úظõɫ
     * ָ겻ͼΧڣ
     * ú<code>null</code>*/
    public Color mixColorAt(int x, int y, Color color)
    {
        if (x >= 0 && x < Width && y >= 0 && y < Height)
        {
            if (Mask[y][x])
            {
                if (Palette != null)
                    return new Color(
                        color.getRGB() ^ Palette[Image[y][x]].getRGB());
                else
                    return new Color(color.getRGB() ^ Image[y][x]);
            }
            else
            {
                if (Palette != null)
                    return Palette[Image[y][x]];
                else
                    return new Color(Image[y][x]);
            }
        }
        else
            return null;
    }

    /**ͼ뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    protected boolean flowHeadIn(DataInputStream dis)
    {
        try
        {
            Width = dis.readUnsignedByte();
            Height = dis.readUnsignedByte();
            dis.skipBytes(2);
            Hotspot.x = Utilities.readShort(dis);
            Hotspot.y = Utilities.readShort(dis);
            dis.skipBytes(8);

            setSize(Width, Height);

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**2ɫͼƬݿ뵽ڴС*/
    private void flowImage2In(DataInputStream dis) throws IOException
    {
        for (int i = Height - 1; i >= 0; i--)
        {
            for (int j = 0; j < Width / 8.0; j++)
            {

                int AColor = dis.readUnsignedByte();

                for (int k = 0; k < 8; k++)
                {
                    if (j * 8 + k < Width)
                    {
                        if (AColor >= 1 << (7 - k))
                        {
                            Image[i][j * 8 + k] = 1;
                            AColor -= 1 << (7 - k);
                        }
                        else
                            Image[i][j * 8 + k] = 0;
                    }
                }
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 8.0 + 0.9)) % 4 != 0)
                dis.skipBytes(4 - ((int) (Width / 8.0 + 0.9)) % 4);
        }
    }

    /**16ɫͼƬݿ뵽ڴС*/
    private void flowImage16In(DataInputStream dis) throws IOException
    {
        for (int m = Height - 1; m >= 0; m--)
        {
            for (int n = 0; n < Width; n += 2)
            {
                int cByte;
                int High, Low;

                cByte = dis.readUnsignedByte();

                Low = cByte % 16;
                High = cByte / 16;

                Image[m][n] = High;
                if (n + 1 < Width)
                    Image[m][n + 1] = Low;
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 2.0 + 0.9)) % 4 != 0)
                dis.skipBytes(4 - ((int) (Width / 2.0 + 0.9)) % 4);
        }
    }

    /**256ɫͼƬݿ뵽ڴС*/
    private void flowImage256In(DataInputStream dis) throws IOException
    {
        for (int m = Height - 1; m >= 0; m--)
        {
            for (int n = 0; n < Width; n++)
                Image[m][n] = dis.readUnsignedByte();

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (Width % 4 != 0)
                dis.skipBytes(4 - Width % 4);
        }
    }

    /**ɫͼƬݿ뵽ڴС*/
    private void flowImage16777216In(DataInputStream dis) throws IOException
    {
        for (int y = Height - 1; y >= 0; y--)
        {
            for (int x = 0; x < Width; x++)
            {
                Image[y][x] = dis.readUnsignedByte();
                Image[y][x] += dis.readUnsignedByte() * 0x100;
                Image[y][x] += dis.readUnsignedByte() * 0x10000;
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            dis.skipBytes(Width % 4);
        }
    }

    /**ݿ뵽ڴС*/
    private void flowMaskIn(DataInputStream dis) throws IOException
    {
        for (int i = Height - 1; i >= 0; i--)
        {
            for (int j = 0; j < Width / 8.0; j++)
            {

                int AColor = dis.readUnsignedByte();

                for (int k = 0; k < 8; k++)
                {
                    if (j * 8 + k < Width)
                    {
                        if (AColor >= 1 << (7 - k))
                        {
                            Mask[i][j * 8 + k] = true;
                            AColor -= 1 << (7 - k);
                        }
                        else
                            Mask[i][j * 8 + k] = false;
                    }
                }
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 8.0 + 0.9)) % 4 != 0)
                dis.skipBytes(4 - ((int) (Width / 8.0 + 0.9)) % 4);
        }
    }

    /**ͼݿ뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    protected boolean flowDataIn(DataInputStream dis)
    {
        try
        {
            dis.skipBytes(14);
            int bits = Utilities.readShort(dis);
            dis.skipBytes(24);

            if (bits != 24)
            {
                Palette = new Color[1 << bits];
                for (int i = 0; i < Palette.length; i++)
                {
                    int BlueValue = dis.readUnsignedByte();
                    int GreenValue = dis.readUnsignedByte();
                    int RedValue = dis.readUnsignedByte();
                    dis.skipBytes(1);

                    Palette[i] = new Color(RedValue, GreenValue, BlueValue);
                }
            }
            else
                Palette = null;

            switch (bits)
            {
                case 1 :
                    flowImage2In(dis);
                    break;
                case 4 :
                    flowImage16In(dis);
                    break;
                case 8 :
                    flowImage256In(dis);
                    break;
                case 24 :
                    flowImage16777216In(dis);
                    break;
                default :
                    throw new Exception();
            }

            flowMaskIn(dis);

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ͼָص㡣
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    protected boolean flowHeadOut(
        DataOutputStream dos,
        int DataSize,
        int DataPosition)
    {
        try
        {
            dos.writeByte(Width);
            dos.writeByte(Height);

            if (getPaletteSize() >= 256)
                dos.writeShort(0);
            else
                Utilities.writeShort(Palette.length, dos);

            Utilities.writeShort(Hotspot.x, dos);
            Utilities.writeShort(Hotspot.y, dos);
            Utilities.writeInt(DataSize, dos);
            Utilities.writeInt(DataPosition, dos);
            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**2ɫͼƬݿָص㡣*/
    private void flowImage2Out(DataOutputStream dos) throws IOException
    {
        for (int i = Height - 1; i >= 0; i--)
        {
            for (int j = 0; j < (int) (Width / 8.0 + 0.9); j++)
            {
                int AColor;
                AColor = 0;

                for (int k = 0; k < 8; k++)
                {
                    if (j * 8 + k < Width)
                        AColor += Image[i][j * 8 + k] * (1 << (7 - k));
                }

                dos.writeByte(AColor);
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 8.0 + 0.9)) % 4 != 0)
            {
                for (int n = 0; n < 4 - ((int) (Width / 8.0 + 0.9)) % 4; n++)
                    dos.writeByte(0);
            }
        }
    }

    /**16ɫͼƬݿָص㡣*/
    private void flowImage16Out(DataOutputStream dos) throws IOException
    {
        for (int m = Height - 1; m >= 0; m--)
        {
            for (int n = 0; n < Width; n += 2)
            {
                int High, Low;

                High = Image[m][n];
                if (n + 1 < Width)
                    Low = Image[m][n + 1];
                else
                    Low = 0;

                dos.writeByte(High * 16 + Low);
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 2.0 + 0.9)) % 4 != 0)
            {
                for (int i = 0; i < 4 - ((int) (Width / 2.0 + 0.9)) % 4; i++)
                    dos.writeByte(0);
            }
        }
    }

    /**256ɫͼƬݿָص㡣*/
    private void flowImage256Out(DataOutputStream dos) throws IOException
    {
        for (int m = Height - 1; m >= 0; m--)
        {
            for (int n = 0; n < Width; n++)
                dos.writeByte(Image[m][n]);

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (Width % 4 != 0)
            {
                for (int i = 0; i < 4 - Width % 4; i++)
                    dos.writeByte(0);
            }
        }
    }

    /**ɫͼƬݿָص㡣*/
    private void flowImage16777216Out(DataOutputStream dos) throws IOException
    {
        for (int y = Height - 1; y >= 0; y--)
        {
            for (int x = 0; x < Width; x++)
            {
                dos.writeByte(Image[y][x] & 0xff);
                dos.writeByte((Image[y][x] & 0xff00) / 0x100);
                dos.writeByte((Image[y][x] & 0xff0000) / 0x10000);
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            for (int n = 0; n < Width % 4; n++)
                dos.writeByte(0);
        }
    }

    /**ݿ뵽ڴС*/
    private void flowMaskOut(DataOutputStream dos) throws IOException
    {
        for (int i = Height - 1; i >= 0; i--)
        {
            for (int j = 0; j < (int) (Width / 8.0 + 0.9); j++)
            {
                int AColor = 0;

                for (int k = 0; k < 8; k++)
                {
                    if (j * 8 + k < Width)
                    {
                        if (Mask[i][j * 8 + k])
                            AColor += (1 << (7 - k));
                    }
                }

                dos.writeByte(AColor);
            }

            //BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
            //дʱҪųЧ
            if (((int) (Width / 8.0 + 0.9)) % 4 != 0)
            {
                for (int n = 0; n < 4 - ((int) (Width / 8.0 + 0.9)) % 4; n++)
                    dos.writeByte(0);
            }
        }
    }

    /**ͼݿָص㡣
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    protected boolean flowDataOut(DataOutputStream dos)
    {
        try
        {
            Utilities.writeInt(40, dos);
            Utilities.writeInt(Width, dos);
            Utilities.writeInt(Height * 2, dos);
            Utilities.writeShort(1, dos);

            int bits = (int) (Math.log(getPaletteSize()) / Math.log(2));
            Utilities.writeShort(bits, dos);
            dos.writeInt(0);
            Utilities.writeInt(getImageDataSize(), dos);
            dos.writeLong(0);
            dos.writeLong(0);

            if (bits != 24)
            {
                for (int i = 0; i < Palette.length; i++)
                {
                    int BlueValue = Palette[i].getBlue();
                    int GreenValue = Palette[i].getGreen();
                    int RedValue = Palette[i].getRed();

                    dos.writeByte(BlueValue);
                    dos.writeByte(GreenValue);
                    dos.writeByte(RedValue);
                    dos.writeByte(0);
                }
            }

            switch (bits)
            {
                case 1 :
                    flowImage2Out(dos);
                    break;
                case 4 :
                    flowImage16Out(dos);
                    break;
                case 8 :
                    flowImage256Out(dos);
                    break;
                case 24 :
                    flowImage16777216Out(dos);
                    break;
                default :
                    throw new Exception();
            }

            flowMaskOut(dos);

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ȡͼƬĴС*/
    private int getImageDataSize()
    {
        int bits;
        if (Palette == null)
            bits = 24;
        else
            bits = (int) (Math.log(Palette.length) / Math.log(2));

        int dataWidth = (int) (Width * bits / 8.0 + 0.99);

        if (dataWidth % 4 != 0)
            dataWidth += 4 - (dataWidth % 4);
        int DataSize = dataWidth * Height;
        return DataSize;
    }

    /**ȡͼС*/
    protected int getIconDataSize()
    {
        int DataSize = getImageDataSize();
        int maskWidth = (int) (Width / 8.0 + 0.99);
        if (maskWidth % 4 != 0)
            maskWidth += 4 - (maskWidth % 4);
        int MaskSize = maskWidth * Height;

        int PaletteSize;
        switch (getPaletteSize())
        {
            case 2 :
                PaletteSize = 8;
                break;
            case 16 :
                PaletteSize = 64;
                break;
            case 256 :
                PaletteSize = 1024;
                break;
            case 16777216 :
                PaletteSize = 0;
                break;
            default :
                return -1;
        }

        return PaletteSize + DataSize + MaskSize;
    }
}
