package msicon;

import java.awt.*;
import java.io.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼʵù߼</p>*/

public class Utilities
{
    /**öʵ*/
    private Utilities()
    {}

    /**ȡɫš
     * ָĵɫָɫӽɫ
     * ظɫڵɫеλá*/
    public static int getNearestColorIndex(Color[] palette, Color color)
    {
        int minDiffer = 300000000;
        int minIndex = 0;

        for (int i = 0; i < palette.length; i++)
        {
            int rDiffer = palette[i].getRed() - color.getRed();
            int gDiffer = palette[i].getGreen() - color.getGreen();
            int bDiffer = palette[i].getBlue() - color.getBlue();

            int Differ =
                1089 * rDiffer * rDiffer
                    + 3025 * gDiffer * gDiffer
                    + 144 * bDiffer * bDiffer;

            if (Differ <= minDiffer)
            {
                minDiffer = Differ;
                minIndex = i;
            }
        }

        return minIndex;
    }

    /**ȡɫ
     * ָĵɫָɫӽɫ*/
    public static Color getNearestColor(Color[] palette, Color color)
    {
        return palette[getNearestColorIndex(palette, color)];
    }

    /**ʽļжһΡ*/
    public static int readShort(DataInputStream dis) throws IOException
    {
        int data = readUShort(dis);
        if (data > 0x7fff)
            data -= 0x10000;
        return data;
    }

    /**ʽļжһ޷ŶΡ*/
    public static int readUShort(DataInputStream dis) throws IOException
    {
        int data = dis.readUnsignedByte();
        data += dis.readUnsignedByte() * 0x100;
        return data;
    }

    /**ʽļжһΡ*/
    public static int readInt(DataInputStream dis) throws IOException
    {
        long data = readUInt(dis);
        if (data > 0x7fffffff)
            data -= 0x100000000L;
        return (int) data;
    }

    /**ʽļжһ޷Ρ*/
    public static long readUInt(DataInputStream dis) throws IOException
    {
        int data = readUShort(dis);
        data += readUShort(dis) * 0x10000;
        return data;
    }

    /**ʽļжһΡ*/
    public static long readLong(DataInputStream dis) throws IOException
    {
        long data = readUInt(dis);
        data += dis.readUnsignedByte() * 0x10000;

        int hibyte = dis.readByte();

        if (hibyte > 0)
            data += dis.readByte() * 0x1000000;
        else
        {
            data += (dis.readUnsignedByte() % 127) * 0x1000000;
            data = ~data + 1;
        }

        return data;
    }

    /**һΪnַ*/
    public static String readString(int n, DataInputStream dis)
        throws IOException
    {
        byte[] buffer = new byte[n];
        dis.read(buffer);
        return new String(buffer);
    }

    /**ʽļдһΡ*/
    public static void writeShort(int data, DataOutputStream dos)
        throws IOException
    {
        if (data < 0)
            data += 0x10000;
        writeUShort(data, dos);
    }

    /**ʽļдһ޷ŶΡ*/
    public static void writeUShort(int data, DataOutputStream dos)
        throws IOException
    {
        dos.writeByte(data % 0x100);
        dos.writeByte(data / 0x100);
    }

    /**ʽļдһΡ*/
    public static void writeInt(int data, DataOutputStream dos)
        throws IOException
    {
        if (data > 0)
            writeUInt(data, dos);
        else
            writeUInt(data + 0x100000000L, dos);
    }

    /**ʽļдһ޷Ρ*/
    public static void writeUInt(long data, DataOutputStream dos)
        throws IOException
    {
        writeUShort((int) (data % 0x10000), dos);
        writeUShort((int) (data / 0x10000), dos);
    }

    /**ʽļдһΡ*/
    public static void writeLong(long data, DataOutputStream dos)
        throws IOException
    {
        if (data > 0)
        {
            writeUInt(data % 0x100000000L, dos);
            writeUInt(data / 0x100000000L, dos);
        }
        else
        {
            data = Math.abs(data);
            long lowDWord = - (data % 0x100000000L);
            long highDWord = - (data / 0x100000000L);

            lowDWord += 0x100000000L;
            highDWord += 0xffffffffL;

            writeUInt(lowDWord, dos);
            writeUInt(highDWord, dos);
        }
    }

    /**ȥַβ0*/
    public static String fixString(String toFix)
    {
        if (toFix.indexOf(0) != -1)
            return toFix.substring(0, toFix.indexOf(0));
        else
            return toFix;
    }
}
