package tinyPainter.dialog;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * Ի
 * @author gameboy<p>
 * Created on 2002-12-3
 */
public class TPFontDialog extends TPDialog
{
    private static String[] fontFamilyNames =
        GraphicsEnvironment
            .getLocalGraphicsEnvironment()
            .getAvailableFontFamilyNames();
    private static int[] fontSizes =
        { 5, 6, 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 64 };
    private JComboBox jcbFontFamily;
    private JComboBox jcbFontSize;
    private JToggleButton jtbBold;
    private JToggleButton jtbItalic;
    private JTextField jtfText;
    private Font selectedFont;
    private void setTextFont()
    {
        String fontFamilyName =
            fontFamilyNames[jcbFontFamily.getSelectedIndex()];
        int fontSize = fontSizes[jcbFontSize.getSelectedIndex()];
        int fontStyle = Font.PLAIN;
        if (jtbBold.isSelected())
        {
            fontStyle += Font.BOLD;
        }
        if (jtbItalic.isSelected())
        {
            fontStyle += Font.ITALIC;
        }
        selectedFont = new Font(fontFamilyName, fontStyle, fontSize);
        repaint();
    }
    /**
     * ȡѡ
     * @return ѡ
     */
    public Font getSelectedFont()
    {
        return selectedFont;
    }
    /**
     * ȡı
     * @return ı
     */
    public String getInputText()
    {
        return jtfText.getText();
    }
    /**
     * Ի
     * @param 
     */
    public TPFontDialog(Frame parent)
    {
        super(parent);
        setTitle(Resource.FontDialogTitle);
        setDefaultCloseOperation(HIDE_ON_CLOSE);
        ActionListener al = new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                setTextFont();
            }
        };
        JPanel fontPanel = new JPanel();
        JPanel buttonPanel = new JPanel();
        jcbFontFamily = new JComboBox(fontFamilyNames);
        jcbFontFamily.setMaximumRowCount(3);
        jcbFontFamily.setMaximumSize(new Dimension(200, 30));
        jcbFontSize = new JComboBox();
        for (int i = 0; i < fontSizes.length; i++)
        {
            jcbFontSize.addItem("" + fontSizes[i]);
        }
        jcbFontSize.setMaximumRowCount(5);
        jcbFontSize.setMaximumSize(new Dimension(50, 30));
        jtbBold = new JToggleButton(Resource.FontStyleBold);
        jtbItalic = new JToggleButton(Resource.FontStyleItalic);
        jtfText = new JTextField(12);
        setTextFont();
        JPanel previewPanel = new JPanel()
        {
            protected void paintComponent(Graphics g)
            {
                super.paintComponent(g);
                g.setFont(selectedFont);
                g.drawString(jtfText.getText(), 20, getHeight() / 2);
            }
        };
        previewPanel.setBackground(Color.white);
        previewPanel.setPreferredSize(new Dimension(200, 100));
        jcbFontFamily.addActionListener(al);
        jcbFontSize.addActionListener(al);
        jtbBold.addActionListener(al);
        jtbItalic.addActionListener(al);
        jtfText.addActionListener(al);
        jtfText.addCaretListener(new CaretListener()
        {
            public void caretUpdate(CaretEvent arg0)
            {
                repaint();
            }
        });
        fontPanel.add(jcbFontFamily);
        fontPanel.add(jcbFontSize);
        fontPanel.add(jtbBold);
        fontPanel.add(jtbItalic);
        fontPanel.add(jtfText);
        buttonPanel.add(jbOK);
        buttonPanel.add(jbCancel);
        getContentPane().add("North", fontPanel);
        getContentPane().add("Center", previewPanel);
        getContentPane().add("South", buttonPanel);
        //setSize(500, 200);
        pack();
        setResizable(false);
    }

}
